package com.example.juanalonsoastruga.cargascontrol.CapaTransversal;

import java.io.Serializable;

/**
 * Clase DTOCombustible, representa el conjunto de información requerido dentro de la aplicación para un combustible.
 *
 */
public class DTOCombustible implements Serializable {

    private int id;
    private String tipo;
    private String unidades;

    /**
     * Constructor de clase.
     *
     * @param id    un int con el id del combustible
     * @param tipo  un String con el tipo asociadao al combustible
     * @param unidades  un String con las unidades de medición del combustible
     */
    public DTOCombustible(int id, String tipo, String unidades) {
        this.id = id;
        this.tipo = tipo;
        this.unidades = unidades;
    }

    /**
     * Metodo getId, devuelve el id asociado al combustible.
     *
     * @return  un int con el id del combustible
     */
    public int getId() {
        return id;
    }


    /**
     * Metodo getTipo, devuelve el tipo de combustible.
     *
     * @return  Un String con el tipo de combustible
     */
    public String getTipo() {
        return tipo;
    }

    /**
     * Metodo setTipo, establece el tipo del combustible.
     *
     * @param tipo  Un String con el tipo del combustible
     */
    public void setTipo(String tipo) {
        this.tipo = tipo;
    }

    /**
     * Metodo getUnidades, devuelve las unidades de medicion del combustible.
     *
     * @return  Un String con las unidades de medicion
     */
    public String getUnidades() {
        return unidades;
    }

    /**
     * Metodo setUnidades, establece las unidades de medición del combustible.
     *
     * @param unidades  Un String con unidades.
     */
    public void setUnidades(String unidades) {
        this.unidades = unidades;
    }
}
