package com.example.juanalonsoastruga.cargascontrol.CapaTransversal;

import java.io.Serializable;

/**
 * Clase DTODatosDerivadosCombustible, representa el conjunto de datos derivados  obtenidos
 * en las recargas de un combustible de un vehiculo.
 *
 */
public class DTODatosDerivadosCombustible implements Serializable {


    private String matriculaVehiculo;

    private Integer mes;

    private Integer anio;

    private String combustible;
    /* *************Numero Recargas******************* */
    private Integer numeroRecargasCombustiblePorMes;

    private Integer numeroRecargasCombustiblePorAnio;
    /* *************Combustible Recargado************* */
    private Double sumaCombustibleRecargadoPorMes;

    private Double sumaCombustibleRecargadoPorAnio;

    private Double maximoCombustibleMensualRecargado;

    private Double minimoCombustibleMensualRecargado;

    private Double mediaCombustibleMensualRecargado;

    private Double maximoCombustibleAnualRecargado;

    private Double minimoCombustibleAnualRecargado;

    private Double mediaCombustibleAnualRecargado;
    /* *************Combustible / Km *********** */
    private Double sumaCombustibleXKmMensual;

    private Double sumaCombustibleXKmAnual;

    private Double minimoCombustibleXKmMensual;

    private Double minimoCombustibleXKmAnual;

    private Double mediaCombustibleXKmMensual;

    private Double maximoCombustibleXKmMensual;

    private Double maximoCombustibleXKmAnual;

    private Double mediaCombustibleXKmAnual;

    /**
     * Constructor de clase vacia para mayor comodidad a la hora del manejo.
     *
     */
    public DTODatosDerivadosCombustible(){

    }

    /**
     * Cosntructor de clase.
     *
     * @param matriculaVehiculo Un String con la matricula del vehiculo
     * @param anio  Un Integer con el anio asociado
     * @param mes   Un Integer con el mes asociado
     * @param combustible   Un String con el combustible asociado
     */
    public DTODatosDerivadosCombustible(String matriculaVehiculo, Integer anio, Integer mes, String combustible){
        this.matriculaVehiculo=matriculaVehiculo;
        this.mes=mes;
        this.anio=anio;
        this.combustible=combustible;
    }


    /**
     * Metodo getmatriculaVehiculo, devuelve la matricula del vehiculo.
     *
     * @return  String con la matricula del vehiculo
     */
    public String getMatriculaVehiculo() {
        return matriculaVehiculo;
    }
    /**
     * Metodo setmatriculaVehiculo, establece la matricula del vehiculo.
     *
     * @param matriculaVehiculo String con la matricula del vehiculo
     */
    public void setMatriculaVehiculo(String matriculaVehiculo) {
        this.matriculaVehiculo = matriculaVehiculo;
    }

    /**
     * Metodo getMes, devuelve el mes asociado.
     *
     * @return  Un Integer con el mes
     */
    public Integer getMes() {
        return mes;
    }

    /**
     * Metodo setMes, establece el mes asociado.
     *
     * @param mes Un Integer con el mes
     */
    public void setMes(Integer mes) {
        this.mes = mes;
    }

    /**
     * Metodo getAnio, devuelve el anio asociado.
     *
     * @return  Un Integer con el anio
     */
    public Integer getAnio() {
        return anio;
    }

    /**
     * Metodo setAnio, establece el anio asociado.
     *
     * @param anio Un Integer con el anio
     */
    public void setAnio(Integer anio) {
        this.anio = anio;
    }

    /**
     * Metodo getCombustible, devuelve el combustible asociado al conjunto de datos.
     *
     * @return   Un String con el tipo de combustible
     */
    public String getCombustible() {
        return combustible;
    }

    /**
     * Metodo setCombustible, establece el combustible asociado al conjunto de datos.
     *
     * @param combustible   Un String con el tipo de combustible
     */
    public void setCombustible(String combustible) {
        this.combustible = combustible;
    }

    /**
     * Metodo getNumeroRecargasCombustiblePorMes, devuelve el numero de recargas del combustible producidas en el mes actual.
     *
     * @return Integer con dicho numero
     */
    public Integer getNumeroRecargasCombustiblePorMes() {
        return numeroRecargasCombustiblePorMes;
    }
    /**
     * Metodo setNumeroRecargasCombustiblePorMes, establece el numero de recargas del combustible producidas en el mes actual.
     *
     * @param numeroRecargasCombustiblePorMes Integer con dicho numero
     */
    public void setNumeroRecargasCombustiblePorMes(Integer numeroRecargasCombustiblePorMes) {
        this.numeroRecargasCombustiblePorMes = numeroRecargasCombustiblePorMes;
    }

    /**
     * Metodo getNumeroRecargasCombustibleporAnio, devuelve el numero de recargas del combustible producidas en el anio actual.
     *
     * @return Integer con dicho numero
     */
    public Integer getNumeroRecargasCombustiblePorAnio() {
        return numeroRecargasCombustiblePorAnio;
    }

    /**
     * Metodo getNumeroRecargasCombustibleporAnio, establece el numero de recargas del combustible producidas en el anio actual.
     *
     * @param numeroRecargasCombustiblePorAnio Integer con dicho numero
     */
    public void setNumeroRecargasCombustiblePorAnio(Integer numeroRecargasCombustiblePorAnio) {
        this.numeroRecargasCombustiblePorAnio = numeroRecargasCombustiblePorAnio;
    }

    /**
     * Metodo getSumaCombustibleRecargadoPorMes, devuelve la suma de cantidad de combustible recargado en el mes.
     *
     * @return  Un Double con la suma
     */
    public Double getSumaCombustibleRecargadoPorMes() {
        return sumaCombustibleRecargadoPorMes;
    }

    /**
     * Metodo setSumaCombustibleRecargadoPorMes, establece la suma de cantidad de combustible recargado en el mes.
     *
     * @param  sumaCombustibleRecargadoPorMes Un Double con la suma
     */
    public void setSumaCombustibleRecargadoPorMes(Double sumaCombustibleRecargadoPorMes) {
        this.sumaCombustibleRecargadoPorMes = sumaCombustibleRecargadoPorMes;
    }

    /**
     * Metodo getSumaCombustibleRecargadoPorAnio, devuelve la suma de cantidad de combustible recargado en el anio.
     *
     * @return  Un Double con la suma
     */
    public Double getSumaCombustibleRecargadoPorAnio() {
        return sumaCombustibleRecargadoPorAnio;
    }

    /**
     * Metodo setSumaCombustibleRecargadoPorAnio, establece la suma de cantidad de combustible recargado en el anio.
     *
     * @param  sumaCombustibleRecargadoPorAnio Un Double con la suma
     */
    public void setSumaCombustibleRecargadoPorAnio(Double sumaCombustibleRecargadoPorAnio) {
        this.sumaCombustibleRecargadoPorAnio = sumaCombustibleRecargadoPorAnio;
    }

    /**
     * Metodo getMaximoCombustibleMensualRecargado, devuelve la maxima cantidad de combustible recargada en el mes.
     *
     * @return Un Double con la cantidad
     */
    public Double getMaximoCombustibleMensualRecargado() {
        return maximoCombustibleMensualRecargado;
    }
    /**
     * Metodo setMaximoCombustibleMensualRecargado, establece la maxima cantidad de combustible recargada en el mes.
     *
     * @param maximoCombustibleMensualRecargado Un Double con la cantidad
     */
    public void setMaximoCombustibleMensualRecargado(Double maximoCombustibleMensualRecargado) {
        this.maximoCombustibleMensualRecargado = maximoCombustibleMensualRecargado;
    }

    /**
     * Metodo getMinimoCombustibleMensualRecargado, devuelve la minima cantidad de combustible recargada en el mes.
     *
     * @return Un Double con la cantidad
     */
    public Double getMinimoCombustibleMensualRecargado() {
        return minimoCombustibleMensualRecargado;
    }

    /**
     * Metodo setMinimoCombustibleMensualRecargado, establece la minima cantidad de combustible recargada en el mes.
     *
     * @param minimoCombustibleMensualRecargado Un Double con la cantidad
     */
    public void setMinimoCombustibleMensualRecargado(Double minimoCombustibleMensualRecargado) {
        this.minimoCombustibleMensualRecargado = minimoCombustibleMensualRecargado;
    }

    /**
     * Metodo getMaximoCombustibleAnualRecargado, devuelve la maxima cantidad de combustible recargada en el anio.
     *
     * @return Un Double con la cantidad
     */
    public Double getMaximoCombustibleAnualRecargado() {
        return maximoCombustibleAnualRecargado;
    }

    /**
     * Metodo setMaximoCombustibleAnualRecargado, establece la maxima cantidad de combustible recargada en el anio.
     *
     * @param maximoCombustibleAnualRecargado Un Double con la cantidad
     */
    public void setMaximoCombustibleAnualRecargado(Double maximoCombustibleAnualRecargado) {
        this.maximoCombustibleAnualRecargado = maximoCombustibleAnualRecargado;
    }

    /**
     * Metodo getMinimoCombustibleAnualRecargado, devuelve la minima cantidad de combustible recargada en el anio.
     *
     * @return Un Double con la cantidad
     */
    public Double getMinimoCombustibleAnualRecargado() {
        return minimoCombustibleAnualRecargado;
    }
    /**
     * Metodo setMinimoCombustibleAnualRecargado, establece la minima cantidad de combustible recargada en el anio.
     *
     * @param minimoCombustibleAnualRecargado Un Double con la cantidad
     */
    public void setMinimoCombustibleAnualRecargado(Double minimoCombustibleAnualRecargado) {
        this.minimoCombustibleAnualRecargado = minimoCombustibleAnualRecargado;
    }

    /**
     * Metodo getSumaCombustibleXKmMensual, devuelve la suma de la cantidad de combustible por km recorrido
     * recargada en el mes.
     *
     * @return  Un Double con la cantidad
     */
    public Double getSumaCombustibleXKmMensual() {
        return sumaCombustibleXKmMensual;
    }

    /**
     * Metodo getSumaCombustibleXKmMensual, establece la suma de la cantidad de combustible por km recorrido
     * recargada en el mes.
     *
     * @param sumaCombustibleXKmMensual  Un Double con la cantidad
     */
    public void setSumaCombustibleXKmMensual(Double sumaCombustibleXKmMensual) {
        this.sumaCombustibleXKmMensual = sumaCombustibleXKmMensual;
    }


    /**
     * Metodo getSumaCombustibleXKmAnual, devuelve la suma de la cantidad de combustible por km recorrido
     * recargada en el anio.
     *
     * @return  Un Double con la cantidad
     */
    public Double getSumaCombustibleXKmAnual() {
        return sumaCombustibleXKmAnual;
    }

    /**
     * Metodo setSumaCombustibleXKmAnual, establece la suma de la cantidad de combustible por km recorrido
     * recargada en el anio.
     *
     * @param sumaCombustibleXKmAnual  Un Double con la cantidad
     */
    public void setSumaCombustibleXKmAnual(Double sumaCombustibleXKmAnual) {
        this.sumaCombustibleXKmAnual = sumaCombustibleXKmAnual;
    }

    /**
     * Metodo getMinimoCombustibleXKmMensual, devuelve el minimo de la cantidad de combustible por km recorrido
     * recargada en el mes.
     *
     * @return Double con la cantidad
     */
    public Double getMinimoCombustibleXKmMensual() {
        return minimoCombustibleXKmMensual;
    }

    /**
     * Metodo setMinimoCombustibleXKmMensual, establece el minimo de la cantidad de combustible por km recorrido
     * recargada en el mes.
     *
     * @param minimoCombustibleXKmMensual Double con la cantidad
     */
    public void setMinimoCombustibleXKmMensual(Double minimoCombustibleXKmMensual) {
        this.minimoCombustibleXKmMensual = minimoCombustibleXKmMensual;
    }

    /**
     * Metodo getMinimoCombustibleXKmMensual, devuelve el minimo de la cantidad de combustible por km recorrido
     * recargada en el anual.
     *
     * @return Double con la cantidad
     */
    public Double getMinimoCombustibleXKmAnual() {
        return minimoCombustibleXKmAnual;
    }

    /**
     * Metodo setMinimoCombustibleXKmAnual, establece el minimo de la cantidad de combustible por km recorrido
     * recargada en el anual.
     *
     * @rparam minimoaCombustibleXKmAnual Double con la cantidad
     */
    public void setMinimoCombustibleXKmAnual(Double minimoaCombustibleXKmAnual) {
        this.minimoCombustibleXKmAnual = minimoaCombustibleXKmAnual;
    }

    /**
     * Metodo getMaximoCombustibleXKmMensual, devuelve el maximo de la cantidad de combustible por km recorrido
     * recargada en el mensual.
     *
     * @return Double con la cantidad
     */
    public Double getMaximoCombustibleXKmMensual() {
        return maximoCombustibleXKmMensual;
    }

    /**
     * Metodo setMaximoCombustibleXKmMensual, establece el maximo de la cantidad de combustible por km recorrido
     * recargada en el mensual.
     *
     * @param maximoCombustibleXKmMensual Double con la cantidad
     */
    public void setMaximoCombustibleXKmMensual(Double maximoCombustibleXKmMensual) {
        this.maximoCombustibleXKmMensual = maximoCombustibleXKmMensual;
    }

    /**
     * Metodo getMaximoCombustibleXKmAnual, devuelve el maximo de la cantidad de combustible por km recorrido
     * recargada en el anual.
     *
     * @return Double con la cantidad
     */
    public Double getMaximoCombustibleXKmAnual() {
        return maximoCombustibleXKmAnual;
    }

    /**
     * Metodo setMaximoCombustibleXKmAnual, establece el maximo de la cantidad de combustible por km recorrido
     * recargada en el anual.
     *
     * @param maximoaCombustibleXKmAnual Double con la cantidad
     */
    public void setMaximoCombustibleXKmAnual(Double maximoaCombustibleXKmAnual) {
        this.maximoCombustibleXKmAnual = maximoaCombustibleXKmAnual;
    }

    /**
     * Metodo getMediaCombustibleMensualRecargado, devuelve la media de la cantidad de combustible
     * recargada en el mes.
     *
     * @return Double con la cantidad
     */
    public Double getMediaCombustibleMensualRecargado() {
        return mediaCombustibleMensualRecargado;
    }

    /**
     * Metodo setMediaCombustibleMensualRecargado, establece la media de la cantidad de combustible
     * recargada en el mes.
     *
     * @param mediaCombustibleMensualRecargado Double con la cantidad
     */
    public void setMediaCombustibleMensualRecargado(Double mediaCombustibleMensualRecargado) {
        this.mediaCombustibleMensualRecargado = mediaCombustibleMensualRecargado;
    }

    /**
     * Metodo getMediaCombustibleAnualRecargado, devuelve la media de la cantidad de combustible
     * recargada en el anio.
     *
     * @return  Double con la cantidad
     */
    public Double getMediaCombustibleAnualRecargado() {
        return mediaCombustibleAnualRecargado;
    }

    /**
     * Metodo setMediaCombustibleAnualRecargado, establece la media de la cantidad de combustible
     * recargada en el anio.
     *
     * @param mediaCombustibleAnualRecargado  Double con la cantidad
     */
    public void setMediaCombustibleAnualRecargado(Double mediaCombustibleAnualRecargado) {
        this.mediaCombustibleAnualRecargado = mediaCombustibleAnualRecargado;
    }

    /**
     * Metodo getMediaCombustibleXKmMensual, devuelve la media de la cantidad de combustible por km
     * recargada en el mes.
     *
     * @return  Double con la cantidad
     */
    public Double getMediaCombustibleXKmMensual() {
        return mediaCombustibleXKmMensual;
    }

    /**
     * Metodo setMediaCombustibleXKmMensual, establece la media de la cantidad de combustible por km
     * recargada en el mes.
     *
     * @return  Double con la cantidad
     */
    public void setMediaCombustibleXKmMensual(Double mediaCombustibleXKmMensual) {
        this.mediaCombustibleXKmMensual = mediaCombustibleXKmMensual;
    }

    /**
     * Metodo getMediaCombustibleXKmAnual, devuelve la media de la cantidad de combustible por km
     * recargada en el anio.
     *
     * @return  Double con la cantidad
     */
    public Double getMediaCombustibleXKmAnual() {
        return mediaCombustibleXKmAnual;
    }

    /**
     * Metodo setMediaCombustibleXKmAnual, establece la media de la cantidad de combustible por km
     * recargada en el anio.
     *
     * @param mediaCombustibleXKmAnual Double con la cantidad
     */
    public void setMediaCombustibleXKmAnual(Double mediaCombustibleXKmAnual) {
        this.mediaCombustibleXKmAnual = mediaCombustibleXKmAnual;
    }
}