package com.example.juanalonsoastruga.cargascontrol.CapaTransversal;

import java.io.Serializable;

/**
 *Clase DTODatosDerivadosVehiculoTotales, replesenta el conjunto de datos derivados asociados a un vehiculo.
 */
public class DTODatosDerivadosVehiculoTotales implements Serializable {

    private String matriculaVehiculo;

    private Integer mes;

    private Integer anio;

    private Integer numeroRecargasTotalesPorMes;

    private Integer numeroRecargasTotalesPorAnio;

    private Double costeRecargasTotalesPorMes;

    private Double costeRecargasTotalesPorAnio;

    private Double kmRecargasTotalesPorMes;

    private Double kmRecargasTotalesPorAnio;

    /**
     *Constructor de clase.
     *
     */
    public DTODatosDerivadosVehiculoTotales(){}
    /**
     *Constructor de clase.
     *
     *@param mes Un Objeto Integer representando el nÃºmero de mes (0 a 11)
     *@param anio Un Objeto Integer representando el numero de anio
     *@param matriculaVehiculo Un String con la matricula del vehiculo asociado
     */
    public DTODatosDerivadosVehiculoTotales(String matriculaVehiculo, Integer anio,Integer mes) {
        this.mes=mes;
        this.anio=anio;
        this.matriculaVehiculo=matriculaVehiculo;
    }
    /**
     * Metodo setMatricula, establece la matricula del vehiculo.
     *
     * @param matricula String representando la matricula del vehiculo
     */
    public void setMatricula(String matricula){
        this.matriculaVehiculo=matricula;
    }
    /**
     * Metodo getMatricula, devuelve la matricula del vehiculo.
     *
     * @return  Un String representando la matricula del vehiculo
     */
    public String getMatricula( ){
        return matriculaVehiculo;
    }
    /**
     * Metodo setMes, establece el mes asociado al conjunto.
     *
     * @param mes Un Objeto Integer representando el mes asociado(0 a 11)
     */
    public void setMes(Integer mes){
        this.mes=mes;
    }
    /**
     * Metodo getMes, devuelve  el mes asociado al conjunto.
     *
     * @return  Un Integer con el mes asociado al conjunto
     */
    public Integer getMes( ){
        return mes;
    }
    /**
     * Metodo setAnio, establece el anio asociado al conjunto.
     *
     * @param anio Un Objeto Integer representando el anio asociado
     */
    public void setAnio(Integer anio){
        this.anio=anio;
    }
    /**
     * Metodo getAnio, devuelve  el anio asociado al conjunto.
     *
     * @return  Un Integer con el anio asociado al conjunto
     */
    public Integer getAnio( ){
        return anio;
    }
    /**
     * Metodo setNumeroRecargasMes, establece el numero de recargas realizadas en un mes sobre el vehiculo.
     *
     * @param numeroRecargasTotalesPorMes Un Objeto Integer representando el numero de recargas
     */
    public void setNumeroRecargasMes(Integer numeroRecargasTotalesPorMes){
        this.numeroRecargasTotalesPorMes=numeroRecargasTotalesPorMes;
    }
    /**
     * Metodo getNumeroRecargasMes, devuelve el numero de recargas realizadas en un mes sobre el vehiculo.
     *
     * @return Un Integer con el numero de recargas al mes
     */
    public Integer getNumeroRecargasMes(){
        return numeroRecargasTotalesPorMes;
    }

    /**
     * Metodo setNumeroRecargasAnio, establece el numero de recargas hechas en el anio.
     *
     * @param numeroRecargasTotalesPorAnio  Un Integer con el numero de recargas al anio
     */
    public void setNumeroRecargasAnio(Integer numeroRecargasTotalesPorAnio){
        this.numeroRecargasTotalesPorAnio=numeroRecargasTotalesPorAnio;
    }
    /**
     * Metodo getNumeroRecargasAnio, devuelve el numero de recargas realizadas en un anio sobre el vehiculo.
     *
     * @return Un Integer con el numero de recargas al anio
     */
    public Integer getNumeroRecargasAnio(){
        return numeroRecargasTotalesPorAnio;
    }

    /**
     * Metodo getCosteRecargasTotalesPorMes, devuelve la suma de los costes por recargas al mes asciadas al vehiculo.
     *
     * @return Un Double con el coste
     */
    public  Double getCosteRecargasTotalesPorMes(){
        return costeRecargasTotalesPorMes;
    }

    /**
     * Metodo setCosteRecargasTotalesPorMes, establece la suma de los costes por recargas al mes asciadas al vehiculo.
     *
     * @param costeRecargasTotalesPorMes Un Double con el coste
     */
    public  void setCosteRecargasTotalesPorMes(Double costeRecargasTotalesPorMes){
       this.costeRecargasTotalesPorMes=costeRecargasTotalesPorMes;
    }

    /**
     * Metodo getCosteRecargasTotalesPorMes, devuelve la suma de los costes por recargas al anio asciadas al vehiculo.
     *
     * @return Un Double con el coste
     */
    public  Double getCosteRecargasTotalesPorAnio(){
        return costeRecargasTotalesPorAnio;
    }
    /**
     * Metodo setCosteRecargasTotalesPorMes, establece la suma de los costes por recargas al anio asciadas al vehiculo.
     *
     * @param costeRecargasTotalesPorAnio Double con el coste
     */
    public  void setCosteRecargasTotalesPorAnio(Double costeRecargasTotalesPorAnio){
        this.costeRecargasTotalesPorAnio=costeRecargasTotalesPorAnio;
    }

    /**
     * Metodo getKmRecargasTotalesPorMes, devuelve el numero de km realizados en un mes sobre el vehiculo.
     *
     * @return Un Double con el numero de km al mes
     */
    public Double getKmRecargasTotalesPorMes(){
        return kmRecargasTotalesPorMes;
    }

    /**
     * Metodo setKmRecargasTotalesPorMes, establece el numero de km realizados en un mes sobre el vehiculo.
     *
     * @param km Un Double con el numero de recargas al mes
     */
    public void setKmRecargasTotalesPorMes(Double km ){
        this.kmRecargasTotalesPorMes=km;
    }

    /**
     * Metodo getKmRecargasTotalesPorAnio, devuelve el numero de km realizadas en un anio sobre el vehiculo.
     *
     * @return Un Double con el numero de km al anio
     */
    public Double getKmRecargasTotalesPorAnio(){
        return kmRecargasTotalesPorAnio;
    }

    /**
     * Metodo setKmRecargasTotalesPorAnio, establece el numero de km realizadas en un anio sobre el vehiculo.
     *
     * @param km Un Double con el numero de km al anio
     */
    public void setKmRecargasTotalesPorAnio(Double km){
        this.kmRecargasTotalesPorAnio=km;
    }
}