package com.example.juanalonsoastruga.cargascontrol.CapaTransversal;




import java.io.Serializable;
/**
 *Clase DTOGasolinera, representa el conjunto de datos de
 *una estacion de recarga.
 *
 */
public class DTOGasolinera implements Serializable{

    private String direccion;
    private String horario;
    private double latitud;
    private double longitud;
    private String provincia;
    private String municipio;
    private String localidad;
    private String rotulo;
    private boolean biodiesel=false;
    private boolean bioetanol=false;
    private boolean gasNaturalComprimido=false;
    private boolean gasNaturalLicuado=false;
    private boolean gasesLicuadosPetroleo=false;
    private boolean gasoleoA=false;
    private boolean gasoleoB=false;
    private boolean gasolina95=false;
    private boolean gasolina98=false;
    private boolean nuevoGasoleoA=false;
    private double km;
    /**
     *Constructor de clase.
     *
     */
    public DTOGasolinera(){}

    /**
     *Metodo setDireccion, establece la direccion de la estacion.
     *
     *@param txt String con la direccion
     */

    public void setDireccion(String txt){
        this.direccion=txt;
    }
    /**
     *Metodo getDireccion, devuelve la direccion de la estacion.
     *
     *@return String con la direccion
     */

    public String getDireccion(){
        return this.direccion;
    }

    /**
     *Metodo setHorario, establece el horario de la estacion de servicio.
     *
     *@param txt String con el horario semanal
     */

    public void setHorario(String txt){
        this.horario=txt;
    }

    /**
     *Metodo getHorario, devuelve el horario de la estacion de servicio.
     *
     *@return String con el horario semanal
     */

    public String getHorario(){
        return this.horario;
    }

    /**
     *Metodo setLatitud, establece la latitud geográfica de
     *la estacion de servicio.
     *
     *@param num double con la latitud en grados decimales
     */

    public void setLatitud(double num){
        this.latitud=num;
    }

    /**
     *Metodo getLatitud, devuelve la latitud geográfica de
     *la estacion de servicio.
     *
     *@return double con la latitud en grados decimales
     */

    public double getLatitud(){
        return this.latitud;
    }

    /**
     *Metodo setLongitud, establece la longitud geográfica de
     *la estacion de servicio.
     *
     *@param num double con la longitud en grados decimales
     */

    public void setLongitud(double num){
        this.longitud=num;
    }

    /**
     *Metodo getLongitud, devuelve la longitud geográfica de
     *la estacion de servicio.
     *
     *@return double con la longitud en grados decimales
     */

    public double getLongitud(){
        return this.longitud;
    }


    /**
     *Metodo setProvincia, establece la provincia en la que se encuentra la estacion.
     *
     *@param txt String con la provincia
     */

    public void setProvincia(String txt){
        this.provincia=txt;
    }


    /**
     *Metodo getProvincia, devuelve la provincia en la que se encuentra la estacion.
     *
     *@return String con la provincia
     */

    public String getProvincia(){
        return this.provincia;
    }

    /**
     *Metodo setMunicipio, establece el municipio en el que se encuentra la estacion.
     *
     *@param txt String con el municipio
     */

    public void setMunicipio(String txt){
        this.municipio=txt;
    }


    /**
     *Metodo getMunicipio, devuelve el municipio en el que se encuentra la estacion.
     *
     *@return txt String con el municipio
     */

    public String getMunicipio(){
        return this.municipio;
    }

    /**
     *Metodo setLocalidad, establece la localidad en la que se encuentra la estacion.
     *
     *@param txt String con la localidad
     */

    public void setLocalidad(String txt){
        this.localidad=txt;
    }

    /**
     *Metodo getLocalidad, devuelve la localidad en la que se encuentra la estacion.
     *
     *@return String con la localidad
     */

    public String getLocalidad(){
        return this.localidad;
    }

    /**
     *Metodo setRotulo, establece el rotulo en el que se encuentra la estacion.
     *
     *@param txt String con el rotulo de la estacion
     */

    public void setRotulo(String txt){
        this.rotulo=txt;
    }

    /**
     *Metodo getRotulo, devuelve el rotulo en el que se encuentra la estacion.
     *
     *@return String con el rotulo de la estacion
     */

    public String getRotulo(){
        return this.rotulo;
    }

    /**
     *Metodo setBiodiesel, establece a la estacion como posible distribuidor de
     * Biodiesel.
     *
     */

    public void setBiodiesel(){
        this.biodiesel=true;
    }

    /**
     *Metodo getBiodiesel, determina si a la estacion como posible distribuidor de
     * Biodiesel.
     *
     *@return true en caso de serlo, false si no lo es
     */

    public boolean getBiodiesel(){
        return this.biodiesel;
    }


    /**
     *Metodo setBioetanol, establece a la estacion como posible distribuidor de
     * Bioetanol.
     *
     */

    public void setBioetanol(){
        this.bioetanol=true;
    }

    /**
     *Metodo getBioetanol, determina si la estacion es un posible distribuidor de
     * Bioetanol.
     *
     *@return true en caso de serlo, false si no lo es
     */

    public boolean getBioetanol(){
        return this.bioetanol;
    }


    /**
     *Metodo setGasNaturalComprimido, establece a la estacion como posible distribuidor de
     * Gas Natural Comprimido (GNC).
     *
     */

    public void setGasNaturalComprimido(){
        this.gasNaturalComprimido=true;
    }

    /**
     *Metodo getGasNaturalComprimido, determina si a la estacion es un posible distribuidor de
     * Gas Natural Comprimido (GNC).
     *
     */

    public boolean getGasNaturalComprimido(){
        return this.gasNaturalComprimido;
    }

    /**
     *Metodo setGasNaturalLicuado, establece a la estacion como posible distribuidor de
     * Gas Natural Licuado (GNL).
     *
     */

    public void setGasNaturalLicuado(){
        this.gasNaturalLicuado=true;
    }


    /**
     *Metodo getGasNaturalLicuado, determina si la estacion es un posible distribuidor de
     * Gas Natural Licuado (GNL).
     *
     */

    public boolean getGasNaturalLicuado(){
        return this.gasNaturalLicuado;
    }


    /**
     *Metodo setGasLicuadoPetroleo, establece a la estacion como posible distribuidor de
     * Gases Licuados del Petroleo (GLP).
     *
     */

    public void setGasLicuadoPetroleo(){
        this.gasesLicuadosPetroleo=true;
    }

    /**
     *Metodo getGasLicuadoPetroleo, determina si la estacion es un posible distribuidor de
     * Gases Licuados del Petroleo (GLP).
     *
     */

    public boolean getGasLicuadoPetroleo(){
        return this.gasesLicuadosPetroleo;
    }

    /**
     *Metodo setGasoleoA, establece a la estacion como posible distribuidor de
     * Gasoleo A.
     *
     */

    public void setGasoleoA(){
        this.gasoleoA=true;
    }

    /**
     *Metodo getGasoleoA, determina si la estacion es un posible distribuidor de
     * Gasoleo A.
     *
     */

    public boolean getGasoleoA(){
        return this.gasoleoA;
    }

    /**
     *Metodo setGasoleoB, establece a la estacion como posible distribuidor de
     * Gasoleo B.
     *
     */

    public void setGasoleoB(){
        this.gasoleoB=true;
    }

    /**
     *Metodo getGasoleoB, determina si la estacion es un posible distribuidor de
     * Gasoleo B.
     *
     */

    public boolean getGasoleoB(){
        return this.gasoleoB;
    }

    /**
     *Metodo setGasolina95, establece a la estacion como posible distribuidor de
     * Gasolina 95.
     *
     */

    public void setGasolina95(){
        this.gasolina95=true;
    }

    /**
     *Metodo getGasolina95, determina si la estacion es un posible distribuidor de
     * Gasolina 95.
     *
     */

    public boolean getGasolina95(){
        return this.gasolina95;
    }

    /**
     *Metodo setGasolina98, establece a la estacion como posible distribuidor de
     * Gasolina 98.
     *
     */

    public void setGasolina98(){
        this.gasolina98=true;
    }

    /**
     *Metodo getGasolina98, determina si la estacion es un posible distribuidor de
     * Gasolina 98.
     *
     */

    public boolean getGasolina98(){
        return this.gasolina98;
    }

    /**
     *Metodo setNuevoGasoleoA, establece a la estacion como posible distribuidor de
     * Nuevo Gasoleo A.
     *
     */

    public void setNuevoGasoleoA(){
        this.nuevoGasoleoA=true;
    }

    /**
     *Metodo getNuevoGasoleoA, determina si la estacion es un posible distribuidor de
     * Nuevo Gasoleo A.
     *
     */

    public boolean getNuevoGasoleoA(){
        return this.nuevoGasoleoA;
    }

    /**
     * Metodo getKm, devuelve el resultado del calculo del numero de km entre el punto de origen y la estacion.
     *
     * @return double con la cantidad de km
     */
    public double getKm() {
        return km;
    }

    /**
     * Metodo setKm, establece el numero de km entre el punto de origen y la estacion de recarga.
     *
     * @param km    argumento double con el numero de km
     */
    public void setKm(double km) {
        this.km = km;
    }
}