package com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimaRecarga;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimaRecarga.InterfaceFConsultarUltimaRecarga;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarUltimaRecarga.InterfaceMConsultarUltimaRecarga;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarUltimaRecarga.ModeloConsultarUltimaRecarga;

import java.util.Hashtable;

/**
 * Clase ControladorConsultarUltimaRecarga, representa al presentador del CU Recuperar Id Recarga de la Ultima Consulta
 *
 */
public class ControladorConsultarUltimaRecarga implements InterfaceCConsultarUltimaRecarga {

    private InterfaceFConsultarUltimaRecarga view;
    private InterfaceMConsultarUltimaRecarga model;

    /**
     * Cinstructor de clase
     *
     * @param vista objeto InterfaceFConsultarUltimaRecarga
     */
    public ControladorConsultarUltimaRecarga(InterfaceFConsultarUltimaRecarga vista){
        setView(vista);
        setModel(new ModeloConsultarUltimaRecarga());
    }

    /**
     * Metodo getModel, devuelve el modelo asociado al presentador.
     *
     * @return InterfaceMConsultarUltimaRecarga
     */
    @Override
    public InterfaceMConsultarUltimaRecarga getModel(){
        return model;
    }


    /**
     * Metodo setModel, establece el modelo asociado al presentador.
     *
     * @param model Objeto InterfaceMConsultarUltimaRecarga
     * @throws IllegalArgumentException si el argumento es nulo
     */
    @Override
    public void setModel(InterfaceMConsultarUltimaRecarga model) {
        if(model==null){
            throw new IllegalArgumentException();
        }else{
            this.model=model;
        }
    }

    /**
     * Metodo getControlador, devuelve la vista asociada al presentador.
     *
     * @return InterfaceFConsultarUltimaRecarga
     */
    @Override
    public InterfaceFConsultarUltimaRecarga getView(){
        return view;
    }


    /**
     * Metodo borraFichero, borra el fichero de recarga asociado.
     *
     */
    @Override
    public void borraFichero() {
        model.borrarFichero();
    }


    /**
     * Metodo setControlador, establece la vista asociada al presentador.
     *
     * @param vista Objeto InterfaceFConsultarUltimaRecarga
     * @throws IllegalArgumentException si el argumento es nulo
     */
    @Override
    public void setView(InterfaceFConsultarUltimaRecarga vista) {
        if(vista==null){
            throw new IllegalArgumentException();
        }else{
            this.view=vista;
        }

    }

    /**
     * Metodo eventoInicio, metodo para avisar al presentador del evento de comienzo de caso de uso.
     *
     */
    @Override
    public void eventoInicio() {

                Hashtable recarga=model.recuperaIdUltimaRecarga();
                try{
                    if(recarga.get("id")!=null&&recarga.get("fecha")!=null&&recarga.get("combustible")!=null){
                        view.setIdRecarga(recarga);
                    }
                }catch (Exception e){
                    recarga=null;
                    view.setIdRecarga(recarga);
                }

    }

}
