package com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoGasolineras;


import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoGasolineras.InterfaceFMostrarListadoGasolineras;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoGasolineras.InterfaceMMostrarListadoGasolineras;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoGasolineras.ModeloMostrarListadoGasolineras;

import java.util.Hashtable;
import java.util.List;

/**
 * Clase ControladorMostrarListadoGasolineras, representa al controlador en el CU Mostrar Listado Gasolineras.
 *
 */
public class ControladorMostrarListadoGasolineras implements InterfaceCMostrarListadoGasolineras {

    private InterfaceFMostrarListadoGasolineras formateador;
    private InterfaceMMostrarListadoGasolineras model;

    /**
     * Constructor de clase.
     *
     * @param formateador Objeto InterfaceFMostrarListadoGasolineras
     */
    public ControladorMostrarListadoGasolineras(InterfaceFMostrarListadoGasolineras formateador){

        setFormateador(formateador);
        setModel(new ModeloMostrarListadoGasolineras());
    }

    /**
     * Metodo setControlador, asocia un formateador a este controlador.
     *
     * @param formateador Objeto InterfaceFMostrarListadoGasolineras
     * @throws IllegalArgumentException si el argumento es null
     */
    @Override
    public void setFormateador(InterfaceFMostrarListadoGasolineras formateador){
        if(formateador ==null){
            throw new IllegalArgumentException();
        }else{
            this.formateador = formateador;
        }
    }

    /**
     * Metodo getControlador, devuelve la vista asociada al controlador.
     *
     * @return Un objeto InterfaceFMostrarListadoGasolineras
     */
    @Override
    public InterfaceFMostrarListadoGasolineras getFormateador(){
        return formateador;
    }

    /**
     * Metodo setModel, establece el modelo asociado a este controlador.
     *
     * @param model Un objeto  InterfaceMMostrarListadoGasolineras
     * @throws IllegalArgumentException si el argumento es null
     */
    @Override
    public void setModel(InterfaceMMostrarListadoGasolineras model){
        if(model==null){
            throw new IllegalArgumentException();
        }else{
            this.model=model;
        }
    }

    /**
     * Metodo getModel, devuelve el modelo asociado al controlador.
     *
     * @return InterfaceMMostrarListadoGasolineras
     */
    @Override
    public InterfaceMMostrarListadoGasolineras getModel(){
        return model;
    }

    /**
     * Metodo solicitarActualizacionMapa, avisa al controlador del evento de comienzo del caso de uso.
     *
     */
    @Override
    public void inicio() {

        formateador.setLatitudActual((double)getLocalizacionActual().get("latitud"));
        formateador.setLongitudActual((double)getLocalizacionActual().get("longitud"));
        List<DTOGasolinera> gasolineras=model.descargaListadoGasolineras(getLocalizacionActual());
        estableceListadoGasolineras(gasolineras);

    }



    private void estableceListadoGasolineras(List<DTOGasolinera> gasolineras) {
        formateador.setGasolineras(gasolineras);
    }

    private Hashtable getLocalizacionActual() {
        Hashtable localizacion= new Hashtable(2);
         return model.getLocalizacion(localizacion);

    }
}
