package com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoRecargas;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoRecargas.InterfaceFMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoRecargas.InterfaceMMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoRecargas.ModeloMostrarListadoRecargas;

import java.util.List;

/**
 * Clase ControladorMostrarListadoRecargas, representa al Controlador en el CU Mostrar Listado de Recargas de un Vehiculo
 *
 */
public class ControladorMostrarListadoRecargas implements InterfaceCMostrarListadoRecargas {

    private InterfaceFMostrarListadoRecargas formateador;
    private InterfaceMMostrarListadoRecargas model;

    /**
     * Constructor de Clase.
     *
     * @param formateador Un Objeto InterfaceFMostrarListadoRecargas
     */
    public ControladorMostrarListadoRecargas(InterfaceFMostrarListadoRecargas formateador){
        setFormateador(formateador);
        setModel(new ModeloMostrarListadoRecargas());
    }

    /**
     * Metodo setControlador, establece el formateador asociada al controlador.
     *
     * @param formateador  Un Objeto InterfaceFMostrarListadoRecargas
     * @throws IllegalArgumentException si el argumento es null
     */
    public void setFormateador(InterfaceFMostrarListadoRecargas formateador){
        if(formateador ==null){
            throw new IllegalArgumentException();
        }else{
            this.formateador = formateador;
        }
    }
    /**
     * Metodo getControlador, devuelve el formateador asociado al controlador.
     *
     * @return  Un Objeto InterfaceFMostrarListadoRecargas
     */
    public InterfaceFMostrarListadoRecargas getFormateador() {
        return formateador;
    }
    /**
     * Metodo setModel, establece el modelo asociado al controlador.
     *
     * @param model  Un Objeto InterfaceMMostrarListadoRecargas
     * @throws IllegalArgumentException si el argumento es null
     */
    public void setModel(InterfaceMMostrarListadoRecargas model){
        if(model==null){
            throw new IllegalArgumentException();
        }else{
            this.model=model;
        }
    }
    /**
     * Metodo getModel, devuelve el modelo asociada al controlador.
     *
     * @return  Un Objeto InterfaceMMostrarListadoRecargas
     */
    public InterfaceMMostrarListadoRecargas getModel() {
        return model;
    }

    /**
     * Metodo comienzoCU, despierta al controlador para comenzar la ejecucion del CU.
     *
     * @param matricula Un Objeto String
     * @throws IllegalArgumentException si el argumento es null
     */
    @Override
    public void comienzoCU(String matricula) {
        if(matricula==null){
            throw new IllegalArgumentException();
        }else {
            List<DTORecarga> recargas = model.getListadoRecargas(matricula);
            formateador.setListado(recargas);
        }
    }
}
