package com.example.juanalonsoastruga.cargascontrol.Datos.CombustibleProvider;

import com.example.juanalonsoastruga.cargascontrol.Datos.Entidades.Combustible;

import java.io.InputStream;
import java.util.List;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * Clase CombustibleParser, parsea el documento de combustibles inicial.
 *
 */
public class CombustibleParser {

    private InputStream is;

    /**
     * Constructor de clase
     *
     * @param is Objeto InputStream con la dirección del archivo a parsear
     */
    public CombustibleParser( InputStream is)
    {
            this.is =is;
    }

    /**
     * Metodo parse, parsea el archivo XML especificado.
     *
     * @return Un Objeto  List<Combustible> con el listado de combustibles
     */
    public List<Combustible> parse() {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try
        {
            SAXParser parser = factory.newSAXParser();
            CombustibleHandler handler = new CombustibleHandler();
            //Parsea el archivo del inputstream con el manejador proporcionado
            parser.parse( is,  handler);

            return handler.getCombustibles();
        }
        catch (Exception e)
        {
            throw new RuntimeException(e);
        }
    }

    private InputStream getInputStream()
    {
            return is;
    }


}
