package com.example.juanalonsoastruga.cargascontrol.Datos.DAO;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;
import androidx.room.Update;

import com.example.juanalonsoastruga.cargascontrol.Datos.Entidades.DatosDerivadosCombustible;
@Dao
public interface DatDervdCombustibleDAO {
    @Query("SELECT * FROM DATOSDERIVADOSCOMBUSTIBLE WHERE " +
            "DATOSDERIVADOSCOMBUSTIBLE.matriculaVehiculo==:matricula " +
            "AND DATOSDERIVADOSCOMBUSTIBLE.combustible==:combustible " +
            "AND DATOSDERIVADOSCOMBUSTIBLE.mes == :mes " +
            "AND DATOSDERIVADOSCOMBUSTIBLE.anio == :anio " +
            " LIMIT 1 ")
    DatosDerivadosCombustible getRegistro(String matricula,int anio,int mes, int combustible);

    @Query("SELECT * FROM DATOSDERIVADOSCOMBUSTIBLE WHERE " +
            "DATOSDERIVADOSCOMBUSTIBLE.matriculaVehiculo==:matricula " +
            "AND DATOSDERIVADOSCOMBUSTIBLE.combustible==:combustible "+
            "ORDER BY DATOSDERIVADOSCOMBUSTIBLE.anio , DATOSDERIVADOSCOMBUSTIBLE.mes "+
            "LIMIT 1")
    DatosDerivadosCombustible getUltimoRegistro(String matricula,int combustible);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void addRegistro(DatosDerivadosCombustible r);

    @Update(onConflict = OnConflictStrategy.REPLACE)
    void actualizaRegistro(DatosDerivadosCombustible r);

    @Delete
    void borraRegistro(DatosDerivadosCombustible r);
}
