package com.example.juanalonsoastruga.cargascontrol.Datos.DAO;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;
import androidx.room.Update;

import com.example.juanalonsoastruga.cargascontrol.Datos.Entidades.DatosDerivadosCostesCombustible;
@Dao
public interface DatDervdCostesCombustibleDAO {

    @Query("SELECT * FROM DATOSDERIVADOSCOSTESCOMBUSTIBLE WHERE " +
            "DATOSDERIVADOSCOSTESCOMBUSTIBLE.matriculaVehiculo==:matricula " +
            "AND DATOSDERIVADOSCOSTESCOMBUSTIBLE.combustible==:combustible " +
            "AND DATOSDERIVADOSCOSTESCOMBUSTIBLE.mes == :mes " +
            "AND DATOSDERIVADOSCOSTESCOMBUSTIBLE.anio == :anio " +
            " LIMIT 1 ")
    DatosDerivadosCostesCombustible getRegistro(String matricula, int anio, int mes, int combustible);

    @Query("SELECT * FROM DATOSDERIVADOSCOSTESCOMBUSTIBLE WHERE " +
            "DATOSDERIVADOSCOSTESCOMBUSTIBLE.matriculaVehiculo==:matricula " +
            "AND DATOSDERIVADOSCOSTESCOMBUSTIBLE.combustible==:combustible "+
            "ORDER BY  DATOSDERIVADOSCOSTESCOMBUSTIBLE.anio , DATOSDERIVADOSCOSTESCOMBUSTIBLE.mes "+
            "LIMIT 1")
    DatosDerivadosCostesCombustible getUltimoRegistro(String matricula,int combustible);


    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void addRegistro(DatosDerivadosCostesCombustible  r);

    @Update(onConflict = OnConflictStrategy.REPLACE)
    void actualizaRegistro(DatosDerivadosCostesCombustible  r);

    @Delete
    void borraRegistro(DatosDerivadosCostesCombustible  r);
}
