package com.example.juanalonsoastruga.cargascontrol.Datos.DAO;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;
import androidx.room.Update;

import com.example.juanalonsoastruga.cargascontrol.Datos.Entidades.DatosDerivadosVehiculoTotales;
@Dao
public interface DatDervdVehiculoTotalDAO {


    @Query("SELECT * FROM DATOSDERIVADOSVEHICULOTOTALES WHERE " +
            "DATOSDERIVADOSVEHICULOTOTALES.matriculaVehiculo==:matricula " +
            "AND DATOSDERIVADOSVEHICULOTOTALES.mes == :mes " +
            "AND DATOSDERIVADOSVEHICULOTOTALES.anio == :anio " +
            " LIMIT 1 ")
    DatosDerivadosVehiculoTotales getRegistro(String matricula, int anio, int mes);


    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void addRegistro(DatosDerivadosVehiculoTotales  r);

    @Update(onConflict = OnConflictStrategy.REPLACE)
    void actualizaRegistro(DatosDerivadosVehiculoTotales  r);

    @Delete
    void borraRegistro(DatosDerivadosVehiculoTotales  r);

    @Query("SELECT * FROM DATOSDERIVADOSVEHICULOTOTALES WHERE " +
            "DATOSDERIVADOSVEHICULOTOTALES.matriculaVehiculo==:matricula " +
            "ORDER BY  DATOSDERIVADOSVEHICULOTOTALES.anio , DATOSDERIVADOSVEHICULOTOTALES.mes "+
            "LIMIT 1")
    DatosDerivadosVehiculoTotales getUltimoRegistro(String matricula);
}
