package com.example.juanalonsoastruga.cargascontrol.Datos.DAO;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;

import com.example.juanalonsoastruga.cargascontrol.Datos.Entidades.Recarga;

import java.util.List;
@Dao
public interface RecargaDAO {

    @Query("SELECT * FROM RECARGA WHERE " +
            "RECARGA.matriculaVehiculo==:matricula " +
            "AND RECARGA.combustible==:combustible " +
            "AND RECARGA.fecha BETWEEN :primerDia AND :ultimoDia " +
            "ORDER BY RECARGA.fecha  ASC")
    List<Recarga> getRecargasEntreFechasforCombustible(String matricula, int combustible, long primerDia , long ultimoDia);

    @Query("SELECT * FROM RECARGA WHERE RECARGA.matriculaVehiculo==:matricula")
    List<Recarga> getRecargas(String matricula);

    @Query("SELECT * FROM RECARGA WHERE " +
            "RECARGA.matriculaVehiculo==:matricula " +
            "AND RECARGA.combustible==:combustible " +
            "AND RECARGA.fecha < :before " +
            "ORDER BY RECARGA.fecha  DESC" +
            " LIMIT 1")
    Recarga getLastRecargaBeforeDate(String matricula,long before,int combustible);

    @Query("SELECT * FROM RECARGA WHERE " +
            "RECARGA.matriculaVehiculo==:matricula " +
            "AND RECARGA.combustible==:combustible " +
            "ORDER BY RECARGA.fecha DESC " +
            "LIMIT 1")
    Recarga getLastRecargaPorCombustible(String matricula, int combustible);

    @Query("SELECT * FROM RECARGA WHERE " +
            "RECARGA.matriculaVehiculo==:matricula " +
            "AND RECARGA.fecha < :before " +
            "ORDER BY RECARGA.fecha DESC " +
            "LIMIT 1")
    Recarga getLastRecarga(String matricula, long before);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void addRecarga(Recarga r);

    @Query("SELECT * FROM RECARGA WHERE RECARGA.matriculaVehiculo==:matricula AND RECARGA.combustible=:combustible AND RECARGA.fecha=:fecha" )
    Recarga getRecarga(String matricula,int combustible,long fecha);
}
