package com.example.juanalonsoastruga.cargascontrol.Datos.DAO;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;
import androidx.room.Update;

import com.example.juanalonsoastruga.cargascontrol.Datos.Entidades.Vehiculo;

import java.util.List;
@Dao
public interface VehiculoDAO {
    @Query("SELECT * FROM VEHICULO")
    List<Vehiculo> getVehiculos();

    @Query("SELECT * FROM VEHICULO WHERE matricula LIKE :matricula")
    Vehiculo getVehiculo(String matricula);

    @Query("SELECT  VEHICULO.matricula, VEHICULO.nombre, VEHICULO.combustiblePrimario  FROM VEHICULO")
    List<Vehiculo> getIdVehiculos();

    @Insert(onConflict = OnConflictStrategy.ABORT)
    void addVehiculo(Vehiculo vehiculo);

    @Update(onConflict = OnConflictStrategy.REPLACE)
    void actualizaVehiculo(Vehiculo vehiculo);

    @Delete
    void borraVehiculo(Vehiculo vehiculo);
}
