package com.example.juanalonsoastruga.cargascontrol.Datos.Entidades;

import androidx.room.Entity;
import androidx.room.ForeignKey;
import androidx.room.Ignore;
import androidx.annotation.NonNull;

@Entity(tableName = "DATOSDERIVADOSCOMBUSTIBLE",
        primaryKeys = {  "matriculaVehiculo", "mes","anio","combustible"},
        foreignKeys = {
            @ForeignKey(entity = Vehiculo.class,
                    parentColumns = {"matricula"},
                    childColumns = {"matriculaVehiculo"},
                    onDelete = ForeignKey.CASCADE),
            @ForeignKey(entity = Combustible.class,
                    parentColumns = {"id"},
                    childColumns = {"combustible"},
                    onDelete = ForeignKey.CASCADE)
            }
        )
public class DatosDerivadosCombustible {
    @NonNull
    private String matriculaVehiculo;
    @NonNull
    private Integer mes;
    @NonNull
    private Integer anio;
    @NonNull
    private Integer combustible;
    /* ***************************************** */
    private Integer numeroRecargasCombustiblePorMes;

    private Integer numeroRecargasCombustiblePorAnio;
    /* ***************************************** */
    private Double sumaCombustibleRecargadoPorMes;

    private Double sumaCombustibleRecargadoPorAnio;

    private Double maximoCombustibleMensualRecargado;

    private Double minimoCombustibleMensualRecargado;

    private Double maximoCombustibleAnualRecargado;

    private Double minimoCombustibleAnualRecargado;
    /* ***************************************** */
    private Double sumaCombustibleXKmMensual;

    private Double sumaCombustibleXKmAnual;

    private Double minimoCombustibleXKmMensual;

    private Double minimoCombustibleXKmAnual;

    private Double maximoCombustibleXKmMensual;

    private Double maximoCombustibleXKmAnual;
    /* ***************************************** */

    public DatosDerivadosCombustible(@NonNull String matriculaVehiculo, @NonNull Integer mes, @NonNull Integer anio, @NonNull Integer combustible) {
        this.matriculaVehiculo = matriculaVehiculo;
        this.mes = mes;
        this.anio = anio;
        this.combustible = combustible;
    }
    @Ignore
    public DatosDerivadosCombustible(@NonNull String matriculaVehiculo, @NonNull Integer mes, @NonNull Integer anio, @NonNull Integer combustible, Integer numeroRecargasCombustiblePorMes, Integer numeroRecargasCombustiblePorAnio, Double sumaCombustibleRecargadoPorMes, Double sumaCombustibleRecargadoPorAnio, Double maximoCombustibleMensualRecargado, Double minimoCombustibleMensualRecargado, Double maximoCombustibleAnualRecargado, Double minimoCombustibleAnualRecargado, Double sumaCombustibleXKmMensual, Double sumaCombustibleXKmAnual, Double minimoCombustibleXKmMensual, Double minimoaCombustibleXKmAnual, Double maximoCombustibleXKmMensual, Double maximoaCombustibleXKmAnual) {
        this.matriculaVehiculo = matriculaVehiculo;
        this.mes = mes;
        this.anio = anio;
        this.combustible = combustible;
        this.numeroRecargasCombustiblePorMes = numeroRecargasCombustiblePorMes;
        this.numeroRecargasCombustiblePorAnio = numeroRecargasCombustiblePorAnio;
        this.sumaCombustibleRecargadoPorMes = sumaCombustibleRecargadoPorMes;
        this.sumaCombustibleRecargadoPorAnio = sumaCombustibleRecargadoPorAnio;
        this.maximoCombustibleMensualRecargado = maximoCombustibleMensualRecargado;
        this.minimoCombustibleMensualRecargado = minimoCombustibleMensualRecargado;
        this.maximoCombustibleAnualRecargado = maximoCombustibleAnualRecargado;
        this.minimoCombustibleAnualRecargado = minimoCombustibleAnualRecargado;
        this.sumaCombustibleXKmMensual = sumaCombustibleXKmMensual;
        this.sumaCombustibleXKmAnual = sumaCombustibleXKmAnual;
        this.minimoCombustibleXKmMensual = minimoCombustibleXKmMensual;
        this.minimoCombustibleXKmAnual = minimoaCombustibleXKmAnual;
        this.maximoCombustibleXKmMensual = maximoCombustibleXKmMensual;
        this.maximoCombustibleXKmAnual = maximoaCombustibleXKmAnual;
    }

    @NonNull
    public String getMatriculaVehiculo() {
        return matriculaVehiculo;
    }

    public void setMatriculaVehiculo(@NonNull String matriculaVehiculo) {
        this.matriculaVehiculo = matriculaVehiculo;
    }

    @NonNull
    public Integer getMes() {
        return mes;
    }

    public void setMes(@NonNull Integer mes) {
        this.mes = mes;
    }

    @NonNull
    public Integer getAnio() {
        return anio;
    }

    public void setAnio(@NonNull Integer anio) {
        this.anio = anio;
    }

    @NonNull
    public Integer getCombustible() {
        return combustible;
    }

    public void setCombustible(@NonNull Integer combustible) {
        this.combustible = combustible;
    }

    public Integer getNumeroRecargasCombustiblePorMes() {
        return numeroRecargasCombustiblePorMes;
    }

    public void setNumeroRecargasCombustiblePorMes(Integer numeroRecargasCombustiblePorMes) {
        this.numeroRecargasCombustiblePorMes = numeroRecargasCombustiblePorMes;
    }

    public Integer getNumeroRecargasCombustiblePorAnio() {
        return numeroRecargasCombustiblePorAnio;
    }

    public void setNumeroRecargasCombustiblePorAnio(Integer numeroRecargasCombustiblePorAnio) {
        this.numeroRecargasCombustiblePorAnio = numeroRecargasCombustiblePorAnio;
    }

    public Double getSumaCombustibleRecargadoPorMes() {
        return sumaCombustibleRecargadoPorMes;
    }

    public void setSumaCombustibleRecargadoPorMes(Double sumaCombustibleRecargadoPorMes) {
        this.sumaCombustibleRecargadoPorMes = sumaCombustibleRecargadoPorMes;
    }

    public Double getSumaCombustibleRecargadoPorAnio() {
        return sumaCombustibleRecargadoPorAnio;
    }

    public void setSumaCombustibleRecargadoPorAnio(Double sumaCombustibleRecargadoPorAnio) {
        this.sumaCombustibleRecargadoPorAnio = sumaCombustibleRecargadoPorAnio;
    }

    public Double getMaximoCombustibleMensualRecargado() {
        return maximoCombustibleMensualRecargado;
    }

    public void setMaximoCombustibleMensualRecargado(Double maximoCombustibleMensualRecargado) {
        this.maximoCombustibleMensualRecargado = maximoCombustibleMensualRecargado;
    }

    public Double getMinimoCombustibleMensualRecargado() {
        return minimoCombustibleMensualRecargado;
    }

    public void setMinimoCombustibleMensualRecargado(Double minimoCombustibleMensualRecargado) {
        this.minimoCombustibleMensualRecargado = minimoCombustibleMensualRecargado;
    }

    public Double getMaximoCombustibleAnualRecargado() {
        return maximoCombustibleAnualRecargado;
    }

    public void setMaximoCombustibleAnualRecargado(Double maximoCombustibleAnualRecargado) {
        this.maximoCombustibleAnualRecargado = maximoCombustibleAnualRecargado;
    }

    public Double getMinimoCombustibleAnualRecargado() {
        return minimoCombustibleAnualRecargado;
    }

    public void setMinimoCombustibleAnualRecargado(Double minimoCombustibleAnualRecargado) {
        this.minimoCombustibleAnualRecargado = minimoCombustibleAnualRecargado;
    }

    public Double getSumaCombustibleXKmMensual() {
        return sumaCombustibleXKmMensual;
    }

    public void setSumaCombustibleXKmMensual(Double sumaCombustibleXKmMensual) {
        this.sumaCombustibleXKmMensual = sumaCombustibleXKmMensual;
    }

    public Double getSumaCombustibleXKmAnual() {
        return sumaCombustibleXKmAnual;
    }

    public void setSumaCombustibleXKmAnual(Double sumaCombustibleXKmAnual) {
        this.sumaCombustibleXKmAnual = sumaCombustibleXKmAnual;
    }

    public Double getMinimoCombustibleXKmMensual() {
        return minimoCombustibleXKmMensual;
    }

    public void setMinimoCombustibleXKmMensual(Double minimoCombustibleXKmMensual) {
        this.minimoCombustibleXKmMensual = minimoCombustibleXKmMensual;
    }

    public Double getMinimoCombustibleXKmAnual() {
        return minimoCombustibleXKmAnual;
    }

    public void setMinimoCombustibleXKmAnual(Double minimoaCombustibleXKmAnual) {
        this.minimoCombustibleXKmAnual = minimoaCombustibleXKmAnual;
    }

    public Double getMaximoCombustibleXKmMensual() {
        return maximoCombustibleXKmMensual;
    }

    public void setMaximoCombustibleXKmMensual(Double maximoCombustibleXKmMensual) {
        this.maximoCombustibleXKmMensual = maximoCombustibleXKmMensual;
    }

    public Double getMaximoCombustibleXKmAnual() {
        return maximoCombustibleXKmAnual;
    }

    public void setMaximoCombustibleXKmAnual(Double maximoaCombustibleXKmAnual) {
        this.maximoCombustibleXKmAnual = maximoaCombustibleXKmAnual;
    }
}
