package com.example.juanalonsoastruga.cargascontrol.Datos.Entidades;

import androidx.room.Entity;
import androidx.room.ForeignKey;
import androidx.room.Ignore;
import androidx.annotation.NonNull;
@Entity(tableName = "DATOSDERIVADOSCOSTESCOMBUSTIBLE",
        primaryKeys = {  "matriculaVehiculo", "mes","anio","combustible"},
        foreignKeys = {
                @ForeignKey(entity = Vehiculo.class,
                        parentColumns = {"matricula"},
                        childColumns = {"matriculaVehiculo"},
                        onDelete = ForeignKey.CASCADE),
                @ForeignKey(entity = Combustible.class,
                        parentColumns = {"id"},
                        childColumns = {"combustible"},
                        onDelete = ForeignKey.CASCADE)
        }
)
public class DatosDerivadosCostesCombustible {

    @NonNull
    private String matriculaVehiculo;
    @NonNull
    private Integer mes;
    @NonNull
    private Integer anio;
    @NonNull
    private Integer combustible;
    /* ***************************************** */
    private Integer numeroRecargasCombustiblePorMes;

    private Integer numeroRecargasCombustiblePorAnio;
    /* ***************************************** */
    private Double sumaCosteRecargaMensual;

    private Double sumaCosteRecargaAnual;

    private Double minimoCosteRecargaMensual;

    private Double maximoCosteRecargaMensual;

    private Double minimoCosteRecargaAnual;

    private Double maximoCosteRecargaAnual;

    /* ***************************************** */
    /*Euros por litro por ejemplo*/
    private Double sumaCosteXRecargaMensual;

    private Double sumaCosteXRecargaAnual;

    private Double minimoCosteXRecargaMensual;

    private Double minimoCosteXRecargaAnual;

    private Double maximoCosteXRecargaMensual;

    private Double maximoCosteXRecargaAnual;
    /* ***************************************** */

    public DatosDerivadosCostesCombustible(@NonNull String matriculaVehiculo, @NonNull Integer mes, @NonNull Integer anio, @NonNull Integer combustible) {
        this.matriculaVehiculo = matriculaVehiculo;
        this.mes = mes;
        this.anio = anio;
        this.combustible = combustible;
    }
    @Ignore
    public DatosDerivadosCostesCombustible(@NonNull String matriculaVehiculo, @NonNull Integer mes, @NonNull Integer anio, @NonNull Integer combustible, Integer numeroRecargasCombustiblePorMes, Integer numeroRecargasCombustiblePorAnio, Double sumaCosteRecargaMensual, Double sumaCosteRecargaAnual, Double minimoCosteRecargaMensual, Double maximoCosteRecargaMensual, Double minimoCosteRecargaAnual, Double maximoCosteRecargaAnual, Double sumaCosteXKmRecargaMensual, Double sumaCosteXKmRecargaAnual, Double minimoCosteXKmRecargaMensual, Double minimoCosteXKmRecargaAnual, Double maximoCosteXKmRecargaMensual, Double maximoCosteXKmRecargaAnual, Double sumaCosteXRecargaMensual, Double sumaCosteXRecargaAnual, Double minimoCosteXRecargaMensual, Double minimoCosteXRecargaAnual, Double maximoCosteXRecargaMensual, Double maximoCosteXRecargaAnual) {
        this.matriculaVehiculo = matriculaVehiculo;
        this.mes = mes;
        this.anio = anio;
        this.combustible = combustible;
        this.numeroRecargasCombustiblePorMes = numeroRecargasCombustiblePorMes;
        this.numeroRecargasCombustiblePorAnio = numeroRecargasCombustiblePorAnio;
        this.sumaCosteRecargaMensual = sumaCosteRecargaMensual;
        this.sumaCosteRecargaAnual = sumaCosteRecargaAnual;
        this.minimoCosteRecargaMensual = minimoCosteRecargaMensual;
        this.maximoCosteRecargaMensual = maximoCosteRecargaMensual;
        this.minimoCosteRecargaAnual = minimoCosteRecargaAnual;
        this.maximoCosteRecargaAnual = maximoCosteRecargaAnual;
       this.sumaCosteXRecargaMensual = sumaCosteXRecargaMensual;
        this.sumaCosteXRecargaAnual = sumaCosteXRecargaAnual;
        this.minimoCosteXRecargaMensual = minimoCosteXRecargaMensual;
        this.minimoCosteXRecargaAnual = minimoCosteXRecargaAnual;
        this.maximoCosteXRecargaMensual = maximoCosteXRecargaMensual;
        this.maximoCosteXRecargaAnual = maximoCosteXRecargaAnual;
    }

    @NonNull
    public String getMatriculaVehiculo() {
        return matriculaVehiculo;
    }

    public void setMatriculaVehiculo(@NonNull String matriculaVehiculo) {
        this.matriculaVehiculo = matriculaVehiculo;
    }

    @NonNull
    public Integer getMes() {
        return mes;
    }

    public void setMes(@NonNull Integer mes) {
        this.mes = mes;
    }

    @NonNull
    public Integer getAnio() {
        return anio;
    }

    public void setAnio(@NonNull Integer anio) {
        this.anio = anio;
    }

    @NonNull
    public Integer getCombustible() {
        return combustible;
    }

    public void setCombustible(@NonNull Integer combustible) {
        this.combustible = combustible;
    }

    public Integer getNumeroRecargasCombustiblePorMes() {
        return numeroRecargasCombustiblePorMes;
    }

    public void setNumeroRecargasCombustiblePorMes(Integer numeroRecargasCombustiblePorMes) {
        this.numeroRecargasCombustiblePorMes = numeroRecargasCombustiblePorMes;
    }

    public Integer getNumeroRecargasCombustiblePorAnio() {
        return numeroRecargasCombustiblePorAnio;
    }

    public void setNumeroRecargasCombustiblePorAnio(Integer numeroRecargasCombustiblePorAnio) {
        this.numeroRecargasCombustiblePorAnio = numeroRecargasCombustiblePorAnio;
    }

    public Double getSumaCosteRecargaMensual() {
        return sumaCosteRecargaMensual;
    }

    public void setSumaCosteRecargaMensual(Double sumaCosteRecargaMensual) {
        this.sumaCosteRecargaMensual = sumaCosteRecargaMensual;
    }

    public Double getSumaCosteRecargaAnual() {
        return sumaCosteRecargaAnual;
    }

    public void setSumaCosteRecargaAnual(Double sumaCosteRecargaAnual) {
        this.sumaCosteRecargaAnual = sumaCosteRecargaAnual;
    }

    public Double getMinimoCosteRecargaMensual() {
        return minimoCosteRecargaMensual;
    }

    public void setMinimoCosteRecargaMensual(Double minimoCosteRecargaMensual) {
        this.minimoCosteRecargaMensual = minimoCosteRecargaMensual;
    }

    public Double getMaximoCosteRecargaMensual() {
        return maximoCosteRecargaMensual;
    }

    public void setMaximoCosteRecargaMensual(Double maximoCosteRecargaMensual) {
        this.maximoCosteRecargaMensual = maximoCosteRecargaMensual;
    }

    public Double getMinimoCosteRecargaAnual() {
        return minimoCosteRecargaAnual;
    }

    public void setMinimoCosteRecargaAnual(Double minimoCosteRecargaAnual) {
        this.minimoCosteRecargaAnual = minimoCosteRecargaAnual;
    }

    public Double getMaximoCosteRecargaAnual() {
        return maximoCosteRecargaAnual;
    }

    public void setMaximoCosteRecargaAnual(Double maximoCosteRecargaAnual) {
        this.maximoCosteRecargaAnual = maximoCosteRecargaAnual;
    }

    public Double getSumaCosteXRecargaMensual() {
        return sumaCosteXRecargaMensual;
    }

    public void setSumaCosteXRecargaMensual(Double sumaCosteXRecargaMensual) {
        this.sumaCosteXRecargaMensual = sumaCosteXRecargaMensual;
    }

    public Double getSumaCosteXRecargaAnual() {
        return sumaCosteXRecargaAnual;
    }

    public void setSumaCosteXRecargaAnual(Double sumaCosteXRecargaAnual) {
        this.sumaCosteXRecargaAnual = sumaCosteXRecargaAnual;
    }

    public Double getMinimoCosteXRecargaMensual() {
        return minimoCosteXRecargaMensual;
    }

    public void setMinimoCosteXRecargaMensual(Double minimoCosteXRecargaMensual) {
        this.minimoCosteXRecargaMensual = minimoCosteXRecargaMensual;
    }

    public Double getMinimoCosteXRecargaAnual() {
        return minimoCosteXRecargaAnual;
    }

    public void setMinimoCosteXRecargaAnual(Double minimoCosteXRecargaAnual) {
        this.minimoCosteXRecargaAnual = minimoCosteXRecargaAnual;
    }

    public Double getMaximoCosteXRecargaMensual() {
        return maximoCosteXRecargaMensual;
    }

    public void setMaximoCosteXRecargaMensual(Double maximoCosteXRecargaMensual) {
        this.maximoCosteXRecargaMensual = maximoCosteXRecargaMensual;
    }

    public Double getMaximoCosteXRecargaAnual() {
        return maximoCosteXRecargaAnual;
    }

    public void setMaximoCosteXRecargaAnual(Double maximoCosteXRecargaAnual) {
        this.maximoCosteXRecargaAnual = maximoCosteXRecargaAnual;
    }
}
