package com.example.juanalonsoastruga.cargascontrol.Datos.Entidades;

import androidx.room.Entity;
import androidx.room.ForeignKey;
import androidx.room.Ignore;
import androidx.annotation.NonNull;

@Entity(tableName = "DATOSDERIVADOSVEHICULOTOTALES",
        primaryKeys = {  "matriculaVehiculo", "mes","anio" },
        foreignKeys = {
                @ForeignKey(entity = Vehiculo.class,
                        parentColumns = {"matricula"},
                        childColumns = {"matriculaVehiculo"},
                        onDelete = ForeignKey.CASCADE)

        }
)
public class DatosDerivadosVehiculoTotales {
    @NonNull
    private String matriculaVehiculo;
    @NonNull
    private Integer mes;
    @NonNull
    private Integer anio;
    /* ***************************************** */
    //Suma de todos los combustibles
    private Integer numeroRecargasTotalesPorMes;

    private Integer numeroRecargasTotalesPorAnio;
    /* ***************************************** */
    //Suma de todos los combustibles
    private Double costeRecargasTotalesPorMes;

    private Double costeRecargasTotalesPorAnio;
    /* ***************************************** */
    //Suma de todos los combustibles
    private Double kmRecargasTotalesPorMes;

    private Double kmRecargasTotalesPorAnio;
    /* ***************************************** */

    public DatosDerivadosVehiculoTotales(@NonNull String matriculaVehiculo, @NonNull Integer anio, @NonNull Integer mes) {
        this.matriculaVehiculo = matriculaVehiculo;
        this.mes = mes;
        this.anio = anio;
    }

    @Ignore
    public DatosDerivadosVehiculoTotales(@NonNull String matriculaVehiculo, @NonNull Integer anio, @NonNull Integer mes, Integer numeroRecargasTotalesPorMes, Integer numeroRecargasTotalesPorAnio, Double costeRecargasTotalesPorMes, Double costeRecargasTotalesPorAnio, Double kmRecargasTotalesPorMes, Double kmRecargasTotalesPorAnio) {
        this.matriculaVehiculo = matriculaVehiculo;
        this.mes = mes;
        this.anio = anio;
        this.numeroRecargasTotalesPorMes = numeroRecargasTotalesPorMes;
        this.numeroRecargasTotalesPorAnio = numeroRecargasTotalesPorAnio;
        this.costeRecargasTotalesPorMes = costeRecargasTotalesPorMes;
        this.costeRecargasTotalesPorAnio = costeRecargasTotalesPorAnio;
        this.kmRecargasTotalesPorMes = kmRecargasTotalesPorMes;
        this.kmRecargasTotalesPorAnio = kmRecargasTotalesPorAnio;
    }

    @NonNull
    public String getMatriculaVehiculo() {
        return matriculaVehiculo;
    }

    public void setMatriculaVehiculo(@NonNull String matriculaVehiculo) {
        this.matriculaVehiculo = matriculaVehiculo;
    }

    @NonNull
    public Integer getMes() {
        return mes;
    }

    public void setMes(@NonNull Integer mes) {
        this.mes = mes;
    }

    @NonNull
    public Integer getAnio() {
        return anio;
    }

    public void setAnio(@NonNull Integer anio) {
        this.anio = anio;
    }

    public Integer getNumeroRecargasTotalesPorMes() {
        return numeroRecargasTotalesPorMes;
    }

    public void setNumeroRecargasTotalesPorMes(Integer numeroRecargasTotalesPorMes) {
        this.numeroRecargasTotalesPorMes = numeroRecargasTotalesPorMes;
    }

    public Integer getNumeroRecargasTotalesPorAnio() {
        return numeroRecargasTotalesPorAnio;
    }

    public void setNumeroRecargasTotalesPorAnio(Integer numeroRecargasTotalesPorAnio) {
        this.numeroRecargasTotalesPorAnio = numeroRecargasTotalesPorAnio;
    }

    public Double getCosteRecargasTotalesPorMes() {
        return costeRecargasTotalesPorMes;
    }

    public void setCosteRecargasTotalesPorMes(Double costeRecargasTotalesPorMes) {
        this.costeRecargasTotalesPorMes = costeRecargasTotalesPorMes;
    }

    public Double getCosteRecargasTotalesPorAnio() {
        return costeRecargasTotalesPorAnio;
    }

    public void setCosteRecargasTotalesPorAnio(Double costeRecargasTotalesPorAnio) {
        this.costeRecargasTotalesPorAnio = costeRecargasTotalesPorAnio;
    }

    public Double getKmRecargasTotalesPorMes() {
        return kmRecargasTotalesPorMes;
    }

    public void setKmRecargasTotalesPorMes(Double kmRecargasTotalesPorMes) {
        this.kmRecargasTotalesPorMes = kmRecargasTotalesPorMes;
    }

    public Double getKmRecargasTotalesPorAnio() {
        return kmRecargasTotalesPorAnio;
    }

    public void setKmRecargasTotalesPorAnio(Double kmRecargasTotalesPorAnio) {
        this.kmRecargasTotalesPorAnio = kmRecargasTotalesPorAnio;
    }
}
