package com.example.juanalonsoastruga.cargascontrol.Datos.Entidades;

import androidx.room.ColumnInfo;
import androidx.room.Entity;
import androidx.room.ForeignKey;
import androidx.room.Ignore;
import androidx.room.TypeConverters;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import java.util.Date;

@Entity(tableName = "RECARGA",
        primaryKeys = {"fecha", "matriculaVehiculo", "combustible"},
        foreignKeys = {
            @ForeignKey(entity = Vehiculo.class,
                    parentColumns = {"matricula"},
                    childColumns = {"matriculaVehiculo"},
                    onDelete = ForeignKey.CASCADE),
            @ForeignKey(entity = Combustible.class,
                    parentColumns = {"id"},
                    childColumns = {"combustible"},
                    onDelete = ForeignKey.CASCADE)
        }
)



public class Recarga {
    @NonNull
    @TypeConverters({DateConverter.class})
    private Date fecha;
    @Nullable
    private Double kilometraje;
    @NonNull
    private Double coste;
    @NonNull
    private Double combustibleRecargado;
    @NonNull
    private String matriculaVehiculo;
    @NonNull
    private Integer combustible;

    @Nullable
    @ColumnInfo(typeAffinity = ColumnInfo.BLOB)
    private byte[] foto;


    public Recarga(Date fecha , @NonNull String matriculaVehiculo, @NonNull Integer combustible) {
        this.fecha = fecha;
        this.matriculaVehiculo = matriculaVehiculo;
        this.combustible = combustible;

    }
    @Ignore
    public Recarga(Date fecha, @NonNull Double kilometraje, @NonNull Double coste, @NonNull Double combustibleRecargado, @NonNull String matriculaVehiculo, @NonNull Integer combustible, @Nullable byte[] foto) {
        this.fecha = fecha;
        this.kilometraje = kilometraje;
        this.coste = coste;
        this.combustibleRecargado = combustibleRecargado;
        this.matriculaVehiculo = matriculaVehiculo;
        this.combustible = combustible;
        this.foto = foto;
    }



    public Date getFecha() {
        return fecha;
    }

    @NonNull
    public String getMatriculaVehiculo() {
        return matriculaVehiculo;
    }

    @NonNull
    public Double getKilometraje() {
        return kilometraje;
    }

    @NonNull
    public Double getCoste() {
        return coste;
    }

    @NonNull
    public Double getCombustibleRecargado() {
        return combustibleRecargado;
    }

    @Nullable
    public byte[] getFoto() {
        return foto;
    }

    @NonNull
    public Integer getCombustible() {
        return combustible;
    }

    public void setCombustible(@NonNull Integer combustible) {
        this.combustible = combustible;
    }

    public void setFecha(Date fecha) {
        this.fecha = fecha;
    }

    public void setMatriculaVehiculo(@NonNull String matriculaVehiculo) {
        this.matriculaVehiculo = matriculaVehiculo;
    }

    public void setKilometraje(@NonNull Double kilometraje) {
        this.kilometraje = kilometraje;
    }

    public void setCoste(@NonNull Double coste) {
        this.coste = coste;
    }

    public void setCombustibleRecargado(@NonNull Double combustibleRecargado) {
        this.combustibleRecargado = combustibleRecargado;
    }

    public void setFoto(@Nullable byte[] foto) {
        this.foto = foto;
    }
}
