package com.example.juanalonsoastruga.cargascontrol.Datos.Entidades;

import androidx.room.*;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;


@Entity(tableName = "VEHICULO",
        foreignKeys = {
        @ForeignKey(entity = Combustible.class,
                parentColumns = {"id"},
                childColumns = {"combustiblePrimario"},
                onDelete = ForeignKey.CASCADE),
        @ForeignKey(entity = Combustible.class,
        parentColumns = {"id"},
        childColumns = {"combustibleSecundario"},
        onDelete = ForeignKey.CASCADE)},
        primaryKeys = {
        "matricula"
        })
public class Vehiculo {

    @NonNull
    private String matricula;
    @NonNull
    private String nombre;
    @Nullable
    private String marca;
    @Nullable
    private String modelo;
    @Nullable
    private Integer año;
    @Nullable
    private Double kilometraje;
    @NonNull
    private Integer combustiblePrimario;
    @Nullable
    private Integer combustibleSecundario;


    @Nullable
    private Double capTankPrimario;
    @Nullable
    private Double capTankSecundario;
    @Nullable
    @ColumnInfo(typeAffinity = ColumnInfo.BLOB)
    private byte[] foto;


    public Vehiculo(@NonNull String matricula,@NonNull String nombre,@NonNull Integer cPrimario){
        this.matricula=matricula;
        this.nombre=nombre;
        this.combustiblePrimario=cPrimario;
    }


    public Vehiculo(@NonNull String matricula, @NonNull String nombre, String marca, String modelo, Integer año, Double kilometraje, @NonNull Integer combustiblePrimario, Integer combustibleSecundario, Double capTankPrimario, Double capTankSecundario, byte[] foto) {
        this.matricula = matricula;
        this.nombre = nombre;
        this.marca = marca;
        this.modelo = modelo;
        this.año = año;
        this.kilometraje = kilometraje;
        this.combustiblePrimario = combustiblePrimario;
        this.combustibleSecundario = combustibleSecundario;
        this.capTankPrimario = capTankPrimario;
        this.capTankSecundario = capTankSecundario;
        this.foto = foto;
    }

    @NonNull
    public String getNombre() {
        return nombre;
    }

    public void setNombre(@NonNull String nombre) {
        this.nombre = nombre;
    }

    public String getMarca() {
        return marca;
    }

    public void setMarca(String marca) {
        this.marca = marca;
    }

    public String getModelo() {
        return modelo;
    }

    public void setModelo(String modelo) {
        this.modelo = modelo;
    }

    public Integer getAño() {
        return año;
    }

    public void setAño(Integer año) {
        this.año = año;
    }

    @NonNull
    public String getMatricula() {
        return matricula;
    }

    public void setMatricula(@NonNull String matricula) {
        this.matricula = matricula;
    }

    public Double getKilometraje() {
        return kilometraje;
    }

    public void setKilometraje(Double kilometraje) {
        this.kilometraje = kilometraje;
    }

    @NonNull
    public Integer getCombustiblePrimario() {
        return combustiblePrimario;
    }

    public void setCombustiblePrimario(@NonNull Integer combustiblePrimario) {
        this.combustiblePrimario = combustiblePrimario;
    }

    public Integer getCombustibleSecundario() {
        return combustibleSecundario;
    }

    public void setCombustibleSecundario(Integer combustibleSecundario) {
        this.combustibleSecundario = combustibleSecundario;
    }

    public Double getCapTankPrimario() {
        return capTankPrimario;
    }

    public void setCapTankPrimario(Double capTankPrimario) {
        this.capTankPrimario = capTankPrimario;
    }

    public Double getCapTankSecundario() {
        return capTankSecundario;
    }

    public void setCapTankSecundario(Double capTankSecundario) {
        this.capTankSecundario = capTankSecundario;
    }

    public byte[] getFoto() {
        return foto;
    }

    public void setFoto(byte[] foto) {
        this.foto = foto;
    }
}
