package com.example.juanalonsoastruga.cargascontrol.Datos.GasolinerasProvider;

import android.util.Log;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class GasolineraHandler extends DefaultHandler {
    private StringBuilder sbText;

    private DTOGasolinera gasolinera;
    private boolean etiquetaApertura=false;
    private boolean cumpleRequisitos=false;
    private double latitud;
    private double longitud;
    private String direccion;

    public GasolineraHandler(double latitud,double longitud,String direccion){
        super();
        this.latitud=latitud;
        this.longitud=longitud;
        this.direccion=direccion;
    }

    public DTOGasolinera getGasolinera(){
        return gasolinera;
    }

    @Override
    public void startDocument() throws SAXException {

        super.startDocument();
        sbText = new StringBuilder();
    }

    @Override
    public void startElement(String uri, String localId, String name, Attributes attributes) throws SAXException {

        super.startElement(uri, localId, name, attributes);

        if (localId.equals("EESS")) {
            etiquetaApertura=true;
        }
    }

    @Override
    public void characters(char[] ch, int start, int length)
            throws SAXException {

        super.characters(ch, start, length);

        if (etiquetaApertura)
            sbText.append(ch, start, length);
    }

    @Override
    public void endElement(String uri, String localName, String id)
            throws SAXException {

        super.endElement(uri, localName, id);

        String campo;

        if (etiquetaApertura) {

            if (localName.equals("Direccion")) {
                campo = (sbText.toString().trim());
               System.out.println("DIRECCION "+campo);
                System.out.println("Igualdad "+campo.contains(direccion));
                if (campo.contains(direccion)) {
                    cumpleRequisitos =true;
                    gasolinera = new DTOGasolinera();
                    gasolinera.setDireccion(campo);

                } else {
                    cumpleRequisitos = cumpleRequisitos & false;
                }
            } else if (cumpleRequisitos &&localName.equals("Horario")) {
                campo = (sbText.toString().trim());
                gasolinera.setHorario(campo);
            } else if (cumpleRequisitos &&localName.equals("Latitud")) {
                campo = (sbText.toString().trim());

                try {
                    campo = campo.replace(',', '.');
                    double cantidad = Double.parseDouble(campo);
                    gasolinera.setLatitud(cantidad);
                } catch (NumberFormatException nfe) {
                    cumpleRequisitos = cumpleRequisitos & false;
                }

            } else if (cumpleRequisitos && localName.equals("Localidad")) {
                campo = (sbText.toString().trim());
                gasolinera.setLocalidad(campo);
            } else if (cumpleRequisitos && localName.equals("Longitud")) {
                campo = (sbText.toString().trim());
                try {
                    campo = campo.replace(',', '.');
                    double cantidad = Double.parseDouble(campo);
                    cumpleRequisitos = cumpleRequisitos & true;
                    gasolinera.setLongitud(cantidad);

                    gasolinera.setKm(convierteAKm(gasolinera.getLatitud(), gasolinera.getLongitud()));
                } catch (NumberFormatException nfe) {
                    cumpleRequisitos = cumpleRequisitos & false;
                }

            } else if (cumpleRequisitos && localName.equals("Municipio")) {
                campo = (sbText.toString().trim());
                gasolinera.setMunicipio(campo);
            } else if (cumpleRequisitos && localName.equals("Biodiesel")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setBiodiesel();
                }
            } else if (cumpleRequisitos && localName.equals("Bioetanol")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setBioetanol();
                }
            } else if (cumpleRequisitos && localName.equals("GasNaturalComprimido")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasNaturalComprimido();
                }
            } else if (cumpleRequisitos && localName.equals("GasNaturalLicuado")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasNaturalLicuado();
                }
            } else if (cumpleRequisitos && localName.equals("Gaseslicuadosdelpetroleo")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasLicuadoPetroleo();
                }
            } else if (cumpleRequisitos && localName.equals("GasoleoA")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasoleoA();
                }
            } else if (cumpleRequisitos && localName.equals("GasoleoB")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasoleoB();
                }
            } else if (cumpleRequisitos && localName.equals("Gasolina95Proteccion")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasolina95();
                }
            } else if (cumpleRequisitos && localName.equals("Gasolina98")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setGasolina98();
                }
            } else if (cumpleRequisitos && localName.equals("NuevoGasoleoA")) {
                campo = (sbText.toString().trim());
                if (campo.equals("true")) {
                    gasolinera.setNuevoGasoleoA();
                }
            } else if (cumpleRequisitos && localName.equals("Provincia")) {
                campo = (sbText.toString().trim());
                gasolinera.setProvincia(campo);
            } else if (cumpleRequisitos && localName.equals("Rotulo")) {
                campo = (sbText.toString().trim());
                gasolinera.setRotulo(campo);
            } else if (cumpleRequisitos && localName.equals("EESS")) {
                etiquetaApertura=false;
                cumpleRequisitos=true;
            }
            sbText.setLength(0);



        }
    }

        private double convierteAKm(double latitud1,double longitud1){
            //Para hacer esto se debe usar la formula del haversine para poder tener en cuenta el error
            //introducido por la curvatura de la Tierra al calcular la distancia entre dos puntos.

            //KM del radio de la Tierra en el  ecuador
            int radio = 6371;

            double c1=calcularDistanciaEnRadianes(latitud,latitud1);
            double c2=calcularDistanciaEnRadianes(longitud,longitud1);

            //haversin(distancia entre puntos/ radio esfera) = haversin(diferencia de latitudes)+cos(latitud1)*cos(latitud2)
            //*haversin(diferencia de longitudes)



            double a = Math.sin(c1 / 2) * Math.sin(c1 / 2)
                    + Math.cos(Math.toRadians(latitud)) * Math.cos(Math.toRadians(latitud1))
                    * Math.sin(c2 / 2) * Math.sin(c2 / 2);
            double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
            double distance = radio * c ;
            return distance;
        }

        private double calcularDistanciaEnRadianes(double p1, double p2){

            return Math.toRadians(p1-p2);
        }
}
