package com.example.juanalonsoastruga.cargascontrol.Datos.GasolinerasProvider;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;

import java.io.InputStream;
import java.util.List;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

/**
 * Clase GasolinerasParser, parsea el documento de estaciones de recarga.
 *
 */
public class GasolinerasParser {

    private InputStream is;

    /**
     * Constructor de clase.
     *
     * @param is InputStream hacia el archivo a parsear
     */
    public GasolinerasParser(InputStream is)
    {
        this.is =is;
    }

    public List<DTOGasolinera> parse(double minLatitud,double maxLatitud,double minLongitud,double maxLongitud,double latitud,double longitud,int numElementos) {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try
        {
            SAXParser parser = factory.newSAXParser();
            GasolinerasHandler handler = new GasolinerasHandler( minLatitud, maxLatitud, minLongitud, maxLongitud,latitud,longitud,numElementos);
            //Parsea el archivo del inputstream con el manejador proporcionado
            parser.parse( is,  handler);

            return handler.getGasolineras();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
    }

    private InputStream getInputStream()
    {
        return is;
    }


}
