package com.example.juanalonsoastruga.cargascontrol.Datos.GasolinerasProvider;

import android.content.Context;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.R;

import java.io.InputStream;
import java.util.List;


/**
 * Clase GasolinerasProvider, proveedor de la informacion concerniente a las estaciones de recarga nacionales.
 *
 */

public class GasolinerasProvider implements InterfaceGasolinerasProvider {

    private Context cntxt;

    private final int numMaximoElementos=5;
    /**
     * Constructor de clase.
     *
     * @param c Context
     */
    public GasolinerasProvider(Context c){
        this.cntxt=c;
    }

    /**
     * Metodo descargaListado, obtiene el conjunto de datos de las estaciones de recarga
     *
     *
     */
    @Override
    public List<DTOGasolinera> descargaListado(double minLatitud,double maxLatitud,double minLongitud,double maxLongitud,double latitud,double longitud) {

        InputStream is = cntxt.getResources().openRawResource(R.raw.estacionesrecarga);

        GasolinerasParser parser = new GasolinerasParser(is);

        List<DTOGasolinera> gasolineras = parser.parse(minLatitud,maxLatitud,minLongitud,maxLongitud,latitud,longitud,numMaximoElementos);

        return gasolineras;
    }

    @Override
    public DTOGasolinera descargaGasolinera(double latitud,double longitud,String direccion) {
        InputStream is = cntxt.getResources().openRawResource(R.raw.estacionesrecarga);
        GasolineraParser parser = new GasolineraParser(is);
        DTOGasolinera gasolinera= parser.parse(latitud,longitud,direccion);
        return gasolinera;
    }


}
