package com.example.juanalonsoastruga.cargascontrol.Datos;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOCombustible;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTODatosDerivadosCombustible;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTODatosDerivadosCostesCombustible;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTODatosDerivadosVehiculoTotales;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;

import java.util.Date;
import java.util.Hashtable;
import java.util.List;

public interface InterfaceFachadaDatos {

    List<DTOVehiculo> getVehiculos();
    List<DTOVehiculo> getIdentificadoresVehiculos();

    boolean borradoVehiculo(String matricula);

    List<DTOCombustible> getCombustibles();

    boolean setVehiculo(DTOVehiculo vehiculo);

    boolean isReady();

    DTOVehiculo getVehiculo(String matricula);

    boolean actualizaVehiculo(DTOVehiculo vehiculo);

    boolean isVehiculoRegistrado(DTOVehiculo vehiculo);

    boolean isVehiculoRegistrado(String matricula);

    List<DTORecarga> getListadoRecargas(String matricula);

    DTORecarga getRecarga(String matricula, Date fecha, String combustible);

    void setRecarga(DTORecarga recarga);

    List<DTORecarga> getRecargasEnPeriodoPorCombustibleyVehiculo(String matricula, String combustible, Date primerDia, Date ultimoDia);

    DTORecarga getLastRecargaBefore(String matricula,Date dateIni,String combustible);

    DTORecarga getLastRecargaPorCombustible(String matricula, String combustible);

    DTODatosDerivadosVehiculoTotales getDDerivadosVehiculo(String matricula, int anio, int mes);

    DTODatosDerivadosVehiculoTotales getUltimoRegistroDDerivadosVehiculo(String matricula);

    void registraDatosDerivadosVehiculo(DTODatosDerivadosVehiculoTotales ddv);

    void actualizaDatosDerivadosVehiculo(DTODatosDerivadosVehiculoTotales ddv);

    DTODatosDerivadosCombustible getDDerivadosCombustible(String matricula, int year, int month, String combustible);

    DTODatosDerivadosCombustible getUltimoRegistroDDerivadosCombustible(String matricula, String combustible);

    void registraDatosDerivadosCombustible(DTODatosDerivadosCombustible ddv);

    void actualizaDatosDerivadosCombustible(DTODatosDerivadosCombustible ddv);

    DTODatosDerivadosCostesCombustible getDDerivadosCosteCombustible(String matricula, int year, int month, String combustible);

    DTODatosDerivadosCostesCombustible getUltimoRegistroDDerivadosCosteCombustible(String matricula, String combustible);

    void actualizaDatosDerivadosCosteCombustible(DTODatosDerivadosCostesCombustible ddv);

    void registraDatosDerivadosCosteCombustible(DTODatosDerivadosCostesCombustible ddv);

    DTORecarga getLastRecargaBefore(String matricula,Date date);

    void registraIDUltimoVehiculo(String matricula);

    void registraIDUltimaRecarga(Long fecha,String matricula,String combustible);

    Hashtable getLocalizacionActual(Hashtable localizacion);

    List<DTOGasolinera> getEstacionesRecargaNacionales(Hashtable coordenadas);

    DTOGasolinera getDTOGasolinera(double latitud,double longitud,String direccion);

    Hashtable getIdUltimaRecarga();

    String getIdUltimoVehiculo();


    void borrarFicheroVehiculo();

    void borrarFicheroRecarga();
}
