package com.example.juanalonsoastruga.cargascontrol.Datos.LocationProvider;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import java.util.Hashtable;

/**
 * Clase LocationProvider, provee de la latitud y longitud actuales del dispositivo.
 *
 */
public class LocationProvider implements InterfaceLocationProvider {

    private Context cntxt;

    /**
     * Constructor de clase.
     *
     * @param cntxt Context
     */
    public LocationProvider (Context cntxt){
        this.cntxt=cntxt;
    }

    /**
     * Devuelve una estructura de datos con la latitud y longitud actuales en grados decimales.
     *
     * @param localizacion  Hashtable
     * @return Hashtable con latitud y longitud como claves
     */
    public Hashtable getLocalizacionActual(Hashtable localizacion) {

        LocationService gps = new LocationService(this.cntxt);

        try {
            double latitud=gps.getLatitude();
            double longitud=gps.getLongitude();
            Log.d("TAGDEBUG","latitud: "+ latitud);
            Log.d("TAGDEBUG","longitud: "+ longitud);
            localizacion.put("latitud",latitud) ;
            localizacion.put("longitud",longitud) ;

        }catch (Exception e){
            Log.d("LOCATIONPROVIDER","ERROR:");
            e.printStackTrace();
        }
        return localizacion;
    }
}
