package com.example.juanalonsoastruga.cargascontrol.Datos.UltimaConsultaProvider;

import android.content.Context;

import com.example.juanalonsoastruga.cargascontrol.R;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.Hashtable;

public class UltimaConsultaProvider implements InterfaceUltimaConsultaProvider {

    private Context cntxt;

    public UltimaConsultaProvider(Context cntxt){
        this.cntxt=cntxt;
    }

    @Override
    public Hashtable getIdUltimaRecarga(){
        String fichero = cntxt.getResources().getString(R.string.ficheroUltimaRecargaConsultada);

        InputStream is = null;
        Hashtable idrecarga = null;
        try {
            is = cntxt.openFileInput(fichero);
            UltimaConsultaParser parser = new UltimaConsultaParser(is);
            idrecarga = parser.parseRecarga();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return idrecarga;
    }
    @Override
    public void setUltimaRecarga(String matricula,String combustible,Long fecha){
        FileOutputStream fOut=null;
        String fichero = cntxt.getResources().getString(R.string.ficheroUltimaRecargaConsultada);
        try {
            //Escribe nuevo contenido a almacenamiento interno de la aplicacion borrando el anterior
            fOut = cntxt.openFileOutput(fichero,Context.MODE_PRIVATE);
            String contenido="<?xml version=\"1.0\" encoding=\"utf-8\"?> <Campo> <id>"+matricula+"</id> <fecha>"+fecha+"</fecha> <combustible>"+combustible+"</combustible> </Campo>";
            fOut.write(contenido.getBytes());
            fOut.close();
            fOut.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public String getUltimoVehiculo(){
        String fichero = cntxt.getResources().getString(R.string.ficheroUltimoVehiculoConsultado);

        InputStream is = null;
        String idvehiculo = null;
        try {
            is = cntxt.openFileInput(fichero);
            UltimaConsultaParser parser = new UltimaConsultaParser(is);
            idvehiculo = parser.parseVehiculo();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return idvehiculo;

    }


    @Override
    public void setUltimoVeiculo(String matricula){
        FileOutputStream fOut=null;
        String fichero =cntxt.getResources().getString(R.string.ficheroUltimoVehiculoConsultado);
        try {

            //Escribe nuevo contenido a almacenamiento interno de la aplicacion borrando el anterior
            fOut = cntxt.openFileOutput(fichero,Context.MODE_PRIVATE);
            String contenido="<?xml version=\"1.0\" encoding=\"utf-8\"?> <Campo> <id>"+matricula+"</id> </Campo>";
            fOut.write(contenido.getBytes());
            fOut.close();
            fOut.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    @Override
    public void borraFicheroVehiculo() {
        FileOutputStream fOut=null;
        String fichero =cntxt.getResources().getString(R.string.ficheroUltimoVehiculoConsultado);
        try {

            //Escribe nuevo contenido a almacenamiento interno de la aplicacion borrando el anterior
            fOut = cntxt.openFileOutput(fichero,Context.MODE_PRIVATE);
            String contenido="<?xml version=\"1.0\" encoding=\"utf-8\"?> <Campo> <id>"+"null"+"</id> </Campo>";
            fOut.write(contenido.getBytes());
            fOut.close();
            fOut.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void borrarFicheroRecarga() {
        FileOutputStream fOut=null;
        String fichero = cntxt.getResources().getString(R.string.ficheroUltimaRecargaConsultada);
        try {
            //Escribe nuevo contenido a almacenamiento interno de la aplicacion borrando el anterior
            fOut = cntxt.openFileOutput(fichero,Context.MODE_PRIVATE);
            String contenido="<?xml version=\"1.0\" encoding=\"utf-8\"?> <Campo> <id>"+"null"+"</id> <fecha>"+"null"+"</fecha> <combustible>"+"null"+"</combustible> </Campo>";
            fOut.write(contenido.getBytes());
            fOut.close();
            fOut.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
