package com.example.juanalonsoastruga.cargascontrol.Datos.UltimaConsultaProvider;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.util.Hashtable;

public class UltimaRecargaHandler extends DefaultHandler {
    private StringBuilder sbText;
    private boolean etiquetaApertura=false;
    private Hashtable idRecarga;

    public Hashtable getUltimaRecarga(){
        return idRecarga;
    }


    @Override
    public void startDocument() throws SAXException {

        super.startDocument();
        sbText = new StringBuilder();
        idRecarga= new Hashtable();
    }

    @Override
    public void startElement(String uri, String localId, String name, Attributes attributes) throws SAXException {

        super.startElement(uri, localId, name, attributes);

        if (localId.equals("Campo")) {
            etiquetaApertura=true;
        }
    }
    @Override
    public void characters(char[] ch, int start, int length)
            throws SAXException {

        super.characters(ch, start, length);

        if (etiquetaApertura)
            sbText.append(ch, start, length);
    }
    @Override
    public void endElement(String uri, String localName, String id)
            throws SAXException {

        super.endElement(uri, localName, id);

        String campo;

        if (etiquetaApertura) {

            if (localName.equals("id")) {
                campo = (sbText.toString().trim());
                idRecarga.put("id",campo);
            }else if(localName.equals("fecha")){
                campo = (sbText.toString().trim());
                idRecarga.put("fecha",campo);
            }else if(localName.equals("combustible")) {
                campo = (sbText.toString().trim());
                idRecarga.put("combustible",campo);
            }
            sbText.setLength(0);


        }
    }
}
