package com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimaRecarga;

import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimaRecarga.ControladorConsultarUltimaRecarga;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimaRecarga.InterfaceCConsultarUltimaRecarga;

import java.util.Hashtable;

/**
 * Clase FormateadorConsultarUltimaRecarga, representa el formateador del CU  Consultar Ultima Recarga.
 */
public class FormateadorConsultarUltimaRecarga implements InterfaceFConsultarUltimaRecarga, InterfaceFConsultarUltimaRecargaImpl {


    private InterfaceCConsultarUltimaRecarga controlador;
    private Hashtable idRecarga;

    /**
     * Constructor de clase.
     */
    public FormateadorConsultarUltimaRecarga(){
        setControlador(new ControladorConsultarUltimaRecarga(this));
    }

    /**
     * Metodo setControler, establece el controlador asociado a este formateador.
     *
     * @param controlador objeto InterfaceCConsultarUltimaRecarga
     * @throws  IllegalArgumentException si el argumento es nulo
     */
    @Override
    public void setControlador(InterfaceCConsultarUltimaRecarga controlador) {
        if(controlador ==null){
            throw new IllegalArgumentException();
        }else{
            this.controlador = controlador;
        }

    }

    /**
     * Metodo InterfaceCConsultarUltimaRecarga, devuelve el controlador asociado al formateador.
     *
     * @return un objeto InterfaceCConsultarUltimaRecarga
     */
    @Override
    public InterfaceCConsultarUltimaRecarga getControlador(){
        return controlador;
    }


    /**
     * Metodo eventoInicio, evento para avisar al controlador del comienzo de la ejecucion del CU.
     *
     */
    @Override
    public void eventoInicio() {
        controlador.eventoInicio();
    }

    /**
     * Metodo setIdRecarga, establece el id de recarga para el formateador.
     *
     * @param id Objeto Hashtable con la tabla de identificadores del id (matricula, fecha y combustible)
     */
    @Override
    public void setIdRecarga(Hashtable id){
        this.idRecarga=id;
    }
    /**
     * Devuelve el id formateado de la ultima recarga consultada.
     *
     * @return objeto Hashtable con la informacion que constituye el id (matricula, fecha y combustible)
     *
     */
    @Override
    public Hashtable getIdRecarga() {
            return idRecarga;
    }

    /**
     * Metodo borraFichero, borra el fichero de recarga asociado.
     *
     */
    @Override
    public void borraFichero() {
        controlador.borraFichero();
    }


}
