package com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoRecargas;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoRecargas.ControladorMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoRecargas.InterfaceCMostrarListadoRecargas;

import java.util.ArrayList;
import java.util.List;

/**
 * Clase FormateadorMostrarListadoRecargas, representa al formateador en el Caso de Uso Mostrar Listado de Recargas de un Vehiculo.
 *
 */
public class FormateadorMostrarListadoRecargas implements InterfaceFMostrarListadoRecargas, InterfaceFMostrarListadoRecargasImpl {

    private InterfaceCMostrarListadoRecargas controlador;
    private List<PostDataRecarga> datosVista;
    /**
     * Constructor de clase.
     *
     */
    public FormateadorMostrarListadoRecargas(){
        setControlador(new ControladorMostrarListadoRecargas(this));
    }

    /**
     * Metodo getControler, devuelve el controlador asociado con este formateador.
     *
     * @return Un Objeto InterfaceCMostrarListadoRecargas
     */
    public InterfaceCMostrarListadoRecargas getControlador(){
        return controlador;
    }

    /**
     * Metodo setControler, asocia un controlador a este formateador.
     *
     * @param controlador Un Objeto InterfaceCMostrarListadoRecargas
     * @throws IllegalArgumentException si el argumento es null
     */
    public void setControlador(InterfaceCMostrarListadoRecargas controlador){
        if(controlador==null){
            throw new IllegalArgumentException();
        }else {
            this.controlador =controlador;}
    }

    /**
     * Metodo init, indica al formateador que debe despertar al controlador asociado para comenzar la ejecución
     * del caso de uso.
     *
     * @param matricula Un Objeto String con la matricula del vehiculo cuyas recargas se listan
     * @throws IllegalArgumentException si el argumento es null
     */
    @Override
    public void init(String matricula){
        if(matricula==null){
            throw new IllegalArgumentException();
        }else {

            controlador.comienzoCU(matricula);
        }
    }

    /**
     * Metodo setListado, establece el listado de recargas asociadas al vehiculo seleccionado.
     *
     * @param recargas  Un Objeto List<DTORecarga>
     * @throws IllegalArgumentException si el argumento es null
     */
    @Override
    public void setListado(List<DTORecarga> recargas) {
        if(recargas==null){
            throw new IllegalArgumentException();
        }else {
            List<PostDataRecarga> datosvista = new ArrayList<PostDataRecarga>(0);
            PostDataRecarga tmpData;
            DTORecarga tmp;

                for (int i = 0; i < recargas.size(); i++) {
                    tmp = recargas.get(i);
                    tmpData = new PostDataRecarga(tmp);
                    datosvista.add(tmpData);
                }

                datosVista = datosvista;

        }
    }

    /**
     * Metodo getDatosVista, devuelve el listado de recargas del vehiculo a mostrar.
     *
     * @return  Un Objeto List<DTORecarga>
     */
    public List<PostDataRecarga> getDatosVista() {
        return datosVista;
    }

}
