package com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos;


import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoVehiculos.ControladorMostrarListadoVehiculos;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoVehiculos.InterfaceCMostrarListado;

import java.util.ArrayList;
import java.util.List;


/**
 * Clase FormateadorMostrarListadoVehiculos, actua como Formateador, dentro del patron MVP, del CU
 * Mostrar Listado de Vehiculos Registrados.
 *
 */
public class FormateadorMostrarListadoVehiculos implements InterfaceFMostrarListado, InterfaceFMostrarListadoImpl {
    private static final String TAG = "FormateadorMostrarListadoVehiculos";
    private InterfaceCMostrarListado controlador;
    private List<PostData> idsvehiculos;

    /**
     * Costructor de la clase  FormateadorMostrarListadoVehiculos.
     *
     */
    public FormateadorMostrarListadoVehiculos(){ setControler(new ControladorMostrarListadoVehiculos(this));}


    /**
     * Metodo comienzoCU, inicia la ejecución del caso de uso.
     */
    @Override
    public void init() {


        controlador.inicio();

    }


    /**
     * Metodo setControler, establece el Controlador para esta vista segun el patron MVP.
     *
     * @throws IllegalArgumentException
     * @param controler Un objeto que implemente InterfaceCMostrarListado
     */
    @Override
    public void setControler(InterfaceCMostrarListado controler){
        if(controler==null) {
            throw new IllegalArgumentException();
        }else{
            this.controlador =controler;
        }
    }

    /**
     * Metodo getControler, devuelve el objeto asignado como el Controlador del patron MVP.
     *
     * @return  Un objeto que implemente InterfaceCMostrarListado
     */
    @Override
    public InterfaceCMostrarListado getControler() {
        return controlador;
    }

    /**
     * Metodo setIdsvehiculos, dado un listado de vehiculos usa estos datos
     * para establecer la representacion visual del listado de vehiculos.
     *
     * @param ids   Un listado de DTOVehiculo con los datos para cada vehiculo
     */
    @Override
    public void setIdsvehiculos(List<DTOVehiculo> ids) {


        List<PostData> datosvista= new ArrayList<PostData>(0);
        DTOVehiculo tmpVehiculo;
        PostData tmpData;
        if(ids!=null)
            for(int i=0;i<ids.size();i++){
                tmpVehiculo=ids.get(i);
                tmpData= new PostData(tmpVehiculo);
                datosvista.add(tmpData);
            }
        idsvehiculos=datosvista;

    }


    /**
     * Metodo getListadoIds, devuelve un listado de datos de vehiculos registrados que
     * estan listos para mostrarse en la vista.
     *
     * @return  idsvehiculos, el listado de datos formateado para la vista
     */
    @Override
    public List<PostData> getListadoIds() {


        return idsvehiculos;
    }
}
