package com.example.juanalonsoastruga.cargascontrol.Modelo.CUBorrarVehiculo;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

public class ModeloBorrarVehiculo implements InterfaceMBorradoVehiculo {
    private InterfaceFachadaDatos datos;
    public ModeloBorrarVehiculo(){
        setRepo();
    }
    /**
     * Metodo setRepo, establee el repositorio de datos del modelo
     *
     * @param d El objeto que representa al repositorio de datos
     */
    @Override
    public void setRepo(InterfaceFachadaDatos d){
        if(d==null)
            datos= FachadaDatos.instancia();
        else
            datos=d;
    }

    /**
     * Metodo setRepo, establee un repositorio de datos del modelo
     *
     */
    @Override
    public void setRepo(){
            datos= FachadaDatos.instancia();
    }

    /**
     * Metodo getRepo, devuelve un objeto representacion del repositorio de datos
     *
     * @return El objeto representacion del repositorio de datos
     */
    @Override
    public InterfaceFachadaDatos getRepo(){
        return datos;
    }

    /**
     * Metodo borrarVehiculo, borra el vehiculo cuya matricula se ha especificado
     *
     * @param matricula Un String con la matricula del vehiculo
     * @return true, si exito, false en caso contrario
     */
    @Override
    public boolean borrarVehiculo(String matricula) {
        datos.borradoVehiculo(matricula);
        return true;
    }
}
