package com.example.juanalonsoastruga.cargascontrol.Modelo.CUCalcularCosteTrayecto;

/**
 * Clase ModeloCalcularCosteTrayecto, representa el modelo del CU  Calcular Coste del Trayecto
 *
 */
public class ModeloCalcularCosteTrayecto implements InterfaceMCalcularCosteTrayecto {


    /**
     * Cosntructor de clase.
     *
     */
    public ModeloCalcularCosteTrayecto(){

    }

    /**
     * Metodo calculaFactorPrecioKilometro, obtiene el calculo del precio por kilometro recorrido.
     *
     * @param precio    double con el precio por unidad de recarga
     * @param consumo   double con el consumo por kilometro
     * @return double con el factor precio por kilometro recorrido
     */
    @Override
    public double calculaFactorPrecioKilometro(double precio, double consumo) {
        //(Precio/l) * (l/km) = Precio/km
        return precio*consumo;
    }

    /**
     * Metodo calculaPrecioDistancia, obtiene el resultado del calculo del precio por la distancia a recorrer.
     *
     * @param precioXKm double con el factor precio por kilometro recorrido
     * @param distancia double con la distancia en km a recorrer
     * @return
     */
    @Override
    public double calculaPrecioDistancia(double precioXKm, double distancia) {
        // ( Precio/km) * km = Precio
        return precioXKm*distancia;
    }
}
