package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarPosicionMapa;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import java.util.Hashtable;

/**
 * Clase ModeloConsultarPosicionMapa, representa al modelo en el CU Consultar Posicion Actual en Mapa
 *
 */
public class ModeloConsultarPosicionMapa implements InterfaceMConsultarPosicionMapa {

    private InterfaceFachadaDatos datos;

    /**
     * Cosntrcutor de clase.
     *
     */
    public ModeloConsultarPosicionMapa(){
        setRepo();
    }

    /**
     * Metodo getDatos, devuelve la instancia asociada del repositorio de datos.
     *
     * @return InterfaceFachadaDatos
     */
    @Override
    public InterfaceFachadaDatos getDatos() {
        return datos;
    }


    /**
     * Metodo setRepo, establee el repositorio de datos del modelo
     *
     * @param d El objeto que representa al repositorio de datos
     * @throws IllegalArgumentException si el arguemnto es nulo
     */
    @Override
    public void setRepo(InterfaceFachadaDatos d){
        if(d==null){
            throw new IllegalArgumentException();
        }else{
            this.datos=d;
        }
    }
    /**
     * Metodo setRepo, establee un repositorio de datos del modelo
     *
     */
    @Override
    public void setRepo(){
        this.datos= FachadaDatos.instancia();
    }
    /**
     * Metodo getRepo, devuelve un objeto representacion del repositorio de datos
     *
     * @return El objeto representacion del repositorio de datos
     */
    @Override
    public InterfaceFachadaDatos getRepo(){
        return datos;
    }


    /**
     * Metodo consultarPosicionActual, obtiene la latitud y longitud actual del dipositivo.
     *
     * @return  Hashtable   con las claves longitud y latitud para los correspondientes valores
     */
    @Override
    public Hashtable consultarPosicionActual() {
        return datos.getLocalizacionActual(new Hashtable());
    }
}
