package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarUltimaRecarga;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import java.util.Hashtable;

/**
 * Clase ModeloConsultarUltimaRecarga, representa al modelo  del caso de uso consultar ultima recarga
 *
 */
public class ModeloConsultarUltimaRecarga implements InterfaceMConsultarUltimaRecarga {

    private InterfaceFachadaDatos datos;

    /**
     * Constructor de clase.
     *
     */
    public ModeloConsultarUltimaRecarga(){
        setRepo();
    }

    /**
     * Metodo setRepo, establece el repositorio de datos del modelo.
     *
     * @param d El objeto que representa al repositorio de datos
     */
    @Override
    public void setRepo(InterfaceFachadaDatos d){
        if(d==null)
            datos= FachadaDatos.instancia();
        else
            datos=d;
    }

    /**
     * Metodo getRepo, devuelve el repositorio de datos asociado.
     *
     * @return InterfaceFachadaDatos
     */
    @Override
    public InterfaceFachadaDatos getRepo(){

       return datos;

    }


    /**
     * Metodo setRepo, establee un repositorio de datos del modelo
     *
     */
    @Override
    public void setRepo(){

        datos= FachadaDatos.instancia();

    }

    /**
     * Metodo eventoInicio, devuelve el id de la ultima recarga consultada.
     *
     * @return Hashtable con el id (matricula, fecha, combustible)
     */
    @Override
    public Hashtable recuperaIdUltimaRecarga() {
        return datos.getIdUltimaRecarga();
    }

    /**
     * Metodo borrarFichero, borra el fichero de recargas asociado.
     *
     */
    @Override
    public void borrarFichero() {
        datos.borrarFicheroRecarga();
    }

}
