package com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoRecargas;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import java.util.List;

/**
 * Clase ModeloMostrarListadoRecargas , representa al Modelo en el Caso de Uso  Mostrar Listado de Recargas.
 *
 */
public class ModeloMostrarListadoRecargas implements InterfaceMMostrarListadoRecargas{
    private InterfaceFachadaDatos datos;

    /**
     * Constructor de clase.
     *
     */
    public ModeloMostrarListadoRecargas(){
            setRepo();
    }
    /**
     * Metodo setRepo, establece el repositorio de datos para el modelo
     *
     */
    @Override
    public void setRepo(){

            datos=FachadaDatos.instancia();
    }
    /**
     * Metodo setRepo, establece el repositorio de datos para el modelo
     *
     * @param d Objeto InterfaceFachadaDatos
     * @throws IllegalArgumentException si el argumento es null
     */
    @Override
    public void setRepo(InterfaceFachadaDatos d){
        if(d==null)
           throw new IllegalArgumentException();
        else
            datos=d;
    }
    /**
     * Devuelve un repositorio de datos asociado al modelo.
     *
     * @return  Objeto InterfaceFachadaDatos
     */
    @Override
    public InterfaceFachadaDatos getRepo() {
        return datos;
    }

    /**
     * Metodo getListadoRecargas, devuelve un listado de recargas asociadas al vehiculo especificado.
     *
     * @param matricula Un ObjetoString con la matricula del vehiculo
     * @throws IllegalArgumentException si el argumento es null
     * @return  Un Objeto List<DTORecarga>
     */
    @Override
    public List<DTORecarga> getListadoRecargas(String matricula){
        if(matricula==null) {
            throw new IllegalArgumentException();
        }else {
            List<DTORecarga> recargas = datos.getListadoRecargas(matricula);
            return recargas;
        }
    }
}
