package com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoVehiculos;


import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import java.util.List;

/**
 * Clase ModeloMostrarListadoVehiculos, representa al Modelo en el CU Mostrar Listado de Vehiculos
 *
 */
public class ModeloMostrarListadoVehiculos implements InterfaceMMostrarListado {


    private static final String TAG = "ModeloMostrarListadoVehiculos";
    private InterfaceFachadaDatos datos;


    /**
     * Constructor de Clase.
     *
     */
    public ModeloMostrarListadoVehiculos() {setRepo(); }

    /**
     * Metodo setRepo, establee el repositorio de datos del modelo
     *
     * @param d El objeto que representa al repositorio de datos
     */
    @Override
    public void setRepo(InterfaceFachadaDatos d){
        if(d==null)
            datos= FachadaDatos.instancia();
        else
            datos=d;
    }

    /**
     * Metodo setRepo, establee un repositorio de datos del modelo
     *
     *
     */
    @Override
    public void setRepo(){

            datos= FachadaDatos.instancia();

    }

    /**
     * Metodo getRepo, devuelve un objeto representacion del repositorio de datos
     *
     * @return El objeto representacion del repositorio de datos
     */
    @Override
    public InterfaceFachadaDatos getRepo() {
        return datos;
    }

    /**
     * Método getListadoIdVehiculos, devuelve un listado de identificadores de cada uno de los vehículos.
     *
     * @return un listado de matrículas y nombres  de vehículos en foema de DTOVehiculo
     */
    @Override
    public List<DTOVehiculo> getListadoIdVehiculos(){
       List<DTOVehiculo> dtolist=datos.getIdentificadoresVehiculos();
       return dtolist;
    }

}
