package com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarEstadisticasVehiculo;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TableRow;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarEstadisticaVehiculo.FormateadorConsultarEstadisticaVehiculo;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarEstadisticaVehiculo.InterfaceFConsultarEstadisticaVehiculoImpl;

public class ConsultarEstadisticaVehiculoFragment extends Fragment {

    private View view;
    private TextView txtMatricula;
    private TextView txtMes;
    private TextView txtAnio;
    private TextView txtNRecargasMes;
    private TextView txtNRecargasAnio;
    private TextView txtCosteRecargasMes;
    private TextView txtCosteRecargasAnio;
    private TextView txtKmRecargasMes;
    private TextView txtKmRecargasAnio;
    private TableRow matriculaRowDEV;
    private TableRow mesRowDEV;
    private TableRow anioRowDEV;
    private TableRow nRMRowDEV;
    private TableRow nRARowDEV;
    private TableRow cMRowDEV;
    private TableRow cARowDEV;
    private TableRow kmMesRowDEV;
    private TableRow kmAnioRowDEV;

    private InterfaceFConsultarEstadisticaVehiculoImpl formateador;
    private String matricula;

    public ConsultarEstadisticaVehiculoFragment() {
        // Required empty public constructor
    }


    public static ConsultarEstadisticaVehiculoFragment newInstance() {
        return new ConsultarEstadisticaVehiculoFragment();
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment

        formateador = new FormateadorConsultarEstadisticaVehiculo();
        SharedPreferences prefs= this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        view= inflater.inflate(R.layout.fragment_consultar_estadistica_vehiculo, container, false);
        matricula=prefs.getString("matricula","null");
        return view;
    }

    @Override
    public void onResume(){
        super.onResume();
        boolean sinDatos=false;

        txtMatricula=view.findViewById(R.id.editTextMatriculaVehiculoEstadistica);
        txtMes=view.findViewById(R.id.editTextMesVehiculoEstadistica);
        txtAnio=view.findViewById(R.id.editTextAnioVehiculoEstadistica);
        txtNRecargasMes=view.findViewById(R.id.editTextNRecargasMesVehiculoEstadistica);
        txtNRecargasAnio=view.findViewById(R.id.editTextNRecargasAnioVehiculoEstadistica);
        txtCosteRecargasMes=view.findViewById(R.id.editTextCosteRecargasMesVehiculoEstadistica);
        txtCosteRecargasAnio=view.findViewById(R.id.editTextCosteRecargasAnioVehiculoEstadistica);
        txtKmRecargasMes=view.findViewById(R.id.editTextKmRecargasMesVehiculoEstadistica);
        txtKmRecargasAnio=view.findViewById(R.id.editTextKmRecargasAnioVehiculoEstadistica);

        matriculaRowDEV=view.findViewById(R.id.matriculaRowDEV);
        mesRowDEV=view.findViewById(R.id.mesRowDEV);
        anioRowDEV=view.findViewById(R.id.anioRowDEV);
        nRMRowDEV=view.findViewById(R.id.nRMRowDEV);
        nRARowDEV=view.findViewById(R.id.nRARowDEV);
        cMRowDEV=view.findViewById(R.id.cMRowDEV);
        cARowDEV=view.findViewById(R.id.cARowDEV);
        kmMesRowDEV=view.findViewById(R.id.kmMesRowDEV);
        kmAnioRowDEV=view.findViewById(R.id.kmAnioRowDEV);

        try {
            formateador.comienzaCU(matricula);
        }catch(Exception excp){
            sinDatos=true;
        }
        if(sinDatos){
            matriculaRowDEV.setVisibility(View.GONE);
            mesRowDEV.setVisibility(View.GONE);
            anioRowDEV.setVisibility(View.GONE);
            nRMRowDEV.setVisibility(View.GONE);
            nRARowDEV.setVisibility(View.GONE);
            cMRowDEV.setVisibility(View.GONE);
            cARowDEV.setVisibility(View.GONE);
            kmMesRowDEV.setVisibility(View.GONE);
            kmAnioRowDEV.setVisibility(View.GONE);
        }else{
            cargaDatos();
        }

    }

    private void cargaDatos(){

        txtMatricula.setText(formateador.getMatricula()+"");
        txtMes.setText(formateador.getMes()+"");
        txtAnio.setText(formateador.getAnio()+"");
        txtNRecargasMes.setText(formateador.getNRMes()+"");
        txtNRecargasAnio.setText(formateador.getNRAnio()+"");
        txtCosteRecargasMes.setText(formateador.getCosteRecargasMes()+"");
        txtCosteRecargasAnio.setText(formateador.getCosteRecargasAnio()+"");
        txtKmRecargasMes.setText(formateador.getKmRecargasMes()+"");
        txtKmRecargasAnio.setText(formateador.getKmRecargasAnio()+"");
    }

}
