package com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarGasolinerasCercanas;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoGasolineras.PostDataGasolinera;

import java.util.List;

public class ListAdapterGasolineras extends BaseAdapter {

    private List<PostDataGasolinera> data;
    private LayoutInflater inflater = null;
    private OnItemActionClickListener listener;
    public ListAdapterGasolineras(Context c, List<PostDataGasolinera> d, OnItemActionClickListener listener)
    {

        this.data = d;
        inflater = LayoutInflater.from(c);
        this.listener=listener;
    }

    @Override
    public int getCount() { return data.size(); }

    @Override
    public Object getItem(int arg0) { return data.get(arg0); }

    @Override
    public long getItemId(int arg0) { return arg0; }

    @Override
    public View getView(int arg0, View arg1, ViewGroup arg2) {
        ContenedorView contenedor = null;

        if (arg1 == null){
            arg1 = inflater.inflate(R.layout.elementolistgasolinera, null);

            contenedor = new ContenedorView();
            contenedor.elementoContenedorListview=(LinearLayout) arg1.findViewById(R.id.elementoContenedorListviewGasolinera);
            contenedor.nombre = (TextView) arg1.findViewById(R.id.textViewNombreGasolinera);
            contenedor.km = (TextView) arg1.findViewById(R.id.registroDistanciaGasolinera);
            contenedor.direccion = (TextView) arg1.findViewById(R.id.registroDireccionGasolinera);
            arg1.setTag(contenedor);
        } else {
            contenedor = (ContenedorView) arg1.getTag();
        }
        final PostDataGasolinera pd = (PostDataGasolinera) getItem(arg0);

        contenedor.nombre.setText(pd.getNombre());
        contenedor.km.setText(pd.getKm() );
        contenedor.direccion.setText(pd.getDireccion()+"\n "+pd.getLocalidad());
        contenedor.latitud=pd.getLatitud();
        contenedor.longitud=pd.getLongitud();
        contenedor.realDireccion=pd.getDireccion();
        final ContenedorView finalContenedor = contenedor;


        contenedor.elementoContenedorListview.setOnClickListener(new View.OnClickListener(){

            @Override
            public void onClick(View v) {
                listener.onClickContainer(pd);
            }
        });


        return arg1;
    }



    class ContenedorView{
        LinearLayout elementoContenedorListview;
        TextView nombre;
        TextView km;
        double latitud;
        double longitud;
        String realDireccion;
        TextView direccion;


    }
}
