package com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarGasolinerasCercanas;


import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;


import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoGasolineras.PostDataGasolinera;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarInformacionGasolinera.ConsultarInformacionGasolineraActivity;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.Circle;
import com.google.android.gms.maps.model.CircleOptions;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

import java.util.List;


public class MapaGasolinerasFragment extends Fragment    {

    private List<PostDataGasolinera> gasolineras;
    private String latitud;
    private String longitud;
    private  SharedPreferences prefs;
    public MapaGasolinerasFragment() {
        // Required empty public constructor
    }

    public static MapaGasolinerasFragment newInstance() {
        MapaGasolinerasFragment fragment = new MapaGasolinerasFragment();

        return fragment;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View rootView = inflater.inflate(R.layout.fragment_mapa_gasolineras, container, false);
        gasolineras=((TabsInformacionGasolinerasActivity)this.getActivity()).getListadoDatosGasolineras();
        latitud=((TabsInformacionGasolinerasActivity)this.getActivity()).getLatitud();
        longitud=((TabsInformacionGasolinerasActivity)this.getActivity()).getLongitud();
        prefs =  this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        SupportMapFragment mapFragment = (SupportMapFragment) getChildFragmentManager().findFragmentById(R.id.mapGasolinera);
        mapFragment.getMapAsync(new OnMapReadyCallback() {
            @Override
            public void onMapReady(GoogleMap mMap) {

                mMap.clear();

                Marker mkr= mMap.addMarker(new MarkerOptions()
                        .position(new LatLng(Double.parseDouble(latitud),Double.parseDouble(longitud)))
                        .title("Posición Actual"));
                mkr.showInfoWindow();


                //Zoom a la posicion actual
                CameraPosition googlePlex = CameraPosition.builder()
                        .target(new LatLng(Double.parseDouble(latitud),Double.parseDouble(longitud)))
                        .zoom(14)
                        .bearing(0)
                        .tilt(45)
                        .build();

                //haz animacion acercamiento
                mMap.animateCamera(CameraUpdateFactory.newCameraPosition(googlePlex), 5000, null);
                for(int i=0;i<gasolineras.size();i++){

                    mkr= mMap.addMarker(new MarkerOptions()
                            .position(new LatLng(gasolineras.get(i).getLatitud(), gasolineras.get(i).getLongitud()))
                            .title(gasolineras.get(i).getNombre()+" a "+gasolineras.get(i).getKm()+" km"));
                    mkr.setTag(gasolineras.get(i));
                    mkr.setIcon(BitmapDescriptorFactory.fromResource(R.drawable.icono_gasolinera_marker));

                }

                //el circulo de busqueda
                CircleOptions circleOptions = new CircleOptions()
                        .center(new LatLng(Double.parseDouble(latitud),Double.parseDouble(longitud)))
                        .clickable(false)
                        .radius(20000) //esta en metros
                        .strokeColor(Color.GREEN)
                        .fillColor(Color.argb(55, 153, 204, 255))
                        .strokeWidth(10)
                        .visible(true)
                        ;


                Circle nCircle =mMap.addCircle(circleOptions);

                mMap.setOnMarkerClickListener(new GoogleMap.OnMarkerClickListener() {
                    @Override
                    public boolean onMarkerClick(Marker marker) {
                        PostDataGasolinera gasolinera= (PostDataGasolinera)marker.getTag();
                        if(gasolinera!=null) {
                            marker.showInfoWindow();
                            Intent activity = new Intent(getActivity(), ConsultarInformacionGasolineraActivity.class);

                            SharedPreferences.Editor editor = prefs.edit();
                            editor.putString("direccion", gasolinera.getDireccion());
                            editor.commit();
                            getActivity().startActivity(activity);
                        }else{
                             marker.showInfoWindow();
                        }
                        return false;
                    }
                } );
            }
        });


        return rootView;
    }


}
