package com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarInformacionVehiculo_ListadoRecarga_ConsultarGraficas;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageButton;

import com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarEstadisticasVehiculo.TabsEstadisticasActivity;
import com.example.juanalonsoastruga.cargascontrol.Vista.MostrarGráficas.TabsGraficasActivity;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoCombustibleVehiculo;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoGrafica;
import com.example.juanalonsoastruga.cargascontrol.R;


public class ConsultarGraficasFragment extends Fragment {

    private View view;
    private ImageButton bttnCCombustibles;
    private ImageButton bttnCCombustiblesKm;
    private ImageButton bttnCosteCombustiblesKm;
    private ImageButton bttnKm;
    private ImageButton bttnCosteRecarga;
    private ImageButton bttnEstadisticas;
    private final CodigoGrafica B1=CodigoGrafica.GRAFICA1;
    private final CodigoGrafica B2=CodigoGrafica.GRAFICA2;
    private final CodigoGrafica B3=CodigoGrafica.GRAFICA3;
    private final CodigoGrafica B4=CodigoGrafica.GRAFICA4;
    private final CodigoGrafica B5=CodigoGrafica.GRAFICA5;
    private final CodigoCombustibleVehiculo CPRIM=CodigoCombustibleVehiculo.CPRIM;
    private final CodigoCombustibleVehiculo CSEC=CodigoCombustibleVehiculo.CSEC;
    private SharedPreferences prefs;
    private boolean answerAchieved=false;;
    public static ConsultarGraficasFragment newInstance() {
        return new ConsultarGraficasFragment();
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        view =inflater.inflate(R.layout.fragment_consultar_graficas, container, false);
        prefs =  this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);



        bttnCCombustibles=view.findViewById(R.id.bttnconsumoCombustiblesPeriodo);
        bttnCCombustiblesKm=view.findViewById(R.id. bttnconsumoCombustiblesKm);
        bttnCosteCombustiblesKm=view.findViewById(R.id.bttncosteCombustiblesKm);
        bttnKm=view.findViewById(R.id.bttnKm);
        bttnCosteRecarga=view.findViewById(R.id.bttncosteRecargaPeriodo);
        bttnEstadisticas=view.findViewById(R.id.bttnEstadisticas);
        return view;
    }

        @Override
    public void onResume(){
        super.onResume();
        answerAchieved=false;
        bttnCCombustibles.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                final SharedPreferences.Editor editor= prefs.edit();
                editor.putString("grafica",B1.getId()+"");
                editor.commit();
                dispatchWithDialog(editor);
                //getActivity().startActivity(new Intent( getActivity() , TabsGraficasActivity.class));
                System.gc();

            }
        });
        bttnCCombustiblesKm.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SharedPreferences.Editor editor= prefs.edit();
                editor.putString("grafica",B2.getId()+"");
                editor.commit();
                dispatchWithDialog(editor);
                //getActivity().startActivity(new Intent( getActivity() , TabsGraficasActivity.class));
                System.gc();

            }
        });
        bttnCosteCombustiblesKm.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SharedPreferences.Editor editor= prefs.edit();
                editor.putString("grafica",B3.getId()+"");
                editor.commit();
                dispatchWithDialog(editor);
                //getActivity().startActivity(new Intent( getActivity() , TabsGraficasActivity.class));
                System.gc();

            }
        });
        bttnKm.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SharedPreferences.Editor editor= prefs.edit();
                editor.putString("grafica",B4.getId()+"");
                editor.commit();
                dispatchWithDialog(editor);
                //getActivity().startActivity(new Intent( getActivity() , TabsGraficasActivity.class));
                System.gc();

            }
        });
        bttnCosteRecarga.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SharedPreferences.Editor editor= prefs.edit();
                editor.putString("grafica",B5.getId()+"");
                editor.commit();
                dispatchWithDialog(editor);
                //getActivity().startActivity(new Intent( getActivity() , TabsGraficasActivity.class));
                System.gc();
            }
        });
        bttnEstadisticas.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                SharedPreferences.Editor editor= prefs.edit();
                editor.putString("grafica","5");
                editor.commit();
                dispatchWithDialog(editor);
                //getActivity().startActivity(new Intent( getActivity() , TabsEstadisticasActivity.class));
                System.gc();
            }
        });
    }
    public void dispatchWithDialog(final SharedPreferences.Editor editor){
        //Dialog Seleccion Combustibe Primario o Secundario
        final String codigo=prefs.getString("grafica","5");
        if(!prefs.getString("CSEC","null").equals("null")){
            final String[] option = {"Combustible Primario", "Combustible Secundario", "Cancelar"};
            AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(getContext());
            alertDialogBuilder.setTitle("Escoja el combustible:");
            alertDialogBuilder.setItems(option, new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    if (option[which].equals( "Combustible Primario")) {
                        editor.putString("combustible",CPRIM.getId()+"");
                        editor.commit();
                        launchNextActivity(codigo);

                    } else if (option[which].equals( "Combustible Secundario")) {
                        editor.putString("combustible",CSEC.getId()+"");
                        editor.commit();
                        answerAchieved=true;
                        launchNextActivity(codigo);
                    } else {
                        dialog.dismiss();
                        answerAchieved=true;
                    }
                }
            });
            alertDialogBuilder.show();

        }else{
            editor.putString("combustible",CPRIM.getId()+"");
            editor.commit();
            answerAchieved=true;
            launchNextActivity(codigo);
        }
    }

    private void launchNextActivity(final String codigo){

        switch(codigo){

            case "0":
            case "1":
            case "2":
            case "3":
            case "4":
                getActivity().startActivity(new Intent( getActivity() , TabsGraficasActivity.class));
                break;
            default:
                getActivity().startActivity(new Intent( getActivity() , TabsEstadisticasActivity.class));
                break;
        }
    }
}
