package com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarInformacionVehiculo_ListadoRecarga_ConsultarGraficas;


import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarInformacionVehiculo.InterfaceFConsultarInformacionImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarInformacionVehiculo.FormateadorConsultarInformacionVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Vista.ModificarInformacionVehiculo.ModificarVehiculoActivity;


public class ConsultarInformacionVehiculoFragment extends Fragment {

    private View view;
    private String matricula;
    private InterfaceFConsultarInformacionImpl formateador;

    public static ConsultarInformacionVehiculoFragment newInstance() {
        return new ConsultarInformacionVehiculoFragment();
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);

       // matricula= getActivity().getIntent().getExtras().getString("matricula");
        SharedPreferences prefs =  this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);

        matricula=prefs.getString("matricula","null");

        formateador = new FormateadorConsultarInformacionVehiculo();



        view =inflater.inflate(R.layout.fragment_consultar_informacion_vehiculo, container, false);

        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        TextView texto;
        ImageView imagen;
        Button boton;

        formateador.registrarUltimoVehiculoConsultado(matricula);
        formateador.init(matricula);
         if(formateador.getCSecundario()==null){
            view.findViewById(R.id.rowCSec).setVisibility(View.GONE);
            view.findViewById(R.id.rowCTankSec).setVisibility(View.GONE);
        }else{
            view.findViewById(R.id.rowCSec).setVisibility(View.VISIBLE);
            view.findViewById(R.id.rowCTankSec).setVisibility(View.VISIBLE);
        }
        texto = view.findViewById(R.id.editTextNombreVehiculo);
        texto.setText(formateador.getNombre());
        texto = view.findViewById(R.id.editTextMatriculaVehiculo);
        texto.setText(matricula);
        texto = view.findViewById(R.id.editTextMarcaVehiculo);
        texto.setText(formateador.getMarca());
        texto = view.findViewById(R.id.editTextModeloVehiculo);
        texto.setText(formateador.getModelo());
        texto = view.findViewById(R.id.editTextAnio);
        texto.setText(formateador.getAño());
        texto = view.findViewById(R.id.editTextKM);

        texto.setText(formateador.getKm());
        texto = view.findViewById(R.id.combustible1);
        texto.setText(formateador.getCPrimario());
        texto = view.findViewById(R.id.editTextCapPrim);
        texto.setText(formateador.getCTPrimario());
         if(formateador.getCSecundario()!=null) {
             texto = view.findViewById(R.id.combustible2);
             texto.setText(formateador.getCSecundario());

              texto = view.findViewById(R.id.editTextCapSec);
              texto.setText(formateador.getCTSecundario() + "");
        }
        imagen = view.findViewById(R.id.imageViewFotoVehiculo);



        BitmapDrawable bitmapDrawable = ((BitmapDrawable) imagen.getDrawable());
        Bitmap bitmap;
        if(bitmapDrawable==null){
            imagen.buildDrawingCache();
            bitmap = imagen.getDrawingCache();
            imagen.buildDrawingCache(false);
        }else
        {
            bitmap = bitmapDrawable .getBitmap();
        }

        imagen.setImageBitmap(formateador.getFoto());


        int ancho = 500;
        int alto = 500;
       // TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);

       // imagen.setLayoutParams(params);
        boton=view.findViewById(R.id.botonModificacion);


        SharedPreferences prefs =  this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor=prefs.edit();
        editor.putString("CPRIM", formateador.getCPrimario()+"");
        editor.putString("CSEC", formateador.getCSecundario()+"");
        editor.commit();

        boton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lanzaActividadModificacion();
            }
        });

    }

    private void lanzaActividadModificacion() {
        Intent intent=new Intent(getActivity(), ModificarVehiculoActivity.class);
        //intent.putExtra("matricula",matricula);
        getActivity().startActivity(intent);
    }


}
