package com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarInformacionVehiculo_ListadoRecarga_ConsultarGraficas;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoRecargas.PostDataRecarga;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class ListAdapterRecargas extends BaseAdapter {



    private static final String TAG = "ListAdapterRecargas";
    private static int convertViewCounter = 0;

    private List<PostDataRecarga> data;
    private LayoutInflater inflater = null;
    private OnItemActionClickListener listener;
    private Calendar cal;

    public ListAdapterRecargas(Context c, List<PostDataRecarga> d, OnItemActionClickListener listener)
    {
        Log.v(TAG, "Constructing CustomAdapter");

        this.data = d;
        inflater = LayoutInflater.from(c);
        Log.v(TAG, "CustomAdapter Layout Inflated");
        this.listener=listener;
    }


    @Override
    public int getCount() { return data.size(); }

    @Override
    public Object getItem(int arg0) { return data.get(arg0); }

    @Override
    public long getItemId(int arg0) { return arg0; }

    @Override
    public View getView(int arg0, View arg1, ViewGroup arg2) {
        ContenedorView contenedor = null;

        if (arg1 == null){
            arg1 = inflater.inflate(R.layout.elementolistrecarga, null);

            contenedor = new ContenedorView();
            contenedor.elementoContenedorListview=(LinearLayout) arg1.findViewById(R.id.elementoContenedorListviewRecarga);
            contenedor.fecha = (TextView) arg1.findViewById(R.id.registroTextFecha);
            contenedor.precio = (TextView) arg1.findViewById(R.id.registroTextPrecio);

            arg1.setTag(contenedor);
        } else {
            contenedor = (ContenedorView) arg1.getTag();
        }
        final PostDataRecarga pd = (PostDataRecarga) getItem(arg0);
        Double precio=pd.getPrecio();
        contenedor.precio.setText(precio.toString());
        Date fecha=pd.getFecha();
        String pattern = "dd/MM/yyyy HH:mm";
        DateFormat df = new SimpleDateFormat(pattern);

        String fechaAsString = df.format(fecha);


        contenedor.fecha.setText(fechaAsString);

        final ContenedorView finalContenedor = contenedor;


        contenedor.elementoContenedorListview.setOnClickListener(new View.OnClickListener(){

            @Override
            public void onClick(View v) {
                listener.onClickContainer(pd);
            }
        });


        return arg1;
    }



    class ContenedorView{
        LinearLayout elementoContenedorListview;
        TextView fecha;
        TextView precio;

    }
}
