package com.example.juanalonsoastruga.cargascontrol.Vista.Listado_Borrado_Vehiculos;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos.PostData;


import java.util.List;

public class ListAdapter extends BaseAdapter {



    private static final String TAG = "ListAdapter";
    private static int convertViewCounter = 0;

    private List<PostData> data;
    private LayoutInflater inflater = null;
    private OnItemActionClickListener listener;

    public ListAdapter(Context c, List<PostData> d,OnItemActionClickListener listener)
    {
        Log.v(TAG, "Constructing CustomAdapter");

        this.data = d;
        inflater = LayoutInflater.from(c);
        Log.v(TAG, "CustomAdapter Layout Inflated");
        this.listener=listener;
    }


    @Override
    public int getCount() { return data.size(); }

    @Override
    public Object getItem(int arg0) { return data.get(arg0); }

    @Override
    public long getItemId(int arg0) { return arg0; }

    @Override
    public View getView(int arg0, View arg1, ViewGroup arg2) {
        ContenedorView contenedor = null;

        if (arg1 == null){
            arg1 = inflater.inflate(R.layout.elementolistvehiculos, null);

            contenedor = new ContenedorView();
            contenedor.elementoContenedorListview=(LinearLayout) arg1.findViewById(R.id.elementoContenedorListview);
            contenedor.matricula = (TextView) arg1.findViewById(R.id.registroTextMatricula);
            contenedor.nombre = (TextView) arg1.findViewById(R.id.registroTextNombre);
            contenedor.botonEliminar=(ImageButton)arg1.findViewById(R.id.botonEliminar);
            arg1.setTag(contenedor);
        } else
            contenedor = (ContenedorView) arg1.getTag();

        final PostData d = (PostData) getItem(arg0);
        contenedor.matricula.setText(d.getMatricula());
        contenedor.nombre.setText(d.getNombre());


        final ContenedorView finalContenedor = contenedor;
        contenedor.botonEliminar.setOnClickListener(new View.OnClickListener(){

            @Override
            public void onClick(View view) {


                listener.onEliminarClick(d);
            }
        });

        contenedor.elementoContenedorListview.setOnClickListener(new View.OnClickListener(){

            @Override
            public void onClick(View v) {
                listener.onClickContainer(d);
            }
        });


        return arg1;
    }



    class ContenedorView{
        LinearLayout elementoContenedorListview;
        TextView matricula;
        TextView nombre;
        ImageButton botonEliminar;
    }
}
