package com.example.juanalonsoastruga.cargascontrol.Vista.Listado_Borrado_Vehiculos;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import com.google.android.material.floatingactionbutton.FloatingActionButton;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;

import com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarInformacionVehiculo_ListadoRecarga_ConsultarGraficas.TabsGeneralActivity;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUBorrarVehiculo.FormateadorBorradoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUBorrarVehiculo.InterfaceFBorradoVehiculoImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos.InterfaceFMostrarListadoImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos.PostData;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos.FormateadorMostrarListadoVehiculos;
import com.example.juanalonsoastruga.cargascontrol.Vista.RegistroVehiculo.RegistroVehiculoActivity;

import java.util.ArrayList;
import java.util.List;

public class ListadoVehiculosFragment extends  Fragment implements
        View.OnClickListener, OnItemActionClickListener{



    private List<PostData> datos;
    private View view;
    private InterfaceFMostrarListadoImpl formateadorListado;
    private InterfaceFBorradoVehiculoImpl formateadorBorrado;
    private boolean allowRefresh;
    private ListAdapter adaptador;
    private List<PostData> l;
    private FloatingActionButton botonAddVehiculo ;
    private ListView lista;

    public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);

        //Crea la 'formateadorListado' del MVC

        this.formateadorListado = new FormateadorMostrarListadoVehiculos();
        this.formateadorListado.init();


        View view = inflater.inflate(R.layout.fragment_listado_vehiculos,container,false);
        this.view=view;
        allowRefresh=true;

        lista = (ListView) view.findViewById(R.id.listviewvehiculos);

        botonAddVehiculo=(FloatingActionButton) view.findViewById(R.id.addVehicleButton);

        return view;
    }
    @Override
    public void onResume() {

        super.onResume();

        formateadorListado.init();

        l= formateadorListado.getListadoIds();
        if(l==null){

            l= new ArrayList<PostData>(0);
        }
        adaptador = new ListAdapter(getContext(),l,this);

        lista.setAdapter(adaptador);

        botonAddVehiculo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                getActivity().startActivity(new Intent( getActivity() , RegistroVehiculoActivity.class));
                //System.gc();
            }
        });
    }


    @Override
    public void onEliminarClick(PostData vehiculo) {


        formateadorBorrado = new FormateadorBorradoVehiculo();
        formateadorBorrado.init(vehiculo.getMatricula());

        if(formateadorBorrado.getConfirmacionBorrado()){
            onMuestraMensajeBorrado(vehiculo);

           /*if(allowRefresh) {
                allowRefresh=false;
                getFragmentManager().beginTransaction().detach(this).attach(this).commit();

            }*/
        }else{
            formateadorBorrado.eliminaAccionBorrado();
        }
    }

    @Override
    public void onClickContainer(PostData d) {

        Intent tabs = new Intent( getActivity() , TabsGeneralActivity.class);
        //tabs.putExtra("matricula",d.getMatricula());
        SharedPreferences prefs =  this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putString("matricula",d.getMatricula());
        editor.commit();
        getActivity().startActivity(tabs);

    }

    public void onMuestraMensajeBorrado(final PostData vehiculo){
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(getContext());
        // set title
        alertDialogBuilder.setTitle("¿Desea Borrar el vehículo "+vehiculo.getMatricula()+" del sistema ?");

        // set dialog message
        alertDialogBuilder
                .setMessage("Seleccione SI para borrar, NO en caso contrario!")
                .setCancelable(false)
                .setPositiveButton("Si",new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog,int id) {

                      formateadorBorrado.confirmarBorrado();
                      l.remove(vehiculo);
                       onResume();
                    }
                })
                .setNegativeButton("NO",new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog,int id) {
                        // if this button is clicked, just close
                        // the dialog box and do nothing
                        dialog.cancel();
                    }
                });
        //Refresca Vista
        onResume();

        // create alert dialog
        AlertDialog alertDialog = alertDialogBuilder.create();

        // show it
        alertDialog.show();
    }




    @Override
    public void onActivityCreated(Bundle state) {
        super.onActivityCreated(state);

    }
    @Override
    public void onClick(View v) {

    }


}
