package com.example.juanalonsoastruga.cargascontrol.Vista;

import android.content.Intent;
import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;

import com.example.juanalonsoastruga.cargascontrol.Vista.SeccionPrincipal.MenuPrincipal;
import com.example.juanalonsoastruga.cargascontrol.Datos.GasolinerasProvider.GasolinerasProvider;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;

import com.example.juanalonsoastruga.cargascontrol.Datos.LocationProvider.LocationProvider;
import com.example.juanalonsoastruga.cargascontrol.Datos.UltimaConsultaProvider.UltimaConsultaProvider;


public class MainActivity extends AppCompatActivity{

    private static final String TAG ="MAIN" ;
    private FachadaDatos iniUtil;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //Como parte de la inyeccion de dependencias del contexto para las cosas necesarias
        //de la BD se debe hacer esto:

        iniUtil =FachadaDatos.instancia();
        //inyeccion dependencias Context
        iniUtil.setContext(this.getApplicationContext());
        //inyeccion dependencias LocationProvider
        iniUtil.setLocationProvider(new LocationProvider(this.getApplicationContext()));
        //inyeccion dependencias GasolinerasProvider
        iniUtil.setEstacionesRecargaProvider(new GasolinerasProvider(this.getApplicationContext()));
        //inyeccion dependencia UltimaConsultaProvider
        iniUtil.setUltimaConsultaProvider(new UltimaConsultaProvider(this.getApplicationContext()));

        if(!iniUtil.isReady()) {
            iniUtil.pobladoInicial();
        }
        startActivity(new Intent(this,MenuPrincipal.class));
        this.finish();
    }
}
