package com.example.juanalonsoastruga.cargascontrol.Vista.Mapa;

import androidx.fragment.app.FragmentActivity;
import android.os.Bundle;
import android.util.Log;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarPosicionMapa.FormateadorConsultarPosicionMapa;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarPosicionMapa.InterfaceFConsultarPosicionMapaImpl;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.CameraPosition;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

public class MapsActivity extends FragmentActivity implements OnMapReadyCallback {

    private GoogleMap mMap;
    private InterfaceFConsultarPosicionMapaImpl formateador;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_maps);
        SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);
        formateador= new FormateadorConsultarPosicionMapa();
    }



    @Override
    public void onMapReady(GoogleMap googleMap) {
        mMap = googleMap;
        mMap.clear();
        formateador.solicitarActualizacionMapa();
        double latitud=formateador.getLatitudActual();
        double longitud=formateador.getLongitudActual();
         
        LatLng posicionActual = new LatLng(latitud, longitud);

        mMap.addMarker(new MarkerOptions().position(posicionActual).title("Usted está aqui"));
        CameraPosition googlePlex = CameraPosition.builder()
                .target(new LatLng(latitud,longitud))
                .zoom(18)
                .bearing(0)
                .tilt(45)
                .build();
        //haz animacion acercamiento
        mMap.animateCamera(CameraUpdateFactory.newCameraPosition(googlePlex), 2500, null);


    }
}
