package com.example.juanalonsoastruga.cargascontrol.Vista.ModificarInformacionVehiculo;

import android.Manifest;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.core.content.ContextCompat;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUModificarInformacionVehiculo.FormateadorModificarInformacionVehiculo;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUModificarInformacionVehiculo.InterfaceFModificarInformacionVehiculoImpl;

import java.util.List;



public class ModificarVehiculoFragment extends Fragment {
    private final int SELECT_PICTURE = 300;
    private final int CAMERA_RESULT = 101;
    ArrayAdapter<String> combustiblesP;
    ArrayAdapter<String> combustiblesS;
    private View view;
    private EditText editTextNombreVehiculo, editTextMarcaVehiculo, editTextModeloVehiculo;
    private EditText editTextAnio;
    private TextView editTextCapPrim, editTextCapSec;
    private TextView editTextMatriculaVehiculo;
    private TextView editTextKM;
    private ImageView fotoBoton;
    private TextView combustiblePrimario;
    private TextView combustibleSecundario;
    private Button botonModificado;
    private InterfaceFModificarInformacionVehiculoImpl formateador;
    private String matricula;
    private String TAG="DEBUG";
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        view = inflater.inflate(R.layout.fragment_modificar_vehiculo, container, false);
        //matricula = getActivity().getIntent().getExtras().getString("matricula");
        SharedPreferences prefs =  this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);

        matricula=prefs.getString("matricula","null");
        this.editTextNombreVehiculo = view.findViewById(R.id.editTextNombreVehiculoMOD);
        this.editTextMatriculaVehiculo = view.findViewById(R.id.editTextMatriculaVehiculoMOD);
        this.editTextMarcaVehiculo = view.findViewById(R.id.editTextMarcaVehiculoMOD);
        this.editTextModeloVehiculo = view.findViewById(R.id.editTextModeloVehiculoMOD);
        this.editTextAnio = view.findViewById(R.id.editTextAnioMOD);
        this.editTextKM = view.findViewById(R.id.editTextKMMOD);
        this.editTextCapPrim = view.findViewById(R.id.editTextCapPrimMOD);
        this.editTextCapSec = view.findViewById(R.id.editTextCapSecMOD);
        this.fotoBoton = view.findViewById(R.id.imageViewFotoVehiculoMOD);
        this.combustiblePrimario = view.findViewById(R.id.combustible1MOD);
        this.combustibleSecundario = view.findViewById(R.id.combustible2MOD);
        this.botonModificado = view.findViewById(R.id.botonParaModificacion);

        this.formateador = new FormateadorModificarInformacionVehiculo();
        formateador.init(matricula);
        return view;
    }

    @Override
    public void onResume() {
        super.onResume();
        editTextNombreVehiculo.setText(formateador.getNombre());
        editTextMatriculaVehiculo.setText(formateador.getMatricula());
        editTextMarcaVehiculo.setText(formateador.getMarca());
        editTextModeloVehiculo.setText(formateador.getModelo());
        editTextAnio.setText(formateador.getAnio()+"");
        editTextKM.setText(formateador.getKm() + "");

        combustiblePrimario.setText(formateador.getCPrim());
        editTextCapPrim.setText(formateador.getCapPrim()+"" );

        int ancho = 500;
        int alto = 500;
        //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
        //fotoBoton.setLayoutParams(params);
        List<String> cList2 = formateador.getInfoCombustible();

        String cmbstble="Ninguno";
        double capSec=0;

        boolean isNull = true;
        for (int i = 0; i < cList2.size(); i++) {
            if (cList2.get(i).equals(formateador.getCSec())) {
                cmbstble=cList2.get(i);
                capSec= formateador.getCapSec();
            }
        }

            combustibleSecundario.setText(cmbstble);
            editTextCapSec.setText(capSec+"");



        BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
        Bitmap bitmap;
        if (bitmapDrawable == null) {
            bitmap = formateador.getFoto();

        } else {
            fotoBoton.buildDrawingCache();
            bitmap = fotoBoton.getDrawingCache();
            fotoBoton.buildDrawingCache(false);
        }

        if(bitmap!=null) {
            fotoBoton.setImageBitmap(bitmap);
        }
        fotoBoton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(getContext());
                Log.d(TAG, "DialogoSeleccionMedios");
                alertDialogBuilder.setTitle("Importar la Imágen");
                final String[] option = {"Cámara", "Galería", "Cancelar"};

                alertDialogBuilder.setItems(option, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        Log.d(TAG, "SeleccionMedios");
                        if (option[which] == "Cámara") {
                            Log.d(TAG, "Cámara Seleccionado");
                            openCamera();
                        } else if (option[which] == "Galería") {
                            Log.d(TAG, "Galeria Seleccionado");
                            Intent intent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                            intent.setType("image/*");
                            startActivityForResult(intent.createChooser(intent, "Selecciona app de imagen"), SELECT_PICTURE);
                        } else {
                            dialog.dismiss();
                        }
                    }
                });
                int ancho = 500;
                int alto = 500;
                //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
                //fotoBoton.setLayoutParams(params);
                alertDialogBuilder.show();
            }
        });
        botonModificado.setOnClickListener(new View.OnClickListener() {
                                               @Override
                                               public void onClick(View v) {

               Log.d(TAG,"SEGUNDO LISTENER");
               boolean validarCampos=true;
               String cmp=null;
               //Transmitele los datos a la formateador del MVP
               if (editTextNombreVehiculo.getText().length() != 0) {
                   formateador.actualizaNombre(editTextNombreVehiculo.getText().toString());
               } else {
                   formateador.actualizaNombre(null);
               }


               formateador.actualizaMarca(editTextMarcaVehiculo.getText().toString());
               formateador.actualizaModelo(editTextModeloVehiculo.getText().toString());
               int año;
               if (!(editTextAnio.getText().toString().equals(""))) {
                    try {
                        año = Integer.parseInt(editTextAnio.getText().toString());
                        if(año<1890){
                            throw new IllegalArgumentException();
                        }
                        formateador.actualizaAno(año);
                    }catch (Exception e){
                        validarCampos=false;
                        cmp="año";
                        año=0;
                        formateador.deteccionCampoInvalido(cmp);
                    }
               }

               double km;
               if (!(editTextKM.getText().toString().equals(""))) {
                  try {
                      km = Double.parseDouble(editTextKM.getText().toString());
                      if(km<0||editTextKM.getText().toString().charAt(0)=='.'){
                          throw new IllegalArgumentException();
                      }
                      formateador.actualizaKm(km);
                  }catch(Exception e){

                      validarCampos=false;
                      cmp="km";
                      km=0;
                      formateador.deteccionCampoInvalido(cmp);

                  }
               }


               formateador.actualizaCPrimario(combustiblePrimario.getText()+"");
               double capacidad;
               if (!(editTextCapPrim.getText().toString().equals(""))) {
                    try {
                        capacidad = Double.parseDouble(editTextCapPrim.getText().toString());
                        if(capacidad<0||editTextCapPrim.getText().toString().charAt(0)=='.'){
                            throw new IllegalArgumentException();
                        }
                        formateador.actualizaCapTP(capacidad);
                    }catch (Exception e){
                       validarCampos=false;
                       cmp="CTP";
                       capacidad=0;
                       formateador.deteccionCampoInvalido(cmp);
                   }
               }
               if (!combustibleSecundario.getText().equals("Ninguno")) {
                   formateador.actualizaCSecundario(combustibleSecundario.getText()+"");
                   if (!(editTextCapSec.getText().toString().equals(""))) {
                       try {
                           capacidad = Double.parseDouble(editTextCapSec.getText().toString());
                           if(capacidad<0||editTextCapSec.getText().toString().charAt(0)=='.'){
                               throw new IllegalArgumentException();
                           }
                           formateador.actualizaCapTS(capacidad);
                       }catch (Exception e){
                           validarCampos=false;
                           cmp="año";
                           capacidad=0;
                           formateador.deteccionCampoInvalido(cmp);
                       }
                   }
               } else {
                   formateador.actualizaCSecundario(null);
                   formateador.actualizaCapTS(0);
               }

               try {

                   BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
                   Bitmap bitmap;
                   if (bitmapDrawable == null||bitmapDrawable.getBitmap().isRecycled()) {
                       fotoBoton.buildDrawingCache();
                       bitmap = fotoBoton.getDrawingCache();
                       fotoBoton.buildDrawingCache(false);
                   } else {
                       bitmap = bitmapDrawable.getBitmap();
                   }

                   formateador.actualizaFoto(bitmap);

               } catch (Exception e) {
                   Log.d(TAG, "ERRROR");
               }
                if(validarCampos){
                 pulsacionBoton();
                    if (formateador.isRegistroCompletado()) {
                        //drawable.getBitmap().recycle();
                        ((BitmapDrawable) fotoBoton.getDrawable()).getBitmap().recycle();
                        fotoBoton.setImageBitmap(null);
                        System.gc();
                        getActivity().finish();

                    } else {

                        Log.d(TAG, "DialogoNoValidoRegistro");
                        Toast.makeText(getActivity().getApplicationContext(), "No se han rellenado campos obligatotios \n (nombre, matricula, combustible primario)", Toast.LENGTH_LONG).show();


                    }
                }else{
                    String msj= formateador.getMensajeError();
                    Toast.makeText(getActivity().getApplicationContext(), msj, Toast.LENGTH_LONG).show();
                }

           }
        }
        );
    }

    private void openCamera() {
        Log.d(TAG, "OPEN CAMERA");
        if (ContextCompat.checkSelfPermission(getContext(), Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) {
            dispatchTakenPictureIntent();

        } else {
            if (shouldShowRequestPermissionRationale(Manifest.permission.CAMERA)) {
                Toast.makeText(getActivity().getApplicationContext(), "Se necesita permiso para acceder a esa funcionalidad", Toast.LENGTH_LONG).show();

            }
            requestPermissions(new String[]{Manifest.permission.CAMERA, Manifest.permission.WRITE_EXTERNAL_STORAGE}, CAMERA_RESULT);
        }
    }

    private void dispatchTakenPictureIntent() {
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        if (takePictureIntent.resolveActivity(this.getActivity().getPackageManager()) != null) {
            Log.d(TAG, "START ACTIVITY FOR RESULT");
            startActivityForResult(takePictureIntent, CAMERA_RESULT);

        }
        Log.d(TAG, "ALREADY DONE");
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        try {
            Log.d(TAG, "IMAGEN  REQUEST CODE IS CAMERA RESULT"+(requestCode == CAMERA_RESULT));
            if (requestCode == CAMERA_RESULT) {
                Bundle extras = data.getExtras();
                Matrix matrix = new Matrix();
                // matrix.postRotate(90);

                BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
                Bitmap bitmap;
                if (bitmapDrawable == null) {
                    fotoBoton.buildDrawingCache();
                    bitmap = fotoBoton.getDrawingCache();
                    fotoBoton.buildDrawingCache(false);
                } else {
                    bitmap = bitmapDrawable.getBitmap();
                }
                bitmap = (Bitmap) extras.get("data");
                bitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
                        bitmap.getHeight(), matrix, true);

                fotoBoton.setImageBitmap(bitmap);
                fotoBoton.postInvalidate();
                //bitmap.recycle();
                Log.d(TAG, "IMAGEN CAMBIADA");
            } else {
                if (requestCode == SELECT_PICTURE) {
                    Uri imageUri = data.getData();
                    fotoBoton.setImageURI(imageUri);

                }
            }
            int ancho = 500;
            int alto = 500;
            //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
            //fotoBoton.setLayoutParams(params);
        } catch (Exception e) {
            Log.d(TAG, "No se ha llegado a tomar imagen");
        }

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        if (requestCode == CAMERA_RESULT) {
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED) {
                dispatchTakenPictureIntent();
            } else {
                Toast.makeText(getActivity().getApplicationContext(), "Se necesita permiso para acceder a esa funcionalidad", Toast.LENGTH_LONG).show();

            }
        } else {
            super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        }
    }

    public void pulsacionBoton() {
        formateador.pulsacionBotonModificar();
    }

}
