package com.example.juanalonsoastruga.cargascontrol.Vista.MostrarGráficas;

import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoCombustibleVehiculo;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoGrafica;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoPeriocidadGrafica;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCoste.FormateadorGraficarCoste;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustible.InterfaceFGraficarConsumoCombustibleImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustible.FormateadorGraficarConsumoCombustible;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustibleXKm.InterfaceFGraficarConsumoCombustibleKmImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustibleXKm.FormateadorGraficarConsumoCombustibleKm;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCoste.InterfaceFGraficarCosteImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCosteCombustibleXUnidadRecarga.InterfaceFGraficarCosteCombustibleUnidadRecargaImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCosteCombustibleXUnidadRecarga.FormateadorGraficarCosteCombustibleUnidadRecarga;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarKm.InterfaceFGraficarKmImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarKm.FormateadorGraficarKm;
import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.charts.LineChart;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.data.LineData;
import com.github.mikephil.charting.data.LineDataSet;

public class GraficaAnualFragment extends Fragment {

    private SharedPreferences prefs;
    private int codigoGrafica;
    private int codigoCombustible;
    private String matricula;
    private LineChart grafica;
    private View view;

    private TextView descripcionX;
    private TextView descripcionY;


    public GraficaAnualFragment() {
        // Required empty public constructor
    }


    public static GraficaAnualFragment newInstance() {
        GraficaAnualFragment fragment = new GraficaAnualFragment();

        return fragment;
    }



    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        prefs=   this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        view = inflater.inflate(R.layout.fragment_grafica_anual, container, false);
        codigoGrafica = Integer.parseInt(prefs.getString("grafica","0"));
        codigoCombustible= Integer.parseInt(prefs.getString("combustible","0"));
        matricula=prefs.getString("matricula","null");
        grafica = view.findViewById(R.id.chartGraficaAnual);
        descripcionX=view.findViewById(R.id.tVDescripcionEjeXAnual);
        descripcionY=view.findViewById(R.id.tVDescripcionEjeYAnual);
        return view;
    }

    @Override
    public void onResume(){
        super.onResume();
        switch(CodigoGrafica.getDescripcion(codigoGrafica)){
            case "CONSUMO_COMBUSTIBLE":
                grafConsumoCombustible();
                break;
            case "CONSUMO_COMBUSTIBLE_KM":
                grafConsumoCombustibleKm();
                break;
            case "COSTE_COMBUSTIBLE_RECARGA" :
                grafCosteCombustibleRecarga();
                break;
            case "KM" :
                grafKm();
                break;
            case "COSTE_RECARGA" :
                grafCosteRecarga();
                break;
        }
    }

    public void grafConsumoCombustible(){
        InterfaceFGraficarConsumoCombustibleImpl f1=new FormateadorGraficarConsumoCombustible();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f1.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM, CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f1.getDataSet();
            //dataSet.setLabel("Consumo Anual de Combustible Primario");
        }else{
            f1.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f1.getDataSet();
            //dataSet.setLabel("Consumo Anual de Combustible Secundario");
        }

        setUpGraficaLineal("Número de Mes","Carburante",dataSet);

    }
    public void grafConsumoCombustibleKm(){
        InterfaceFGraficarConsumoCombustibleKmImpl f2=new FormateadorGraficarConsumoCombustibleKm();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f2.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f2.getDataSet();
        }else{
            f2.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f2.getDataSet();
        }
        setUpGraficaLineal("Número de Mes","Carburante/Km",dataSet);
    }
    public void grafCosteCombustibleRecarga(){
        InterfaceFGraficarCosteCombustibleUnidadRecargaImpl f3=new FormateadorGraficarCosteCombustibleUnidadRecarga();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f3.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f3.getDataSet();

        }else{
            f3.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f3.getDataSet();

        }

        setUpGraficaLineal("Número de Mes","Coste/Recarga",dataSet);
    }
    public void grafKm(){
        InterfaceFGraficarKmImpl f4=new FormateadorGraficarKm();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f4.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f4.getDataSet();

        }else{
            f4.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f4.getDataSet();

        }

        setUpGraficaLineal("Número de Mes","Km",dataSet);
    }
    public void grafCosteRecarga(){
        InterfaceFGraficarCosteImpl f5=new FormateadorGraficarCoste();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f5.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f5.getDataSet();

        }else{
            f5.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
            dataSet=f5.getDataSet();

        }

        setUpGraficaLineal("Número de Mes","Coste",dataSet);
    }


    public void setUpGraficaLineal(String labelX,String labelY,LineDataSet dataSet){

        descripcionX.setText(labelX);
        String labelFormateada="";
        for(int i=0;i<labelY.length();i++){
            labelFormateada=labelFormateada.concat(labelY.charAt(i)+"\n");
        }
        labelY=labelFormateada;
        descripcionY.setText(labelY);

        dataSet.setDrawCircleHole( true );
        dataSet.setColor(Color.parseColor("#047dd9"));
        dataSet.setLineWidth(3f);
        dataSet.enableDashedLine(3f, 6f, 0f);

        dataSet.setValueTextColor(Color.parseColor("#FF1300"));
        dataSet.setValueTextSize(15f);
        dataSet.setDrawIcons(false);

        dataSet.setCircleColor(Color.parseColor("#FFAA00"));
        dataSet.setCircleHoleColor(Color.parseColor("#000000"));
        dataSet.setCircleRadius(3f);

        grafica.setTouchEnabled(true);
        grafica.setPinchZoom(true);
        grafica.getDescription().setEnabled(false);


        XAxis xaxis=grafica.getXAxis();
        xaxis.setDrawGridLines(false);
        xaxis.setPosition(XAxis.XAxisPosition.BOTTOM);
        xaxis.setAxisMinimum(0);
        xaxis.setTextSize(20);
        xaxis.setGranularity(1f);

        YAxis yaxis=grafica.getAxisLeft();
        yaxis.setDrawGridLines(false);
        yaxis.setPosition(YAxis.YAxisLabelPosition.OUTSIDE_CHART);
        yaxis.setAxisMinimum(0);
        yaxis.setTextSize(20);
        yaxis.setGranularity(5f);

        LineData grafLineal=new LineData(dataSet);
        grafica.setData(grafLineal);
        grafica.animateX(1500, Easing.Linear);
        grafica.animateY(1500, Easing.Linear);
        grafica.notifyDataSetChanged();
        grafica.invalidate();
        //grafica.notifyDataSetChanged();
    }
}
