package com.example.juanalonsoastruga.cargascontrol.Vista.MostrarGráficas;

import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoCombustibleVehiculo;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoGrafica;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoPeriocidadGrafica;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustibleXKm.FormateadorGraficarConsumoCombustibleKm;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCoste.FormateadorGraficarCoste;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCosteCombustibleXUnidadRecarga.FormateadorGraficarCosteCombustibleUnidadRecarga;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarKm.FormateadorGraficarKm;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustible.InterfaceFGraficarConsumoCombustibleImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustible.FormateadorGraficarConsumoCombustible;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarConsumoCombustibleXKm.InterfaceFGraficarConsumoCombustibleKmImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCoste.InterfaceFGraficarCosteImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCosteCombustibleXUnidadRecarga.InterfaceFGraficarCosteCombustibleUnidadRecargaImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarKm.InterfaceFGraficarKmImpl;
import com.github.mikephil.charting.animation.Easing;
import com.github.mikephil.charting.charts.LineChart;
import com.github.mikephil.charting.components.XAxis;
import com.github.mikephil.charting.components.YAxis;
import com.github.mikephil.charting.data.LineData;
import com.github.mikephil.charting.data.LineDataSet;


public class GraficaMensualFragment extends Fragment {

private SharedPreferences prefs;
private int codigoGrafica;
private int codigoCombustible;
private String matricula;
private LineChart grafica;
private View view;

private TextView descripcionX;
private TextView descripcionY;



public GraficaMensualFragment() {
        // Required empty public constructor
    }


    public static GraficaMensualFragment newInstance() {
        GraficaMensualFragment fragment = new GraficaMensualFragment();

        return fragment;
    }



    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        prefs=   this.getActivity().getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        view = inflater.inflate(R.layout.fragment_grafica_mensual, container, false);
        codigoGrafica = Integer.parseInt(prefs.getString("grafica","0"));
        codigoCombustible= Integer.parseInt(prefs.getString("combustible","0"));
        matricula=prefs.getString("matricula","null");
        grafica = view.findViewById(R.id.chartGraficaMensual);
        descripcionX=view.findViewById(R.id.tVDescripcionEjeX);
        descripcionY=view.findViewById(R.id.tVDescripcionEjeY);

        return view;
    }

    @Override
    public void onResume(){
        super.onResume();
        switch(CodigoGrafica.getDescripcion(codigoGrafica)){
            case "CONSUMO_COMBUSTIBLE":
                grafConsumoCombustible();
                break;
            case "CONSUMO_COMBUSTIBLE_KM":
                grafConsumoCombustibleKm();
                break;
            case "COSTE_COMBUSTIBLE_RECARGA" :
                grafCosteCombustibleRecarga();
                break;
            case "KM" :
                grafKm();
                break;
            case "COSTE_RECARGA" :
                grafCosteRecarga();
                break;
            default:
                Log.d("GRAFICAMENSUALFRAGMENT","NO SE A DONDE IR");
        }
    }

    public void grafConsumoCombustible(){
        InterfaceFGraficarConsumoCombustibleImpl f1=new FormateadorGraficarConsumoCombustible();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f1.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM, CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f1.getDataSet();

        }else{
            f1.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f1.getDataSet();

        }

        setUpGraficaLineal("Número de Dia del Mes","Carburante",dataSet);

    }
    public void grafConsumoCombustibleKm(){
        InterfaceFGraficarConsumoCombustibleKmImpl f2=new FormateadorGraficarConsumoCombustibleKm();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f2.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f2.getDataSet();
        }else{
            f2.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f2.getDataSet();
        }
        setUpGraficaLineal("Número de Dia del Mes","Carburante/km",dataSet);
    }


    public void grafCosteCombustibleRecarga(){
        InterfaceFGraficarCosteCombustibleUnidadRecargaImpl f3=new FormateadorGraficarCosteCombustibleUnidadRecarga();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f3.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f3.getDataSet();
        }else{
            f3.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f3.getDataSet();
        }
        setUpGraficaLineal("Número de Dia del Mes","Coste/Recarga",dataSet);
    }
    public void grafKm(){
        InterfaceFGraficarKmImpl f4=new FormateadorGraficarKm();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f4.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f4.getDataSet();
            //dataSet.setLabel("Consumo Anual de Combustible Primario");
        }else{
            f4.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f4.getDataSet();
            //dataSet.setLabel("Consumo Anual de Combustible Secundario");
        }

        setUpGraficaLineal("Número de Dia","Km",dataSet);
    }
    public void grafCosteRecarga(){
        InterfaceFGraficarCosteImpl f5=new FormateadorGraficarCoste();
        LineDataSet dataSet;
        if(CodigoCombustibleVehiculo.getDescripcion(codigoCombustible).equals("CPRIM")){
            f5.comienzaCU(matricula,CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f5.getDataSet();
            //dataSet.setLabel("Consumo Anual de Combustible Primario");
        }else{
            f5.comienzaCU(matricula,CodigoCombustibleVehiculo.CSEC,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA1);
            dataSet=f5.getDataSet();
            //dataSet.setLabel("Consumo Anual de Combustible Secundario");
        }

        setUpGraficaLineal("Número de Dia","Coste(Euros)",dataSet);
    }



    public void setUpGraficaLineal(String labelX,String labelY,LineDataSet dataSet){


        descripcionX.setText(labelX);

        String labelFormateada="";
        for(int i=0;i<labelY.length();i++){
            labelFormateada=labelFormateada.concat(labelY.charAt(i)+"\n");
        }
        labelY=labelFormateada;
        descripcionY.setText(labelY);

        dataSet.setDrawCircleHole( true );
        dataSet.setColor(Color.parseColor("#047dd9"));
        dataSet.enableDashedLine(3f, 6f, 0f);
        dataSet.setLineWidth(3f);

        dataSet.setValueTextColor(Color.parseColor("#FF1300"));
        dataSet.setValueTextSize(15f);
        dataSet.setDrawIcons(false);

        dataSet.setCircleColor(Color.parseColor("#FFAA00"));
        dataSet.setCircleHoleColor(Color.parseColor("#000000"));
        dataSet.setCircleRadius(3f);


        grafica.setTouchEnabled(true);
        grafica.setPinchZoom(true);
        grafica.getDescription().setEnabled(false);

        XAxis xaxis=grafica.getXAxis();
        xaxis.setDrawGridLines(false);
        xaxis.setPosition(XAxis.XAxisPosition.BOTTOM);
        xaxis.setAxisMinimum(0);
        xaxis.setTextSize(20);
        xaxis.setGranularity(1f);


        YAxis yaxis=grafica.getAxisLeft();
        yaxis.setDrawGridLines(false);
        yaxis.setPosition(YAxis.YAxisLabelPosition.OUTSIDE_CHART);
        yaxis.setAxisMinimum(0);
        yaxis.setTextSize(20);
        yaxis.setGranularity(5f);

        LineData grafLineal=new LineData(dataSet);
        grafica.setData(grafLineal);
        grafica.animateX(1500, Easing.Linear);
        grafica.animateY(1500, Easing.Linear);
        grafica.notifyDataSetChanged();
        grafica.invalidate();
        //grafica.notifyDataSetChanged();
    }
}
