package com.example.juanalonsoastruga.cargascontrol.Vista.RegistroRecarga;

import android.Manifest;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.provider.MediaStore;
import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.TimePicker;
import android.widget.Toast;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CURegistrarRecarga.FormateadorRegistrarRecarga;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CURegistrarRecarga.InterfaceFRegistrarRecargaImpl;

import java.util.ArrayList;
import java.util.Calendar;

public class RegistrarRecargaActivity extends AppCompatActivity {
    private String TAG ="RECARGAFRAGMENT" ;

    private final int SELECT_PICTURE = 300;
    private final int CAMERA_RESULT = 101;
    private String selectedDate;
    private TextView etFecha;
    private TextView etHora;
    private EditText etKm;
    private EditText etCoste;
    private Spinner spCombustible;
    private EditText etRecarga;
    private Button bttFechaR;
    private Button bttHoraR;
    private Button bttRegistrar;
    private ImageView fotoBoton;
    private Integer dia,mes,ano,hora,minuto;
    private Context contxt=this;
    private InterfaceFRegistrarRecargaImpl formateador;
    private String matricula;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_registrar_recarga);
        etHora = findViewById(R.id.et_mostrar_hora_picker);
        etFecha = findViewById(R.id.et_mostrar_fecha_picker);
        etKm=findViewById(R.id.editTextKmRecarga);
        etCoste=findViewById(R.id.editTextCosteRecarga);
        spCombustible=findViewById(R.id.combustibleRecargado);
        etRecarga=findViewById(R.id.editTextURecarga);
        bttFechaR = findViewById(R.id.bttFechaR);
        bttHoraR = findViewById(R.id.bttHoraR);
        fotoBoton = findViewById(R.id.imageViewFotoTicket);
        bttRegistrar = findViewById(R.id.botonRegistrarRecarga);
        formateador =new FormateadorRegistrarRecarga();

    }
    @Override
    public void onResume() {
        super.onResume();
        SharedPreferences prefs =  getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
        matricula=prefs.getString("matricula","null");
        Log.d("EVAL","matricula recuperada SharedPrefs "+matricula);
        ArrayList<String> clist= new ArrayList<String>(1);
        clist.add(prefs.getString("CPRIM","null"));
        if(!prefs.getString("CSEC","null").equals("null")){
            clist.add(prefs.getString("CSEC","null"));
        }
        ArrayAdapter<String> combustibles = new ArrayAdapter(this, android.R.layout.simple_spinner_item, clist);
        spCombustible.setAdapter(combustibles );
        bttFechaR.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                 setFecha();

            }
        });
        bttHoraR.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setTiempo();
            }
        });
        BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
        Bitmap bitmap;
        if (bitmapDrawable == null || bitmapDrawable.getBitmap() == null || bitmapDrawable.getBitmap().isRecycled()) {
            fotoBoton.buildDrawingCache();
            bitmap = BitmapFactory.decodeResource(this.getResources(),
                    R.drawable.icono_camara_grande);
        } else {
            bitmap = bitmapDrawable.getBitmap();
        }

        fotoBoton.setImageBitmap(bitmap);
        int ancho = 500;
        int alto = 500;
        //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
        //fotoBoton.setLayoutParams(params);
        fotoBoton.setOnClickListener(new View.OnClickListener (){
            @Override
            public void onClick(View v) {
                useCamera();
            }
        });
        bttRegistrar.setOnClickListener(new View.OnClickListener (){
            @Override
            public void onClick(View v) {
              dispatchWithDialog();
            }
        });
    }


    public void dispatchWithDialog(){
        //Dialog Seleccion Combustibe Primario o Secundario

            final String[] option = {"Completar el registro","Cancelar"};
            AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
            alertDialogBuilder.setTitle("¿Desea Completar la operación?");
            alertDialogBuilder.setMessage("Una vez completada no podrá deshacer los cambios");
            alertDialogBuilder.setPositiveButton("Completar la operación", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    formateador.comienzoCU();
                    cargarDatosEnVista();
                    formateador.solicitarRegistro();

                    if (formateador.isRegistroCorrecto()) {
                        ((BitmapDrawable) fotoBoton.getDrawable()).getBitmap().recycle();
                        fotoBoton.setImageBitmap(null);
                        System.gc();
                        finish();
                    } else {
                        showErrorMsg(formateador.getMsgError());
                    }
                    int ancho = 500;
                    int alto = 500;
                    //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
                    //fotoBoton.setLayoutParams(params);

                }
            });

            alertDialogBuilder.setNegativeButton("Cancelar",new DialogInterface.OnClickListener() {

                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.dismiss();
                }
            });
            alertDialogBuilder.show();


    }


    private void showErrorMsg(String s){

        Toast.makeText( getApplicationContext(), s, Toast.LENGTH_LONG).show();
    }

    private void cargarDatosEnVista() {


        if(ano==null||mes==null||dia==null){
            formateador.registrarSinFecha();
            Log.d("EVAL"," NO FECHA FRAGMENT");
        }else{
            Log.d("EVAL"," ANO "+ano+" MES "+mes+" DIA "+dia);
            formateador.setConFecha();
        }
        if(hora==null||minuto==null){
            formateador.registrarSinTiempo();
            Log.d("EVAL"," NO HORA FRAGMENT");
        }else{
            Log.d("EVAL"," HORA "+hora+" MINUTO "+minuto);
            formateador.setConTiempo();
        }
        if(!(formateador.isSinFecha()|| formateador.isSinTiempo())){
            formateador.registrarMatricula(matricula);
            formateador.registrarFechayTiempo(ano,mes,dia,hora,minuto);

                try{
                    formateador.registrarKm(Double.parseDouble(String.valueOf(etKm.getText())));
                    formateador.registrarCoste(Double.parseDouble(String.valueOf(etCoste.getText())));

                    formateador.registrarCombustible(spCombustible.getSelectedItem().toString());

                    formateador.registrarRecarga(Double.parseDouble(String.valueOf(etRecarga.getText())));

                    BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
                    Bitmap bitmap;
                    if (bitmapDrawable == null || bitmapDrawable.getBitmap() == null || bitmapDrawable.getBitmap().isRecycled()) {
                        fotoBoton.buildDrawingCache();
                        bitmap = BitmapFactory.decodeResource(this.getResources(),
                                R.drawable.icono_camara_grande);
                    } else {
                        bitmap = bitmapDrawable.getBitmap();
                    }

                    fotoBoton.setImageBitmap(bitmap);
                    formateador.registraFoto(bitmap);
                    formateador.registroConCamposCompletos();
                }catch(Exception e){
                    formateador.registroConCamposIncompletos();
                }


        }
    }

    private void setTiempo() {
        Calendar c = Calendar.getInstance();
        hora= c.get(Calendar.HOUR_OF_DAY);
        minuto=c.get(Calendar.MINUTE);
        TimePickerDialog timePickerDialog = new TimePickerDialog(this,R.style.DialogTheme, new TimePickerDialog.OnTimeSetListener() {
            @Override
            public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
                etHora.setText((hourOfDay<10?"0"+hourOfDay:hourOfDay)+":"+(minute<10?"0"+minute:minute));
                 hora=hourOfDay;
                minuto=minute;
            }
        },hora,minuto,false);
        Log.d("EVAL CLICK"," HORA "+hora+" MINUTO "+minuto);
        timePickerDialog.show();
    }

    public void setFecha(){
         Calendar c = Calendar.getInstance();
         dia= c.get(Calendar.DAY_OF_MONTH);
         mes=c.get(Calendar.MONTH);
         ano=c.get(Calendar.YEAR);
         DatePickerDialog datePickerDialog = new DatePickerDialog(this,R.style.DialogTheme, new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int month, int dayOfMonth) {
                etFecha.setText((dayOfMonth<10?"0"+dayOfMonth:dayOfMonth)+"/"+((month+1)<10?"0"+(month+1):(month+1))+"/"+year);
                ano=year;
                mes=month+1;
                dia=dayOfMonth;

            }
         },ano,mes,dia);
        Calendar cal = Calendar.getInstance();
        cal.set(Calendar.DAY_OF_MONTH, cal.getActualMinimum(Calendar.DAY_OF_MONTH));
        cal.set(Calendar.HOUR_OF_DAY,cal.getActualMinimum(Calendar.HOUR_OF_DAY));
        datePickerDialog.getDatePicker().setMinDate(cal.getTime().getTime());
        cal.set(Calendar.DAY_OF_MONTH, cal.getActualMaximum(Calendar.DAY_OF_MONTH));
        cal.set(Calendar.HOUR_OF_DAY,cal.getActualMaximum(Calendar.HOUR_OF_DAY));
        datePickerDialog.getDatePicker().setMaxDate(cal.getTime().getTime());
        Log.d("EVAL CLICK"," ANO "+ano+" MES "+mes+" DIA "+dia);
        datePickerDialog.show();
    }

    public void useCamera(){
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
        Log.d(TAG, "DialogoSeleccionMedios");
        alertDialogBuilder.setTitle("Importar la Imágen");
        final String[] option = {"Cámara", "Galería", "Cancelar"};
        // alertDialogBuilder.setMessage("Seleccione de dónde desea importar la imagen");
        alertDialogBuilder.setItems(option, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                Log.d(TAG, "SeleccionMedios");
                if (option[which].equals("Cámara")) {
                    Log.d(TAG, "Cámara Seleccionado");
                    openCamera();
                } else if (option[which].equals("Galería")) {
                    Log.d(TAG, "Galeria Seleccionado");
                    Intent intent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                    intent.setType("image/*");
                    startActivityForResult(intent.createChooser(intent, "Selecciona app de imagen"), SELECT_PICTURE);
                } else {
                    dialog.dismiss();
                }
            }
        });
        int ancho = 500;
        int alto = 500;
        //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
       // fotoBoton.setLayoutParams(params);
        alertDialogBuilder.show();
    }
    private void openCamera() {

        if (ContextCompat.checkSelfPermission(this.contxt, Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) {
            dispatchTakenPictureIntent();

        }else {
            if (shouldShowRequestPermissionRationale(Manifest.permission.CAMERA)) {
                Toast.makeText(this.contxt, "Se necesita permiso para acceder a esa funcionalidad", Toast.LENGTH_LONG).show();

            }
            requestPermissions(new String[]{Manifest.permission.CAMERA,Manifest.permission.WRITE_EXTERNAL_STORAGE}, CAMERA_RESULT);
        }
    }
    private void dispatchTakenPictureIntent(){
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        if(takePictureIntent.resolveActivity(this.getPackageManager())!=null){

            startActivityForResult(takePictureIntent, CAMERA_RESULT);
            //onActivityResult(101,0,takePictureIntent);

        }
    }
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        try {
            Log.d(TAG, "IMAGEN  ");
            if (requestCode == CAMERA_RESULT) {
                Bundle extras = data.getExtras();
                Matrix matrix = new Matrix();
                // matrix.postRotate(90);
                BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
                Bitmap bitmap;
                if (bitmapDrawable == null) {
                    fotoBoton.buildDrawingCache();
                    bitmap = fotoBoton.getDrawingCache();
                    fotoBoton.buildDrawingCache(false);
                } else {
                    bitmap = bitmapDrawable.getBitmap();
                }
                bitmap = (Bitmap) extras.get("data");
                bitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
                        bitmap.getHeight(), matrix, true);
                fotoBoton.setImageBitmap(bitmap);
                //bitmap.recycle();
                Log.d(TAG, "IMAGEN CAMBIADA");
            } else {
                if (requestCode == SELECT_PICTURE) {
                    Uri imageUri = data.getData();
                    fotoBoton.setImageURI(imageUri);

                }
            }
        } catch (Exception e) {
            Log.d(TAG, "No se ha llegado a tomar imagen");
        }

    }
    @Override
    public void onRequestPermissionsResult(int requestCode,@NonNull String[] permissions, @NonNull int[] grantResults){
        if(requestCode == CAMERA_RESULT){
            if(grantResults.length>0&&grantResults[0]==PackageManager.PERMISSION_GRANTED&&grantResults[1]==PackageManager.PERMISSION_GRANTED){
                dispatchTakenPictureIntent();
            }else{
                Toast.makeText(this.getApplicationContext(), "Se necesita permiso para acceder a esa funcionalidad", Toast.LENGTH_LONG).show();

            }
        }else{
            super.onRequestPermissionsResult(requestCode,permissions,grantResults);
        }
    }
}
