package com.example.juanalonsoastruga.cargascontrol.Vista.RegistroVehiculo;

import android.Manifest;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.os.Bundle;
import androidx.fragment.app.Fragment;
import android.provider.MediaStore;
import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;

import android.widget.Button;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CURegistrarVehiculo.FormateadorRegistroVehiculo;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CURegistrarVehiculo.InterfaceFRegistroVehiculoImpl;

import java.util.List;



public class RegistroVehiculoFragment extends Fragment {

    private View view;
    private TextView editTextNombreVehiculo,editTextMatriculaVehiculo,editTextMarcaVehiculo,editTextModeloVehiculo;
    private TextView editTextAnio,editTextKM,editTextCapPrim,editTextCapSec;
    private ImageView fotoBoton;
    private Spinner combustiblePrimario;
    private Spinner combustibleSecundario;
    private Button botonGuardado;

    private final int SELECT_PICTURE = 300;
    private final int CAMERA_RESULT = 101;


    private InterfaceFRegistroVehiculoImpl formateador;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        this.view = inflater.inflate(R.layout.fragment_registro_vehiculo, container, true);
        this.editTextNombreVehiculo = view.findViewById(R.id.editTextNombreVehiculo);
        this.editTextMatriculaVehiculo = view.findViewById(R.id.editTextMatriculaVehiculo);
        this.editTextMarcaVehiculo = view.findViewById(R.id.editTextMarcaVehiculo);
        this.editTextModeloVehiculo = view.findViewById(R.id.editTextModeloVehiculo);
        this.editTextAnio = view.findViewById(R.id.editTextAnio);
        this.editTextKM = view.findViewById(R.id.editTextKM);
        this.editTextCapPrim = view.findViewById(R.id.editTextCapPrim);
        this.editTextCapSec = view.findViewById(R.id.editTextCapSec);
        this.fotoBoton = view.findViewById(R.id.imageViewFotoVehiculo);

        this.combustiblePrimario = view.findViewById(R.id.combustible1);
        this.combustibleSecundario = view.findViewById(R.id.combustible2);


        formateador = new FormateadorRegistroVehiculo();
        return view;
    }

    @Override
    public void onResume() {
        super.onResume();

        ArrayAdapter<String> combustiblesP;
        ArrayAdapter<String> combustiblesS;

        formateador.init();
        List<String> listado = formateador.getInfoSpinners();

        int ancho = 500;
        int alto = 500;
       // TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
        //fotoBoton.setLayoutParams(params);


        combustiblesP = new ArrayAdapter(this.getActivity(), android.R.layout.simple_spinner_item, listado);

        combustiblesP.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        combustiblePrimario.setAdapter(combustiblesP);
        combustiblesP.notifyDataSetChanged();

        List<String> listado2= formateador.getInfoSpinners();
        listado2.add("Ninguno");

        combustiblesS = new ArrayAdapter(this.getActivity(), android.R.layout.simple_spinner_item, listado2);

        combustiblesS.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        combustibleSecundario.setAdapter(combustiblesS);
        combustiblesS.notifyDataSetChanged();


        BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
        Bitmap bitmap;
        if (bitmapDrawable == null|| bitmapDrawable.getBitmap()==null||bitmapDrawable.getBitmap().isRecycled()) {
            fotoBoton.buildDrawingCache();
           bitmap = BitmapFactory.decodeResource(this.getContext().getResources(),
                    R.drawable.icono_camara_grande);
        } else {
            bitmap = bitmapDrawable.getBitmap();
        }

        fotoBoton.setImageBitmap(bitmap);

        fotoBoton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(getContext());

                alertDialogBuilder.setTitle("Importar la Imágen");
                final String[] option = {"Cámara", "Galería", "Cancelar"};
                // alertDialogBuilder.setMessage("Seleccione de dónde desea importar la imagen");
                alertDialogBuilder.setItems(option, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {

                        if (option[which] == "Cámara") {

                            openCamera();
                        } else if (option[which] == "Galería") {

                            Intent intent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
                            intent.setType("image/*");
                            startActivityForResult(intent.createChooser(intent, "Selecciona app de imagen"), SELECT_PICTURE);
                        } else {
                            dialog.dismiss();
                        }
                    }
                });

                alertDialogBuilder.show();
                int ancho = 500;
                int alto = 500;
                //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
                //fotoBoton.setLayoutParams(params);
            }
        });

        botonGuardado=view.findViewById(R.id.botonGuardado);

        botonGuardado.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {

                        boolean validarCampos=true;
                        String msj=null;
                        String cmp=null;
                        //Transmitele los datos a la formateador del MVP
                        if(editTextNombreVehiculo.getText().length()!=0){
                            formateador.actualizaNombre(editTextNombreVehiculo.getText().toString());
                        }else{
                            formateador.actualizaNombre(null);
                        }
                        if(editTextMatriculaVehiculo.getText().length()!=0){
                            formateador.actualizaMatricula(editTextMatriculaVehiculo.getText().toString());
                        }else{
                            formateador.actualizaMatricula(null);
                        }
                        formateador.actualizaMarca(editTextMarcaVehiculo.getText().toString());
                        formateador.actualizaModelo(editTextModeloVehiculo.getText().toString());
                        int año;
                        if(!(editTextAnio.getText().toString().equals(""))){
                            try {
                                año = Integer.parseInt(editTextAnio.getText().toString());
                                if(año<1890){
                                    throw new IllegalArgumentException();
                                }
                                formateador.actualizaAno(año);
                            }catch (Exception e){
                                validarCampos=false;
                                cmp="año";
                                año=0;
                                formateador.deteccionCampoInvalido(cmp);
                            }


                        }
                        double km;
                        if(!(editTextKM.getText().toString().equals(""))){
                            try {
                                km=Double.parseDouble(editTextKM.getText().toString());
                                if(km<0||editTextKM.getText().toString().charAt(0)=='.'){
                                    throw new IllegalArgumentException();
                                }
                                formateador.actualizaKm(km);
                            }catch(Exception e){

                                validarCampos=false;
                                cmp="km";
                                km=0;
                                formateador.deteccionCampoInvalido(cmp);

                            }
                        }
                        if(combustiblePrimario.getSelectedItem().toString().length()!=0){
                            formateador.actualizaCPrimario(combustiblePrimario.getSelectedItem().toString());
                        }else{
                            formateador.actualizaCPrimario(null);
                        }
                        double capacidad;
                        if(!(editTextCapPrim.getText().toString().equals("") )){

                            try {
                                capacidad=Double.parseDouble(editTextCapPrim.getText().toString());
                                if(capacidad<0||editTextCapPrim.getText().toString().charAt(0)=='.'){
                                    throw new IllegalArgumentException();
                                }
                                formateador.actualizaCapTP(capacidad);
                            }catch (Exception e){
                                validarCampos=false;
                                cmp="CTP";
                                capacidad=0;
                                formateador.deteccionCampoInvalido(cmp);
                            }
                        }
                        if(!combustibleSecundario.getSelectedItem().toString().equals("Ninguno")){
                            formateador.actualizaCSecundario(combustibleSecundario.getSelectedItem().toString());
                            if(!(editTextCapSec.getText().toString().equals(""))){


                                try {
                                    capacidad=Double.parseDouble(editTextCapSec.getText().toString());
                                    if(capacidad<0||editTextCapSec.getText().toString().charAt(0)=='.'){
                                        throw new IllegalArgumentException();
                                    }
                                    formateador.actualizaCapTS(capacidad);
                                }catch (Exception e){
                                    validarCampos=false;
                                    cmp="año";
                                    capacidad=0;
                                    formateador.deteccionCampoInvalido(cmp);
                                }
                            }
                        }else{
                            formateador.actualizaCSecundario(null);
                            formateador.actualizaCapTS(0);
                        }


                        BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
                        Bitmap bitmap;
                        if (bitmapDrawable == null||bitmapDrawable.getBitmap()==null||bitmapDrawable.getBitmap().isRecycled()) {
                            fotoBoton.buildDrawingCache();
                            bitmap = fotoBoton.getDrawingCache();
                            fotoBoton.buildDrawingCache(false);
                        } else {
                            bitmap = bitmapDrawable.getBitmap();
                        }
                        fotoBoton.setImageBitmap(bitmap);


                            formateador.actualizaFoto(bitmap);


                        if(validarCampos) {

                            formateador.solicitarGuardado();

                            if (formateador.isRegistroCompletado()) {
                                //drawable.getBitmap().recycle();
                                ((BitmapDrawable) fotoBoton.getDrawable()).getBitmap().recycle();
                                fotoBoton.setImageBitmap(null);
                                System.gc();
                                getActivity().finish();


                            } else {


                                Toast.makeText(getActivity().getApplicationContext(), formateador.getMensajeError(), Toast.LENGTH_LONG).show();


                            }
                        }else{
                            String mesj= formateador.getMensajeError();
                            Toast.makeText(getActivity().getApplicationContext(), mesj, Toast.LENGTH_LONG).show();

                        }

                    }
                }
        );


    }


    private void openCamera() {

        if (ContextCompat.checkSelfPermission(getContext(), Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) {
           dispatchTakenPictureIntent();

        }else {
            if (shouldShowRequestPermissionRationale(Manifest.permission.CAMERA)) {
                Toast.makeText(getActivity().getApplicationContext(), "Se necesita permiso para acceder a esa funcionalidad", Toast.LENGTH_LONG).show();

            }
            requestPermissions(new String[]{Manifest.permission.CAMERA,Manifest.permission.WRITE_EXTERNAL_STORAGE}, CAMERA_RESULT);
        }
    }
    private void dispatchTakenPictureIntent(){
        Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
        if(takePictureIntent.resolveActivity(this.getActivity().getPackageManager())!=null){

                startActivityForResult(takePictureIntent, CAMERA_RESULT);
                //onActivityResult(101,0,takePictureIntent);

        }
    }
    @Override
    public void onActivityResult(int requestCode,int resultCode,Intent data){
        try {

            if (requestCode == CAMERA_RESULT) {
                Bundle extras = data.getExtras();
                Matrix matrix = new Matrix();
               // matrix.postRotate(90);
                BitmapDrawable bitmapDrawable = ((BitmapDrawable) fotoBoton.getDrawable());
                Bitmap bitmap;
                if(bitmapDrawable==null){
                    fotoBoton.buildDrawingCache();
                    bitmap = fotoBoton.getDrawingCache();
                    fotoBoton.buildDrawingCache(false);
                }else
                {
                    bitmap = bitmapDrawable.getBitmap();

                }
                bitmap = (Bitmap) extras.get("data");
                bitmap  = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
                        bitmap.getHeight(), matrix, true);
                fotoBoton.setImageBitmap(bitmap);
                //bitmap.recycle();
                int ancho = 500;
                int alto = 500;
                //TableRow.LayoutParams params = new TableRow.LayoutParams(ancho, alto);
                //fotoBoton.setLayoutParams(params);

            }else{
                if(requestCode == SELECT_PICTURE){
                    Uri imageUri = data.getData();
                    fotoBoton.setImageURI(imageUri);

                }
            }
        } catch (Exception e){ }

    }

    @Override
    public void onRequestPermissionsResult(int requestCode,@NonNull String[] permissions, @NonNull int[] grantResults){
        if(requestCode == CAMERA_RESULT){
            if(grantResults.length>0&&grantResults[0]==PackageManager.PERMISSION_GRANTED&&grantResults[1]==PackageManager.PERMISSION_GRANTED){
                dispatchTakenPictureIntent();
            }else{
                Toast.makeText(getActivity().getApplicationContext(), "Se necesita permiso para acceder a esa funcionalidad", Toast.LENGTH_LONG).show();

            }
        }else{
            super.onRequestPermissionsResult(requestCode,permissions,grantResults);
        }
    }
}
