package com.example.juanalonsoastruga.cargascontrol.Vista.SeccionPrincipal;

import android.Manifest;
import android.app.FragmentManager;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.os.Bundle;
import androidx.core.app.ActivityCompat;
import androidx.core.view.GravityCompat;
import androidx.appcompat.app.ActionBarDrawerToggle;

import android.view.MenuItem;

import com.example.juanalonsoastruga.cargascontrol.Vista.CalculadoraTrayectos.CalculadoraTrayectoActivity;
import com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarGasolinerasCercanas.TabsInformacionGasolinerasActivity;
import com.example.juanalonsoastruga.cargascontrol.Vista.Mapa.MapsActivity;
import com.google.android.material.navigation.NavigationView;
import androidx.drawerlayout.widget.DrawerLayout;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import android.view.Menu;
import android.view.View;
import android.widget.Button;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimaRecarga.FormateadorConsultarUltimaRecarga;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimoVehiculo.FormateadorConsultarUltimoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarInformacionVehiculo_ListadoRecarga_ConsultarGraficas.TabsGeneralActivity;
import com.example.juanalonsoastruga.cargascontrol.Vista.ConsultarRecarga.ConsultarRecargaActivity;
import com.example.juanalonsoastruga.cargascontrol.Vista.Listado_Borrado_Vehiculos.MostrarListadoVehiculosActivity;
import com.example.juanalonsoastruga.cargascontrol.Datos.LocationProvider.LocationService;
import com.example.juanalonsoastruga.cargascontrol.R;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimaRecarga.InterfaceFConsultarUltimaRecargaImpl;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimoVehiculo.InterfaceFConsultarUltimoVehiculoImpl;

import java.util.Hashtable;

public class MenuPrincipal extends AppCompatActivity
        implements NavigationView.OnNavigationItemSelectedListener, View.OnClickListener {
    private Button btnOp1;
    private Button btnOp2;
    private Button btnOp3;
    private NavigationView navigationView ;
    private DrawerLayout drawer;
    private InterfaceFConsultarUltimoVehiculoImpl formateadorVehiculo;
    private InterfaceFConsultarUltimaRecargaImpl formateadorRecarga;
    private FragmentManager supportFragmentManager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);



        setContentView(R.layout.activity_menu_principal);
        Toolbar toolbar = findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        btnOp1 = (Button)findViewById(R.id.bListVehicles);
        btnOp2 = (Button)findViewById(R.id.bMapa);
        btnOp3 = (Button)findViewById(R.id.bttnListGasolineras);

        drawer = findViewById(R.id.drawer_layout);
        navigationView = findViewById(R.id.nav_view);
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this, drawer, toolbar, R.string.navigation_drawer_open, R.string.navigation_drawer_close);
        drawer.addDrawerListener(toggle);
        toggle.syncState();
        navigationView.setNavigationItemSelectedListener(this);
        formateadorVehiculo = new FormateadorConsultarUltimoVehiculo();
        formateadorRecarga = new FormateadorConsultarUltimaRecarga();
    }

    @Override
    public void onResume() {

        super.onResume();

        formateadorVehiculo.eventoInicio();
        formateadorRecarga.eventoInicio();
        Menu menu=navigationView.getMenu();
        if(formateadorVehiculo.getIdVehiculo()==null|| formateadorVehiculo.getIdVehiculo().equals("null")||(
                formateadorVehiculo.getIdVehiculo()!=null&&!formateadorVehiculo.existeVehiculo(formateadorVehiculo.getIdVehiculo()))){
            disableMenuItems(menu);
            formateadorVehiculo.borraFichero();
        }else{
            enableMenuItems(menu);
        }
        if((formateadorRecarga.getIdRecarga()==null|| formateadorRecarga.getIdRecarga().get("id").equals("null"))||(
                formateadorVehiculo.getIdVehiculo()!=null&&!formateadorVehiculo.existeVehiculo(formateadorVehiculo.getIdVehiculo()))){
            disableMenuRecargaItem(menu);
            formateadorRecarga.borraFichero();
        }else{
            enableMenuRecargaItem(menu);
        }
    }

    private void disableMenuItems(Menu menu){
        menu.findItem(R.id.nav_datos_vehiculo).setEnabled(false);
        menu.findItem(R.id.nav_recargas_vehiculo).setEnabled(false);
        menu.findItem(R.id.nav_graficas_y_estadisticas_vehiculo).setEnabled(false);
        disableMenuRecargaItem(menu);
    }

    private void disableMenuRecargaItem(Menu menu){
        menu.findItem(R.id.nav_datos_recarga).setEnabled(false);
    }

    private void enableMenuItems(Menu menu){
        menu.findItem(R.id.nav_datos_vehiculo).setEnabled(true);
        menu.findItem(R.id.nav_recargas_vehiculo).setEnabled(true);
        menu.findItem(R.id.nav_graficas_y_estadisticas_vehiculo).setEnabled(true);
        enableMenuRecargaItem(menu);
    }

    private void enableMenuRecargaItem(Menu menu){
        menu.findItem(R.id.nav_datos_recarga).setEnabled(true);
    }

    @Override
    public void onBackPressed() {
        DrawerLayout drawer = findViewById(R.id.drawer_layout);
        if (drawer.isDrawerOpen(GravityCompat.START)) {
            drawer.closeDrawer(GravityCompat.START);
        } else {
            super.onBackPressed();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        //getMenuInflater().inflate(R.menu.menu_principal_opciones, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @SuppressWarnings("StatementWithEmptyBody")
    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        // Handle navigation view item clicks here.
        int id = item.getItemId();

        if (id == R.id.nav_datos_vehiculo&&item.isEnabled()) {
            String matricula= formateadorVehiculo.getIdVehiculo();
            Intent tabs = new Intent( this , TabsGeneralActivity.class);
            tabs.putExtra("selected_tab","0");
            this.startActivity(tabs);
        } else if (id == R.id.nav_recargas_vehiculo&&item.isEnabled()) {
            String matricula= formateadorVehiculo.getIdVehiculo();
            Intent tabs = new Intent( this , TabsGeneralActivity.class);
            tabs.putExtra("selected_tab","1");
            this.startActivity(tabs);
        } else if (id == R.id.nav_graficas_y_estadisticas_vehiculo&&item.isEnabled()) {
            String matricula= formateadorVehiculo.getIdVehiculo();
            Intent tabs = new Intent( this , TabsGeneralActivity.class);
            tabs.putExtra("selected_tab","2");
            this.startActivity(tabs);
        } else if (id == R.id.nav_datos_recarga&&item.isEnabled()) {
            Intent activity = new Intent( this , ConsultarRecargaActivity.class);
            Hashtable tabla= formateadorRecarga.getIdRecarga();
            SharedPreferences prefs= this.getSharedPreferences("Preferencias", Context.MODE_PRIVATE);
            SharedPreferences.Editor editor = prefs.edit();
            editor.putString("matricula",tabla.get("id").toString());
            editor.commit();
            activity.putExtra("fecha", Long.parseLong((String) tabla.get("fecha")));
            activity.putExtra("combustible",tabla.get("combustible").toString());
            this.startActivity(activity);
        }
        DrawerLayout drawer = findViewById(R.id.drawer_layout);
        drawer.closeDrawer(GravityCompat.START);
        return true;
    }

    @Override
    public void onClick(View v) {
        //selecciona por id el boton clickado
        switch(v.getId()) {
            case R.id.bListVehicles:
                startActivity(new Intent(this, MostrarListadoVehiculosActivity.class));

                break;
            case R.id.bMapa:
                if (ActivityCompat.checkSelfPermission( this.getApplicationContext(), Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(  this.getApplicationContext(), Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                    requestPermissions( new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, 1);
                    return;
                }else {

                    startActivity(new Intent(this, MapsActivity.class));

                }
                break;
            case R.id.bttnListGasolineras:
                if (ActivityCompat.checkSelfPermission( this.getApplicationContext(), Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(  this.getApplicationContext(), Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                    requestPermissions( new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, 1);
                    return;
                }else{


                    startActivity(new Intent(this, TabsInformacionGasolinerasActivity.class));

                }
                break;
            case R.id.bCalc:
                startActivity(new Intent(this, CalculadoraTrayectoActivity.class));
            default:
                break;
        }
    }
}
