package com.example.juanalonsoastruga.cargascontrol.Controlador.CUBorrarVehiculo;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUBorrarVehiculo.FormateadorBorradoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUBorrarVehiculo.InterfaceMBorradoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUBorrarVehiculo.ModeloBorrarVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUBorrarVehiculo.InterfaceFBorradoVehiculo;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorBorradoVehiculoTest {
    private ControladorBorradoVehiculo controlador;
    @Mock
    private InterfaceFBorradoVehiculo formateador;
    @Mock
    private InterfaceMBorradoVehiculo modelo;



    @Before
    public  void setUp(){
        formateador =createMock(FormateadorBorradoVehiculo.class);
        modelo=createMock(ModeloBorrarVehiculo.class);
        controlador =new ControladorBorradoVehiculo(formateador);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }
    @Test
    public void setViewCorrect(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }
    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }
    @Test
    public void setModeloCorrect(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }
    @Test
    public void seleccionBotonBorrado(){
        expect(formateador.muestraDialogoConfirmacionBorrado()).andReturn(true);
        replay(formateador);
        controlador.setFormateador(formateador);
        controlador.botonBorrarSeleccionado();
        verify(formateador);
    }
    @Test
    public void borradoConfirmado(){
        expect(modelo.borrarVehiculo("")).andReturn(true);
        replay(modelo);
        controlador.setModel(modelo);
        controlador.borradoConfirmado("");
        verify(modelo);

    }

}