package com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarInformacionGasolinera;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarInformacionGasolinera.InterfaceMConsultarInformacionGasolinera;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarInformacionGasolinera.InterfaceFConsultarInformacionGasolinera;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorConsultarInformacionGasolineraTest {

    private ControladorConsultarInformacionGasolinera controlador;
    private InterfaceFConsultarInformacionGasolinera formateador;
    private InterfaceMConsultarInformacionGasolinera modelo;
    private DTOGasolinera dto;
    @Before
    public void setUp(){
        formateador = createMock(InterfaceFConsultarInformacionGasolinera.class);
        modelo= createMock(InterfaceMConsultarInformacionGasolinera.class);
        controlador = new ControladorConsultarInformacionGasolinera(formateador);
        dto=createMock(DTOGasolinera.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }

    @Test
    public void setViewNotNull(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }

    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }

    @Test
    public void setModeloNotNull(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }


    @Test
    public void comienzaCU() {
         modelo.getDatosGasolinera(0,0,"");
         EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return dto;
            }
         });
         formateador.setDatosGasolinera(dto);
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(modelo);
        replay(formateador);
        controlador.setModel(modelo);
        controlador.setFormateador(formateador);
        controlador.comienzaCU(0,0,"");
        verify(modelo);
        verify(formateador);
    }
}