package com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarInformacionVehiculo;


import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarInformacionVehiculo.FormateadorConsultarInformacionVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarInformacionVehiculo.InterfaceFConsultarInformacion;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarInformacionVehiculo.InterfaceMConsultarInformacion;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarInformacionVehiculo.ModeloConsultarInformacionVehiculo;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.junit.Assert.*;

public class ControladorConsultarInformacionVehiculoTest {
    @Mock
    private InterfaceFConsultarInformacion formateador;
    @Mock
    private InterfaceMConsultarInformacion modelo;

    private ControladorConsultarInformacionVehiculo controlador;

    @Before
    public  void setUp(){
        formateador =createMock(FormateadorConsultarInformacionVehiculo.class);
        modelo=createMock(ModeloConsultarInformacionVehiculo.class);
        controlador =new ControladorConsultarInformacionVehiculo(formateador);
    }
    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }
    @Test
    public void setViewCorrect(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }
    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }
    @Test
    public void setModeloCorrect(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }


}