package com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimaRecarga;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimaRecarga.InterfaceFConsultarUltimaRecarga;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarUltimaRecarga.InterfaceMConsultarUltimaRecarga;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorConsultarUltimaConsultaTest {

    private InterfaceFConsultarUltimaRecarga formateador;
    private ControladorConsultarUltimaRecarga controlador;
    private InterfaceMConsultarUltimaRecarga modelo;
    private Hashtable ids;

    @Before
    public void setUp(){
        formateador =createMock(InterfaceFConsultarUltimaRecarga.class);
        controlador =new ControladorConsultarUltimaRecarga(formateador);
        modelo=createMock(InterfaceMConsultarUltimaRecarga.class);
        ids=createMock(Hashtable.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setView(null);
    }
    @Test
    public void setViewNotNull(){
        controlador.setView(formateador);
        assertNotNull(controlador.getView());
    }
    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }
    @Test
    public void setModeloNotNull(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }

    @Test
    public void recuperaIdUltimaRecarga() {

        expect(modelo.recuperaIdUltimaRecarga()).andReturn(ids);

        replay(formateador);
        replay(modelo);
        controlador.setModel(modelo);
        controlador.setView(formateador);
        controlador.eventoInicio();

        verify(formateador);
        verify(modelo);
    }
}