package com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimoVehiculo;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimoVehiculo.InterfaceFConsultarUltimoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarUltimoVehiculo.InterfaceMConsultarUltimoVehiculo;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorConsultarUltimoVehiculoTest {
    @Mock
    private InterfaceFConsultarUltimoVehiculo formateador;
    private ControladorConsultarUltimoVehiculo controlador;
    @Mock
    private InterfaceMConsultarUltimoVehiculo modelo;
    @Before
    public void setUp(){
        formateador =createMock(InterfaceFConsultarUltimoVehiculo.class);
        controlador =new ControladorConsultarUltimoVehiculo(formateador);
        modelo=createMock(InterfaceMConsultarUltimoVehiculo.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }
    @Test
    public void setViewCorrect(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }
    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }
    @Test
    public void setModeloCorrect(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }
    @Test
    public void recuperaIdVehiculoUltimaConsulta() {
        expect(modelo.recuperaIdUltimoVehiculoConsultado()).andReturn("");
        formateador.setIdVehiculo("");
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(modelo);
        replay(formateador);
        controlador.setModel(modelo);
        controlador.eventoInicio();
        verify(modelo);
        verify(formateador);
    }
}