package com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoGasolineras;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoGasolineras.InterfaceFMostrarListadoGasolineras;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoGasolineras.InterfaceMMostrarListadoGasolineras;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;
import java.util.List;

import static org.easymock.EasyMock.anyDouble;
import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorMostrarListadoGasolinerasTest {

    private InterfaceFMostrarListadoGasolineras formateador;
    private ControladorMostrarListadoGasolineras controlador;
    private InterfaceMMostrarListadoGasolineras modelo;
    private Hashtable ids;
    private List< DTOGasolinera > listado;

    @Before
    public void setUp(){
        formateador =createMock(InterfaceFMostrarListadoGasolineras.class);
        controlador =new ControladorMostrarListadoGasolineras(formateador);
        modelo=createMock(InterfaceMMostrarListadoGasolineras.class);
        ids=createMock(Hashtable.class);
        listado=createMock( List.class);
    }


    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }

    @Test
    public void setViewNotNull(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }

    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }

    @Test
    public void setModeloNotNull(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }

    @Test
    public void inicio() {
        formateador.setLatitudActual(anyDouble());
        expectLastCall().andAnswer(new IAnswer<Object>() {
            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });
        formateador.setLongitudActual(anyDouble());
        expectLastCall().andAnswer(new IAnswer<Object>() {
            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });
        expect(modelo.getLocalizacion(isA(Hashtable.class))).andReturn(ids).times(3);
        expect(modelo.descargaListadoGasolineras(isA(Hashtable.class))).andReturn(listado);
        expect(ids.get("latitud")).andReturn(0.0);
        expect(ids.get("longitud")).andReturn(0.0);

        formateador.setGasolineras(listado);
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(modelo);
        replay(formateador);
        replay(ids);

        controlador.setModel(modelo);
        controlador.setFormateador(formateador);
        controlador.inicio();

        verify(modelo);
        verify(formateador);
        verify(ids);
    }
}