package com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoRecargas;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoRecargas.InterfaceMMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoRecargas.ModeloMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoRecargas.InterfaceFMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoRecargas.FormateadorMostrarListadoRecargas;

import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.List;

import static org.easymock.EasyMock.createControl;
import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorMostrarListadoRecargasTest {

    @Mock
    private InterfaceFMostrarListadoRecargas formateador;
    private ControladorMostrarListadoRecargas controlador;
    @Mock
    private InterfaceMMostrarListadoRecargas modelo;
    @Mock
    private List<DTORecarga> recargas;

    @Before
    public void setUp(){
        formateador =createMock(FormateadorMostrarListadoRecargas.class);
        modelo=createMock(ModeloMostrarListadoRecargas.class);
        controlador = new ControladorMostrarListadoRecargas(formateador);
        recargas=createMock(List.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }

    @Test
    public void setViewCorrect(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }

    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModel(null);
    }

    @Test
    public void setModeloCorrect(){
        controlador.setModel(modelo);
        assertNotNull(controlador.getModel());
    }

    @Test(expected = IllegalArgumentException.class)
    public void setComienzoCUNull(){
        controlador.comienzoCU(null);
    }

    @Test
    public void setComienzoCUNotNull(){
        controlador.setFormateador(formateador);
        controlador.setModel(modelo);
        formateador.setListado(recargas);
        expectLastCall().andAnswer(new IAnswer<Object>() {
            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });
        expect(modelo.getListadoRecargas("")).andReturn(recargas);
        replay(modelo);

        controlador.comienzoCU("");
        verify(modelo);

    }
}