package com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoVehiculos;

import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos.InterfaceFMostrarListado;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoVehiculos.InterfaceMMostrarListado;
import com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoVehiculos.ModeloMostrarListadoVehiculos;
import com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos.FormateadorMostrarListadoVehiculos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ControladorMostrarListadoVehiculosTest {

    private ControladorMostrarListadoVehiculos controlador;
    @Mock
    private InterfaceFMostrarListado formateador;
    @Mock
    private InterfaceMMostrarListado modelo;



    @Before
    public  void setUp(){
        formateador =createMock(FormateadorMostrarListadoVehiculos.class);
        modelo=createMock(ModeloMostrarListadoVehiculos.class);
        controlador =new ControladorMostrarListadoVehiculos(formateador);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setViewNull(){
        controlador.setFormateador(null);
    }
    @Test
    public void setViewCorrect(){
        controlador.setFormateador(formateador);
        assertNotNull(controlador.getFormateador());
    }
    @Test(expected = IllegalArgumentException.class)
    public void setModeloNull(){
        controlador.setModelo(null);
    }
    @Test
    public void setModeloCorrect(){
        controlador.setModelo(modelo);
        assertNotNull(controlador.getModel());
    }

    @Test
    public void setIdsSinVehiculos(){

        expect(modelo.getListadoIdVehiculos()).andReturn(null);
        replay(modelo);
        controlador.setFormateador(formateador);
        controlador.setModelo(modelo);
        controlador.getListadoVehiculos();
        verify(modelo);
    }
}