package com.example.juanalonsoastruga.cargascontrol.Formateador.CUBorrarVehiculo;

import com.example.juanalonsoastruga.cargascontrol.Controlador.CUBorrarVehiculo.InterfaceCBorradoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUBorrarVehiculo.ControladorBorradoVehiculo;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorBorradoVehiculoTest {

    private FormateadorBorradoVehiculo formateador;
    @Mock
    private InterfaceCBorradoVehiculo controlador;
    @Before
    public void setUp(){
        formateador =new FormateadorBorradoVehiculo();
        controlador =createMock(ControladorBorradoVehiculo.class);
    }
    @Test(expected = IllegalArgumentException.class)
    public void setPresenterNull(){
        formateador.setControlador(null);

    }
    @Test
    public void setPresenterNotNull(){
        formateador.setControlador(controlador);

        assertNotNull(formateador.getControlador());
    }
    @Test
    public void getConfirmacionBorradoAntesBorrado(){

        assertFalse(formateador.getConfirmacionBorrado());
    }
    @Test
    public void getConfirmacionBorradoDespuesBorrado(){
        formateador.muestraDialogoConfirmacionBorrado();
        assertTrue(formateador.getConfirmacionBorrado());
    }
    @Test(expected = IllegalArgumentException.class)
    public void setMatriculaNull(){
        formateador.setMatricula(null);
    }

    @Test
    public void setMatriculaNoNull(){
        formateador.setMatricula("123");
        assertEquals("123", formateador.getMatricula());
    }
    @Test
    public void setBorrado(){
        formateador.eliminaAccionBorrado();
        assertNull(formateador.getMatricula());
    }
    @Test
    public void confirmarBorrado(){
        expect(controlador.borradoConfirmado("")).andReturn(true);
        replay(controlador);
        formateador.setControlador(controlador);
        formateador.setMatricula("");
        formateador.confirmarBorrado();
        verify(controlador);
    }

}