package com.example.juanalonsoastruga.cargascontrol.Formateador.CUCalcularCosteTrayecto;

import com.example.juanalonsoastruga.cargascontrol.Controlador.CUCalcularCosteTrayecto.ControladorCalcularCosteTrayecto;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUCalcularCosteTrayecto.InterfaceCCalcularCosteTrayecto;

import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorCalcularCosteTrayectoTest {

    private FormateadorCalcularCosteTrayecto formateador;

    @Mock
    private InterfaceCCalcularCosteTrayecto controlador;

    @Before
    public void setUp(){
        controlador= createMock(ControladorCalcularCosteTrayecto.class);
        formateador= new FormateadorCalcularCosteTrayecto();
    }

    @Test
    public void setControlador() {
        formateador.setControlador(controlador);
        assertEquals(controlador,formateador.getControlador());
    }

    @Test (expected = IllegalArgumentException.class)
    public void setControladorNull() {
        formateador.setControlador(null);
    }

    @Test
    public void solicitudCalculo() {
        controlador.solicitarCalculo(isA(String.class),isA(String.class),isA(String.class));
        expectLastCall().andAnswer(new IAnswer<Object>() {
            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });


        replay(controlador);
        formateador.setControlador(controlador);
        formateador.solicitudCalculo("","","");

        verify(controlador);
    }



    @Test
    public void setMensajeError() {
        formateador.setMensajeError("");
        assertEquals("",formateador.getMensajeError());
    }



    @Test
    public void setResultado() {
        formateador.setResultado(0.0);
        assertEquals("0",formateador.getResultado());
    }
}