package com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarPosicionMapa;

import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarPosicionMapa.ControladorConsultarPosicionMapa;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarPosicionMapa.InterfaceCConsultarPosicionMapa;

import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorConsultarPosicionMapaTest {

    private FormateadorConsultarPosicionMapa formateador;
    @Mock
    private InterfaceCConsultarPosicionMapa control;
    @Before
    public void setUp(){
        formateador = new FormateadorConsultarPosicionMapa();
        control = createMock(ControladorConsultarPosicionMapa.class);
    }


    @Test
    public void setControlador() {
        formateador.setControlador(control);
        assertEquals(control,formateador.getControlador());
    }

    @Test(expected = IllegalArgumentException.class)
    public void setControladorNull() {
        formateador.setControlador(null);
    }

    @Test
    public void setLatitud() {
        formateador.setLatitud(0);
        assertEquals(0.0,formateador.getLatitudActual(),0);
    }

    @Test
    public void setLongitud() {
        formateador.setLongitud(0);
        assertEquals(0.0,formateador.getLongitudActual(),0);
    }

    @Test
    public void solicitarActualizacionMapa() {
        control.solicitarActualizacion();
        expectLastCall().andAnswer(new IAnswer<Object>() {
            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });
        replay(control);

        formateador.setControlador(control);
        formateador.solicitarActualizacionMapa();

        verify(control);
    }



}