package com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimaRecarga;

import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimaRecarga.ControladorConsultarUltimaRecarga;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimaRecarga.InterfaceCConsultarUltimaRecarga;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorConsultarUltimaRecargaTest {
    @Mock
    private InterfaceCConsultarUltimaRecarga controlador;
    private FormateadorConsultarUltimaRecarga formateador;
    @Mock
    private Hashtable respuesta;
    @Before
    public void setUp(){
        controlador = createMock(ControladorConsultarUltimaRecarga.class);
        formateador = new FormateadorConsultarUltimaRecarga();
        respuesta=createMock(Hashtable.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setPresenterNull(){
        formateador.setControlador(null);

    }
    @Test
    public void setPresenterNotNull(){
        formateador.setControlador(controlador);

        assertNotNull(formateador.getControlador());
    }
    @Test
    public void recuperaIdRecarga(){
        controlador.eventoInicio();
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(controlador);
        formateador.setControlador(controlador);
        formateador.eventoInicio();
        verify(controlador);
    }



    @Test
    public void setId(){
        formateador.setIdRecarga(respuesta);
        assertEquals(formateador.getIdRecarga(),respuesta);
    }
}