package com.example.juanalonsoastruga.cargascontrol.Formateador.CUConsultarUltimoVehiculo;

import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimoVehiculo.ControladorConsultarUltimoVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUConsultarUltimoVehiculo.InterfaceCConsultarUltimoVehiculo;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorConsultarUltimoVehiculoTest {

    private InterfaceCConsultarUltimoVehiculo controlador;
    private FormateadorConsultarUltimoVehiculo formateador;
    @Before
    public void setUp(){
        controlador = createMock(ControladorConsultarUltimoVehiculo.class);
        formateador = new FormateadorConsultarUltimoVehiculo();
    }

    @Test(expected = IllegalArgumentException.class)
    public void setPresenterNull(){
        formateador.setControlador(null);

    }

    @Test
    public void setPresenterNotNull(){
        formateador.setControlador(controlador);
        assertNotNull(formateador.getControlador());
    }


    @Test
    public void recuperaIdVehiculoNull(){
        controlador.eventoInicio();
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(controlador);
        formateador.setControlador(controlador);
        formateador.eventoInicio();
        verify(controlador);
    }

    @Test
    public void setId(){
        formateador.setIdVehiculo("");
        assertEquals(formateador.getIdVehiculo(),"");
    }
}