package com.example.juanalonsoastruga.cargascontrol.Formateador.CUGraficarCosteCombustibleXUnidadRecarga;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoCombustibleVehiculo;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.CodigoPeriocidadGrafica;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUGraficarCosteCombustibleXUnidadRecarga.InterfaceCGraficarCosteCombustibleUnidadRecarga;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUGraficarCosteCombustibleXUnidadRecarga.ControladorGraficarCosteCombustibleUnidadRecarga;

import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorGraficarCosteCombustibleUnidadRecargaTest {
    private FormateadorGraficarCosteCombustibleUnidadRecarga formateador;
    @Mock
    private InterfaceCGraficarCosteCombustibleUnidadRecarga controlador;
    @Mock
    private Hashtable tabla;
    @Before
    public void setUp(){
        formateador = new FormateadorGraficarCosteCombustibleUnidadRecarga();
        controlador =createMock(ControladorGraficarCosteCombustibleUnidadRecarga.class);
        tabla =createMock(Hashtable.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setPresenterNull(){
        formateador.setControlador(null);
    }

    @Test
    public void setPresenterNotNull(){
        formateador.setControlador(controlador);

        assertNotNull(formateador.getControlador());
    }


    @Test
    public void comienzo(){
        controlador.comienzaCU(CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(controlador);
        formateador.setControlador(controlador);
        formateador.comienzaCU("", CodigoCombustibleVehiculo.CPRIM,CodigoPeriocidadGrafica.PERIOCIDAD_GRAFICA2);
        verify(controlador);
        assertEquals(formateador.getCodigoCombustible(),CodigoCombustibleVehiculo.CPRIM);
        assertEquals(formateador.getMatricula(),"");
        
    }



    @Test(expected = IllegalArgumentException.class)
    public void preparaDatosVisualizacionInexistentes(){
        formateador.preparaDatosVisualizacion(null,0);
    }
    @Test
    public void preparaDatosVisualizacionExistentes(){
        assertNull(formateador.getDataSet());
        expect(tabla.size()).andReturn(0);
        replay(tabla);
        formateador.preparaDatosVisualizacion(tabla, tabla.size());
        assertNotNull(formateador.getDataSet());
        verify(tabla);
    }
    @Test
    public void getNullDataSet(){
        assertNull(formateador.getDataSet());
    }


}