package com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoGasolineras;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoGasolineras.ControladorMostrarListadoGasolineras;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoGasolineras.InterfaceCMostrarListadoGasolineras;

import org.easymock.IAnswer;
import org.junit.Before;
import org.junit.Test;

import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorMostrarListadoGasolinerasTest {

    private FormateadorMostrarListadoGasolineras formateador;
    private InterfaceCMostrarListadoGasolineras controlador;
    private List<DTOGasolinera> gasolineras;
    private  DTOGasolinera   gasolinera;
    @Before
    public void setUp(){
        formateador = new FormateadorMostrarListadoGasolineras();
        controlador = createMock(ControladorMostrarListadoGasolineras.class);
        gasolineras= createMock(List.class);
        gasolinera= createMock(DTOGasolinera.class);
    }


    @Test(expected= IllegalArgumentException.class)
    public void setPresenterNull() {
        formateador.setControlador(null);
    }

    @Test
    public void setPresenterNotNull(){
        formateador.setControlador(controlador);
        assertNotNull(formateador.getControlador());
    }

    @Test
    public void setLatitudActual(){
        formateador.setLatitudActual(0.0);
        assertEquals(formateador.getLatitudActual(),"0.0");
    }

    @Test
    public void setLongitudActual(){
        formateador.setLongitudActual(0.0);
        assertEquals(formateador.getLongitudActual(),"0.0");
    }


    @Test
    public void init() {
        controlador.inicio();
        expectLastCall().andAnswer(new IAnswer<Object>() {
            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });
        replay(controlador);
        formateador.setControlador(controlador);
        formateador.init();
        verify(controlador);
    }

    @Test
    public void getListadoEstacionesNull() {
        assertNull(formateador.getListadoEstaciones());
    }

    @Test(expected = IllegalArgumentException.class)
    public void setGasolinerasNull() {
        formateador.setGasolineras(null);
    }

    @Test
    public void setGasolinerasNotNullGasolineras0() {
        expect(gasolineras.size()).andReturn(0);
        replay(gasolineras);
        formateador.setGasolineras(gasolineras);

        verify(gasolineras);
    }
    @Test
    public void setGasolinerasNotNullGasolinerasNot0() {
        expect(gasolineras.size()).andReturn(1).times(2);
        expect(gasolinera.getRotulo()).andReturn("");
        expect(gasolinera.getKm()).andReturn(0.0);
        expect(gasolinera.getDireccion()).andReturn("");
        expect(gasolinera.getLocalidad()).andReturn("");
        expect(gasolinera.getLatitud()).andReturn(0.0);
        expect(gasolinera.getLongitud()).andReturn(0.0);
        expect(gasolineras.get(0)).andReturn(gasolinera);
        replay(gasolineras);
        replay(gasolinera);

        formateador.setGasolineras(gasolineras);

        verify(gasolineras);
        verify(gasolinera);
    }
}