package com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoRecargas;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoRecargas.InterfaceCMostrarListadoRecargas;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoRecargas.ControladorMostrarListadoRecargas;

import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Date;
import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class FormateadorMostrarListadoRecargasTest {

    @Mock
    private InterfaceCMostrarListadoRecargas controlador;
    @Mock
    private List<DTORecarga> recargas;
    @Mock
    private DTORecarga recarga;

    private FormateadorMostrarListadoRecargas formateador;

    @Before
    public void setUp(){
        controlador =createMock(ControladorMostrarListadoRecargas.class);
        formateador =new FormateadorMostrarListadoRecargas();
        recargas=createMock(List.class);
        recarga=createMock(DTORecarga.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setPresenterNull(){
        formateador.setControlador(null);
    }

    @Test
    public void setPresenterNotNull(){
        formateador.setControlador(controlador);

        assertNotNull(formateador.getControlador());
    }
    @Test(expected = IllegalArgumentException.class)
    public void initConMatriculaNull(){
        formateador.init(null);
    }

    @Test
    public void initConMatriculaNoNull(){
        formateador.setControlador(controlador);
        controlador.comienzoCU("");
        expectLastCall().andAnswer(new IAnswer<Object>() {

            @Override
            public Object answer() throws Throwable {
                return null;
            }
        });
        replay(controlador);
        formateador.init("");
        verify(controlador);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setListadoNull(){
        formateador.setListado(null);
    }

    @Test
    public void setListadoNoNullVacio(){
        assertNull(formateador.getDatosVista());
        expect(recargas.size()).andReturn(0);
        replay(recargas);
        formateador.setListado(recargas);
        verify(recargas);
        assertNotNull(formateador.getDatosVista());
    }
    @Test
    public void setListadoNoNullNoVacio(){
        assertNull(formateador.getDatosVista());
        expect(recargas.size()).andReturn(1).times(2);
        expect(recargas.get(0)).andReturn(recarga);
        expect(recarga.getCoste()).andReturn(0.0);
        expect(recarga.getFecha()).andReturn(new Date());
        expect(recarga.getCombustible()).andReturn("");
        replay(recargas);
        replay(recarga);
        formateador.setListado(recargas);
        verify(recargas);
        verify(recarga);
        assertNotNull(formateador.getDatosVista());
    }
}