package com.example.juanalonsoastruga.cargascontrol.Formateador.CUMostrarListadoVehiculos;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoVehiculos.InterfaceCMostrarListado;
import com.example.juanalonsoastruga.cargascontrol.Controlador.CUMostrarListadoVehiculos.ControladorMostrarListadoVehiculos;


import org.easymock.EasyMock;
import org.easymock.IAnswer;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;


import java.util.ArrayList;


public class FormateadorMostrarListadoVehiculosTest {


    private FormateadorMostrarListadoVehiculos formateador;

    @Mock
    private InterfaceCMostrarListado controlador;

    @Before
    public  void setUp(){
         formateador = new FormateadorMostrarListadoVehiculos();
         controlador =createMock(ControladorMostrarListadoVehiculos.class);
    }

    @Test
    public void init(){
        controlador.inicio();
        EasyMock.expectLastCall().andAnswer(new IAnswer() {
            public Object answer() {
                return null;
            }
        });
        replay(controlador);
        formateador.setControler(controlador);
        formateador.init();
        verify(controlador);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setPresenterNull(){
        formateador.setControler(null);

    }
    @Test
    public void setPresenterNotNull(){
        formateador.setControler(controlador);

        assertNotNull(formateador.getControler());
    }

    @Test
    public void setIdsvehiculosNulo(){
        formateador.setIdsvehiculos(null);
        assertNotNull(formateador.getListadoIds());
    }

    @Test
    public void setIdsvehiculosCero(){
        formateador.setIdsvehiculos(new ArrayList<DTOVehiculo>(0));
        assertNotNull(formateador.getListadoIds());
        assertEquals(0, formateador.getListadoIds().size());
    }

    @Test
    public void setIdsvehiculosCantidadCualquiera(){
        ArrayList<DTOVehiculo> l= new ArrayList<DTOVehiculo>(2);
        l.add(new DTOVehiculo());
        l.add(new DTOVehiculo());
        formateador.setIdsvehiculos(l);

        assertNotNull(formateador.getListadoIds());
        assertEquals(2, formateador.getListadoIds().size());
    }



}