package com.example.juanalonsoastruga.cargascontrol.Modelo.CUBorrarVehiculo;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;

import org.easymock.EasyMock;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloBorrarVehiculoTest {
    @Mock
    private InterfaceFachadaDatos d;

    private ModeloBorrarVehiculo modelo;
    @Before
    public  void setUp(){
        modelo=new ModeloBorrarVehiculo();
        d=createMock(FachadaDatos.instancia().getClass());
    }

    @Test
    public void setRepoNull(){

        modelo.setRepo(null);
        assertNotNull(modelo.getRepo());
    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(d);
        assertNotNull(modelo.getRepo());
    }

    @Test(expected=NullPointerException.class)
    public void borrarVehiculoNull(){
        expect(d.borradoVehiculo(null)).andThrow(new NullPointerException());
        replay(d);
        modelo.setRepo(d);
        modelo.borrarVehiculo(null);
        verify(d);
    }
    @Test
    public void borrarVehiculoNoNull(){
        expect(d.borradoVehiculo("")).andReturn(true);
        replay(d);
        modelo.setRepo(d);
        modelo.borrarVehiculo("");
        verify(d);
    }
}