package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarEstadisticaCostesCombustible;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTODatosDerivadosCostesCombustible;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloConsultarEstadisticaCosteCombustibleTest {
    private ModeloConsultarEstadisticaCosteCombustible modelo;
    @Mock
    private InterfaceFachadaDatos d;
    @Mock
    private DTOVehiculo dtoVehiculo;
    @Mock
    private DTODatosDerivadosCostesCombustible dtoDatosDerivadosCombustible;
    @Before
    public  void setUp(){
        modelo=new ModeloConsultarEstadisticaCosteCombustible();
        d=createMock(FachadaDatos.instancia().getClass());
        dtoVehiculo=createMock(DTOVehiculo.class);
        dtoDatosDerivadosCombustible=createMock(DTODatosDerivadosCostesCombustible.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){

        modelo.setRepo(null);

    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(d);
        assertNotNull(modelo.getDatos());
    }

    @Test
    public void getVehiculo(){
        expect(d.getVehiculo(isA(String.class))).andReturn(dtoVehiculo);
        replay(d);
        modelo.setRepo(d);
        modelo.getVehiculo("");
        verify(d);
    }

    @Test
    public void getDatosDerivadosCombustible(){
        expect(d.getDDerivadosCosteCombustible("",0,0,"")).andReturn(dtoDatosDerivadosCombustible);
        replay(d);
        modelo.setRepo(d);
        modelo.getDatosDerivadosCostesCombustible("",0,0,"");
        verify(d);
    }

}