package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarEstadisticaVehiculo;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTODatosDerivadosVehiculoTotales;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Calendar;

import static org.easymock.EasyMock.anyInt;
import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.expectLastCall;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloConsultarEstadisticaVehiculoTest {

    private ModeloConsultarEstadisticaVehiculo modelo;
    @Mock
    private InterfaceFachadaDatos datos;
    @Mock
    private DTODatosDerivadosVehiculoTotales dto;

    @Before
    public void setUp(){
        datos=createMock(FachadaDatos.class);
        modelo=new ModeloConsultarEstadisticaVehiculo();
        dto=createMock(DTODatosDerivadosVehiculoTotales.class);
    }


    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){

        modelo.setRepo(null);

    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(datos);

    }

    @Test
    public void getDDerivadosVehiculo(){
        expect(datos.getDDerivadosVehiculo(isA(String.class),anyInt(),anyInt())).andReturn(dto);
        replay(datos);
        modelo.setRepo(datos);
        modelo.obtenDatosEstadisticosVehiculo("");
        verify(datos);
    }


}