package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarInformacionGasolinera;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOGasolinera;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;
import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloConsultarInformacionGasolineraTest {
    @Mock
    private InterfaceFachadaDatos d;

    @Mock
    private DTOGasolinera gasolinera;
    private ModeloConsultarInformacionGasolinera modelo;
    @Before
    public  void setUp(){
        modelo=new ModeloConsultarInformacionGasolinera();
        d=createMock(FachadaDatos.instancia().getClass());
        gasolinera=createMock(DTOGasolinera.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){

        modelo.setRepo(null);

    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(d);
        assertNotNull(modelo.getRepo());
    }

    @Test
    public void getDatosGasolinera(){
        expect(d.getDTOGasolinera(0,0,"")).andReturn(gasolinera);
        replay(d);
        modelo.setRepo(d);
        modelo.getDatosGasolinera(0,0,"");
        verify(d);
    }

}