package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarInformacionRecarga;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Date;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.junit.Assert.*;

public class ModeloConsultarInformacionRecargaTest {

    private ModeloConsultarInformacionRecarga modelo;

    @Mock
    private InterfaceFachadaDatos datos;
    @Mock
    private Date fecha;

    @Before
    public void setUp(){
        datos=createMock(FachadaDatos.class);
        modelo=new ModeloConsultarInformacionRecarga();
        fecha=createMock(Date.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){

        modelo.setRepo(null);

    }



    @Test
    public void setRepoNotNull(){
        modelo.setRepo(datos);
        assertNotNull(modelo.getRepo());
    }

    @Test
    public void getRecargaNoExistente(){
        expect(datos.getRecarga("",fecha,"")).andReturn(null);
        modelo.setRepo(datos);
       assertNull(modelo.getRecarga("",fecha,""));
    }

}