package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarInformacionVehiculo;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;


import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloConsultarInformacionVehiculoTest {

    private ModeloConsultarInformacionVehiculo modelo;
    @Mock
    private InterfaceFachadaDatos d;
    @Mock
    private DTOVehiculo v;
    @Before
    public  void setUp(){
        modelo=new ModeloConsultarInformacionVehiculo();
        v=createMock(DTOVehiculo.class);
        d=createMock(FachadaDatos.instancia().getClass());
    }
    @Test
    public void setRepoNull(){

        modelo.setRepo(null);
        assertNotNull(modelo.getRepo());
    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(d);
        assertNotNull(modelo.getRepo());
    }

    @Test(expected=NullPointerException.class)
    public void consultarVehiculoNull(){
        expect(d.getVehiculo(null)).andThrow(new NullPointerException());
        replay(d);
        modelo.consultarVehiculo(null);
        verify(d);
    }
    @Test(expected=NullPointerException.class)
    public void consultarVehiculoInexistente(){
        expect(d.getVehiculo("")).andThrow(new NullPointerException());
        replay(d);
        modelo.consultarVehiculo("");
        verify(d);
    }

    @Test
    public void consultarVehiculoCorrecto(){
        expect(d.getVehiculo("123")).andReturn(v);
        expect(v.getMatricula()).andReturn("123");
        replay(d);
        replay(v);
        modelo.setRepo(d);
        DTOVehiculo vehiculo=modelo.consultarVehiculo("123");
        assertNotNull(vehiculo);
        assertEquals(vehiculo.getMatricula(),"123");
        verify(d);
        verify(v);
    }
}