package com.example.juanalonsoastruga.cargascontrol.Modelo.CUConsultarPosicionMapa;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;

import static org.easymock.EasyMock.createMock;

import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloConsultarPosicionMapaTest {

    private ModeloConsultarPosicionMapa modelo;
    @Mock
    private InterfaceFachadaDatos d;
    @Mock
    private Hashtable localizacion;


    @Before
    public void setUp(){
        modelo=new ModeloConsultarPosicionMapa();
        d=createMock(FachadaDatos.instancia().getClass());
        localizacion=createMock(Hashtable.class);
    }


    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){

        modelo.setRepo(null);

    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(d);
        assertNotNull(modelo.getDatos());
    }
    @Test
    public void consultarPosicionActual() {
        expect(d.getLocalizacionActual(isA(Hashtable.class))).andReturn(localizacion);
        replay(d);

        modelo.setRepo(d);

        assertEquals( modelo.consultarPosicionActual(),localizacion);

        verify(d);

    }
}