package com.example.juanalonsoastruga.cargascontrol.Modelo.CUGraficarKm;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Date;
import java.util.List;

import static org.easymock.EasyMock.anyString;
import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.isA;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloGraficarKmTest {

    @Mock
    private InterfaceFachadaDatos datos;
    private ModeloGraficarKm model;
    @Mock
    private List<DTORecarga> listado;
    @Mock
    private DTOVehiculo dtoVehiculo;
    @Before
    public void setUp(){
        model=new ModeloGraficarKm();
        datos=createMock(FachadaDatos.class);
        listado=createMock(List.class);
        dtoVehiculo=createMock(DTOVehiculo.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){
        model.setRepo(null);
        assertNotNull(model.getRepo());
    }

    @Test
    public void setRepoNotNull(){
        model.setRepo(datos);
        assertNotNull(model.getRepo());
    }
    @Test
    public void getVehiculo(){
        model.setRepo(datos);
        expect(datos.getVehiculo(isA(String.class))).andReturn(dtoVehiculo);
        replay(datos);
        assertEquals(model.getVehiculo(""),dtoVehiculo);
        verify(datos);
    }


    @Test
    public void getRecargasMensualesCombustible(){
        expect(datos.getRecargasEnPeriodoPorCombustibleyVehiculo(anyString(),anyString(),isA(Date.class),isA(Date.class))).andReturn(listado);
        replay(datos);
        model.setRepo(datos);
        assertEquals(model.getRecargasMensualesCombustible("","",new Date(),new Date()),listado);
        verify(datos);
    }
    @Test
    public void getRecargasAnualesCombustible(){
        expect(datos.getRecargasEnPeriodoPorCombustibleyVehiculo(anyString(),anyString(),isA(Date.class),isA(Date.class))).andReturn(listado);
        replay(datos);
        model.setRepo(datos);
        assertEquals(model.getRecargasAnualesCombustible("","",new Date(),new Date()),listado);
        verify(datos);
    }

}