package com.example.juanalonsoastruga.cargascontrol.Modelo.CUModificarInformacionVehiculo;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOCombustible;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloModificarInformacionVehiculoTest {

    @Mock
    private InterfaceFachadaDatos datos;
    @Mock
    private List<DTOCombustible> combustibles;
    @Mock
    private DTOVehiculo vehiculo;

    private ModeloModificarInformacionVehiculo model;

    @Before
    public void setUp(){
        datos=createMock(FachadaDatos.class);
        model = new ModeloModificarInformacionVehiculo();
        combustibles=createMock(ArrayList.class);
        vehiculo = createMock(DTOVehiculo.class);
    }

    @Test
    public void setRepoNull(){
        model.setRepo(null);
        assertNotNull(model.getRepo());
    }

    @Test
    public void setRepoNotNull(){
        model.setRepo(datos);
        assertNotNull(model.getRepo());
    }

    @Test
    public void getCombustibles(){
        expect(datos.getCombustibles()).andReturn(combustibles);
        replay(datos);
        model.setRepo(datos);
        assertNotNull(model.getCombustibles());
    }

    @Test
    public void getVehiculo(){
        expect(datos.getVehiculo("")).andReturn(vehiculo);
        expect(vehiculo.getMatricula()).andReturn("");
        replay(datos);
        replay(vehiculo);
        model.setRepo(datos);
        DTOVehiculo v=model.getVehiculo("");
        assertNotNull(v);
        assertEquals(v.getMatricula(),"");
        verify(datos);
        verify(vehiculo);
    }

    @Test
    public void actualizaVehiculo(){
        expect(datos.actualizaVehiculo(vehiculo)).andReturn(true);
        replay(datos);
        model.setRepo(datos);
        model.actualizaVehiculo(vehiculo)  ;
        verify(datos);
    }
}