package com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoGasolineras;

import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.Hashtable;
import java.util.List;

 import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
 import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloMostrarListadoGasolinerasTest {
    @Mock
    private InterfaceFachadaDatos d;
    @Mock
    private Hashtable hash;
    @Mock
    private Hashtable hash2;
    @Mock
    private List gasolineras;
    private ModeloMostrarListadoGasolineras modelo;
    @Before
    public  void setUp(){
        modelo=new ModeloMostrarListadoGasolineras();
        d=createMock(FachadaDatos.instancia().getClass());
        hash=createMock(Hashtable.class);
        hash2=createMock(Hashtable.class);
        gasolineras=createMock(List.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){

        modelo.setRepo(null);

    }

    @Test
    public void setRepoNotNull(){

        modelo.setRepo(d);
        assertNotNull(modelo.getRepo());
    }

    @Test
    public void getLocalizacion(){
        expect(hash.size()).andReturn(0);
        expect(hash2.size()).andReturn(2);
        expect(d.getLocalizacionActual(hash)).andReturn(hash2);
        replay(hash);
        replay(hash2);
        replay(d);
        modelo.setRepo(d);
        modelo.getLocalizacion(hash);
        assertNotEquals(hash.size(),hash2.size());
        verify(hash);
        verify(hash2);
        verify(d);
    }

    @Test
    public void descargaListadoGasolineras(){

        expect(d.getEstacionesRecargaNacionales(hash)).andReturn(gasolineras);

        replay(gasolineras);
        replay(d);
        modelo.setRepo(d);
        modelo.descargaListadoGasolineras(hash);


        verify(gasolineras);
        verify(d);
    }

}