package com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoRecargas;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTORecarga;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.createMockBuilder;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloMostrarListadoRecargasTest {

    @Mock
    private InterfaceFachadaDatos datos;
    private ModeloMostrarListadoRecargas model;
    @Mock
    private List<DTORecarga> recargas;
    @Before
    public void setUp(){
        model=new ModeloMostrarListadoRecargas();
        datos=createMock(FachadaDatos.class);
        recargas=createMock(List.class);
    }

    @Test(expected = IllegalArgumentException.class)
    public void setRepoNull(){
        model.setRepo(null);
    }

    @Test
    public void setRepoNotNull(){
        model.setRepo(datos);
        assertNotNull(model.getRepo());
    }

    @Test(expected = IllegalArgumentException.class)
    public void getListadoRecargasNull(){
        model.getListadoRecargas(null);
    }

    @Test
    public void getListadoRecargasNotNull(){
        expect(datos.getListadoRecargas("")).andReturn(recargas);
        replay(datos);
        model.setRepo(datos);

        assertEquals(model.getListadoRecargas(""),recargas);
        verify(datos);
    }
}