package com.example.juanalonsoastruga.cargascontrol.Modelo.CUMostrarListadoVehiculos;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;
import static org.junit.Assert.*;

public class ModeloMostrarListadoVehiculosTest {

    @Mock
    private InterfaceFachadaDatos datos;
    private InterfaceMMostrarListado modelo;
    @Mock
    private List<DTOVehiculo>listado;
    @Before
    public void setUp(){
        datos=createMock(FachadaDatos.class);
        modelo=new ModeloMostrarListadoVehiculos();
        listado=createMock(List.class);
    }
    @Test
    public void setRepoNull(){
        modelo.setRepo(null);
        assertNotNull(modelo.getRepo());
    }
    @Test
    public void setRepoNotNull(){
        modelo.setRepo(datos);
        assertNotNull(modelo.getRepo());
    }


    @Test
    public void getListadoVehiculosNotNull(){
        expect(datos.getIdentificadoresVehiculos()).andReturn(listado);
        replay(datos);
        modelo.setRepo(datos);

        assertEquals(modelo.getListadoIdVehiculos(),listado);
        verify(datos);
    }
}