package com.example.juanalonsoastruga.cargascontrol.Modelo.CURegistrarVehiculo;

import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOCombustible;
import com.example.juanalonsoastruga.cargascontrol.CapaTransversal.DTOVehiculo;
import com.example.juanalonsoastruga.cargascontrol.Datos.FachadaDatos;
import com.example.juanalonsoastruga.cargascontrol.Datos.InterfaceFachadaDatos;

import static org.junit.Assert.*;
import org.easymock.Mock;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

import static org.easymock.EasyMock.createMock;
import static org.easymock.EasyMock.expect;
import static org.easymock.EasyMock.replay;
import static org.easymock.EasyMock.verify;

public class ModeloRegistroVehiculoTest {
    @Mock
    private InterfaceFachadaDatos datos;
    @Mock
    private List<DTOCombustible> combustibles;
    @Mock
    private DTOVehiculo vehiculo;

    private ModeloRegistroVehiculo model;

    @Before
    public void setUp(){
        datos=createMock(FachadaDatos.class);
        model = new ModeloRegistroVehiculo();
        combustibles=createMock(ArrayList.class);
        vehiculo = createMock(DTOVehiculo.class);
    }

    @Test
    public void setRepoNull(){
        model.setRepo(null);
        assertNotNull(model.getRepo());
    }

    @Test
    public void setRepoNotNull(){
        model.setRepo(datos);
        assertNotNull(model.getRepo());
    }

    @Test
    public void getCombustibles(){
        expect(datos.getCombustibles()).andReturn(combustibles);
        replay(datos);
        model.setRepo(datos);
        assertNotNull(model.getCombustibles());
    }

    @Test(expected = IllegalArgumentException.class)
    public void registrarVehiculoNulo(){
        expect(datos.setVehiculo(null)).andThrow(new IllegalArgumentException());
        replay(datos);
         model.setRepo(datos);
         model.registraVehiculo(null);
         verify(datos);
    }

    @Test
    public void registrarVehiculoNoNulo(){
        model.setRepo(datos);
        model.registraVehiculo(vehiculo);
    }
    @Test
    public void registrarVehiculoNoRegistrado() {
        model.setRepo(datos);
        assertFalse(model.isVehiculoRegistrado(vehiculo));
    }

}